# https://remlapmot.github.io/cibookex-r/index.html#downloading-the-datasets

# https://www.hsph.harvard.edu/miguel-hernan/causal-inference-book/

library(devtools)
devtools::install_dev_deps()

setwd("D:/1ASReece/Research/2019 Res/Autism/R Codes")
getwd()

library(here)
library(geepack)
library(tidyverse)
library(ipw)

# install.packages(c("tidyverse", "tidyr", "purrr", "broom", "sp", "sf", "spdep", "splm", "ipw", "drtmle", "splines", 
#                    "stats", "nlme", "AER", "ggpubr", "geepack", "psych", "here", "rgdal", "rgeos", "reshape2",
#                    "rlang", "viridis", "RColorBrewer", "albersusa", "corrr", "geofacet", "EValue",
#                    "tidycensus", "tigris", "plm", "spatialreg", "corrgram", "ggrepel", "scales",
#                    "areal", "forcats", "lattice", "latticeExtra", "graphics", "grid", "lwgeom"))
# install.packages("ellipsis")
# install.packages("backports")
# install.packages("multicore")
# install.packages(c("survival", "survey"))
library(multicore)
library(backports)
library(ellipsis)
library(tidyverse)
library(survival)
library(survey)
library(drtmle)
library(geepack)
library(tidyr)
library(dplyr)
library(readr)
library(ipw)
library(nlme)
library(plm)
library(EValue)

# install.packages(c("cobalt", "WeightIt"))
library(WeightIt)
library(cobalt)
library(quantreg)



options(warn=-1)

ASDKLTabab2AdfaRrdf       <- read.csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2AdfaRrdf.csv",
                                      header=TRUE, stringsAsFactors = FALSE, as.is=T)
ASDRawB5na                <- read.csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDRawB5na.csv",
                                      header=TRUE, stringsAsFactors = FALSE, as.is=T)

####
#### MAKE SURE YOU WORK w DATAFRAMES!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
####

ASDRaw                    <- read_csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDRaw_6.csv")
ASDKLTaba                 <- read_csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTaba.csv")
ASDRawB5na                <- read_csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDRawB5na.csv")
ASDKLTabab2Adf            <- read_csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2Adf.csv")
ASDKLTabab2Adfa           <- read_csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2Adfa.csv")
ASDKLTabab2AdfaRr         <- read_csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2AdfaRr.csv")
ASDKLTabab2AdfaRr_        <- read_csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2AdfaRr_.csv")
ASDKLTabab2AdfaRr_s       <- read_csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2AdfaRr_s.csv")
ASDKLTabab2AdfaRrdf       <- read.csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2AdfaRrdf.csv",
                                      header=TRUE, stringsAsFactors = FALSE, as.is=T)

####
#### MAKE SURE YOU WORK w DATAFRAMES!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
####

# write_csv(ASDKLTabab2AdfaRrdf, "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2AdfaRrdf.csv")

dataurls <- list()
dataurls[[1]] <- "https://cdn1.sph.harvard.edu/wp-content/uploads/sites/1268/2012/10/nhefs_sas.zip"
dataurls[[2]] <- "https://cdn1.sph.harvard.edu/wp-content/uploads/sites/1268/2012/10/nhefs_stata.zip"
dataurls[[3]] <- "https://cdn1.sph.harvard.edu/wp-content/uploads/sites/1268/2017/01/nhefs_excel.zip"
dataurls[[4]] <- "https://cdn1.sph.harvard.edu/wp-content/uploads/sites/1268/1268/20/nhefs.csv"

temp <- tempfile()
for (i in 1:3) {
  download.file(dataurls[[i]], temp)
  unzip(temp, exdir = "data")
}

download.file(dataurls[[4]], here("data", "nhefs.csv"))

library("readxl")

nhefs <- read_excel(here("data", "NHEFS.xls"))
nhefs$cens <- ifelse(is.na(nhefs$wt82), 1, 0)

# provisionally ignore subjects with missing values for weight in 1982
nhefs.nmv <-
  nhefs[which(!is.na(nhefs$wt82)),] 

lm(wt82_71 ~ qsmk, data = nhefs.nmv)



###### CreateTableOne HelpPage in R
## Make categorical variables factors
varsToFactor <- c("status","trt","ascites","hepato","spiders","edema","stage")
pbc[varsToFactor] <- lapply(pbc[varsToFactor], factor)




# https://www.coursera.org/lecture/crash-course-in-causality/data-example-in-r-Ie48W
# https://remlapmot.github.io/cibookex-r/ip-weighting-and-marginal-structural-models.html

# Smoking cessation
predict(lm(wt82_71 ~ qsmk, data = nhefs.nmv), data.frame(qsmk = 1))
##        1 
## 4.525079

predict(lm(wt82_71 ~ qsmk, data = nhefs.nmv), data.frame(qsmk = 0)) 
summary(nhefs.nmv[which(nhefs.nmv$qsmk == 0),]$age)
summary(nhefs.nmv[which(nhefs.nmv$qsmk == 0),]$wt71)
summary(nhefs.nmv[which(nhefs.nmv$qsmk == 0),]$smokeintensity)
summary(nhefs.nmv[which(nhefs.nmv$qsmk == 0),]$smokeyrs)
summary(nhefs.nmv[which(nhefs.nmv$qsmk == 1),]$age)
summary(nhefs.nmv[which(nhefs.nmv$qsmk == 1),]$wt71)
summary(nhefs.nmv[which(nhefs.nmv$qsmk == 1),]$smokeintensity)
summary(nhefs.nmv[which(nhefs.nmv$qsmk == 1),]$smokeyrs)
table(nhefs.nmv$qsmk, nhefs.nmv$sex)
prop.table(table(nhefs.nmv$qsmk, nhefs.nmv$sex), 1)
table(nhefs.nmv$qsmk, nhefs.nmv$race)
prop.table(table(nhefs.nmv$qsmk, nhefs.nmv$race), 1)
table(nhefs.nmv$qsmk, nhefs.nmv$education)
prop.table(table(nhefs.nmv$qsmk, nhefs.nmv$education), 1)
table(nhefs.nmv$qsmk, nhefs.nmv$exercise)
prop.table(table(nhefs.nmv$qsmk, nhefs.nmv$exercise), 2)
prop.table(table(nhefs.nmv$qsmk, nhefs.nmv$exercise))
table(nhefs.nmv$qsmk, nhefs.nmv$active)
prop.table(table(nhefs.nmv$qsmk, nhefs.nmv$active), 1)


# https://remlapmot.github.io/cibookex-r/ip-weighting-and-marginal-structural-models.html#program-12.1
# Estimation of ip weights via a logistic model

fit <- glm(
  qsmk ~ sex + race + age + I(age ^ 2) +
    as.factor(education) + smokeintensity +
    I(smokeintensity ^ 2) + smokeyrs + I(smokeyrs ^ 2) +
    as.factor(exercise) + as.factor(active) + wt71 + I(wt71 ^ 2),
  family = binomial(),
  data = nhefs.nmv
)
summary(fit)

p.qsmk.obs <-
  ifelse(nhefs.nmv$qsmk == 0,
         1 - predict(fit, type = "response"),
         predict(fit, type = "response"))

nhefs.nmv$w <- 1 / p.qsmk.obs
summary(nhefs.nmv$w)
sd(nhefs.nmv$w)


# install.packages("geepack") # install package if required
library("geepack")
msm.w <- geeglm(
  wt82_71 ~ qsmk,
  data = nhefs.nmv,
  weights = w,
  id = seqn,
  corstr = "independence"
)
summary(msm.w)

beta <- coef(msm.w)
SE <- coef(summary(msm.w))[, 2]
lcl <- beta - qnorm(0.975) * SE
ucl <- beta + qnorm(0.975) * SE
cbind(beta, lcl, ucl)

xtabs(nhefs.nmv$w ~ nhefs.nmv$sex + nhefs.nmv$qsmk)
table(nhefs.nmv$age[nhefs.nmv$race == 0 & nhefs.nmv$sex == 1],
      nhefs.nmv$qsmk[nhefs.nmv$race == 0 & nhefs.nmv$sex == 1])

# estimation of denominator of ip weights
denom.fit <-
  glm(
    qsmk ~ as.factor(sex) + as.factor(race) + age + I(age ^ 2) +
      as.factor(education) + smokeintensity +
      I(smokeintensity ^ 2) + smokeyrs + I(smokeyrs ^ 2) +
      as.factor(exercise) + as.factor(active) + wt71 + I(wt71 ^ 2),
    family = binomial(),
    data = nhefs.nmv
  )
summary(denom.fit)

pd.qsmk <- predict(denom.fit, type = "response")

numer.fit <- glm(qsmk ~ 1, family = binomial(), data = nhefs.nmv)
summary(numer.fit)

pn.qsmk <- predict(numer.fit, type = "response")

nhefs.nmv$sw <-
  ifelse(nhefs.nmv$qsmk == 0, ((1 - pn.qsmk) / (1 - pd.qsmk)),
         (pn.qsmk / pd.qsmk))

summary(nhefs.nmv$sw)

msm.sw <- geeglm(
  wt82_71 ~ qsmk,
  data = nhefs.nmv,
  weights = sw,
  id = seqn,
  corstr = "independence"
)
summary(msm.sw)

beta <- coef(msm.sw)
SE <- coef(summary(msm.sw))[, 2]
lcl <- beta - qnorm(0.975) * SE
ucl <- beta + qnorm(0.975) * SE
cbind(beta, lcl, ucl)

xtabs(nhefs.nmv$sw ~ nhefs.nmv$sex + nhefs.nmv$qsmk)


#####################################################################################################################
#####################################################################################################################
############## https://remlapmot.github.io/cibookex-r/ip-weighting-and-marginal-structural-models.html#program-12.1
###### Program 12.4
###### Estimating the parameters of a marginal structural mean model with a continuous treatment Data from NHEFS
# Analysis restricted to subjects reporting <=25 cig/day at baseline
nhefs.nmv.s <- subset(nhefs.nmv, smokeintensity <= 25)

# estimation of denominator of ip weights
den.fit.obj <- lm(
  smkintensity82_71 ~ as.factor(sex) +
    as.factor(race) + age + I(age ^ 2) +
    as.factor(education) + smokeintensity + I(smokeintensity ^ 2) +
    smokeyrs + I(smokeyrs ^ 2) + as.factor(exercise) + as.factor(active) + wt71 +
    I(wt71 ^ 2),
  data = nhefs.nmv.s
)

p.den <- predict(den.fit.obj, type = "response")
dens.den <-
  dnorm(nhefs.nmv.s$smkintensity82_71,
        p.den,
        summary(den.fit.obj)$sigma)

# estimation of numerator of ip weights
num.fit.obj <- lm(smkintensity82_71 ~ 1, data = nhefs.nmv.s)
p.num <- predict(num.fit.obj, type = "response")
dens.num <-
  dnorm(nhefs.nmv.s$smkintensity82_71,
        p.num,
        summary(num.fit.obj)$sigma)

nhefs.nmv.s$sw.a <- dens.num / dens.den
summary(nhefs.nmv.s$sw.a)

msm.sw.cont <-
  geeglm(
    wt82_71 ~ smkintensity82_71 + I(smkintensity82_71 * smkintensity82_71),
    data = nhefs.nmv.s,
    weights = sw.a,
    id = seqn,
    corstr = "independence"
  )
summary(msm.sw.cont)

beta <- coef(msm.sw.cont)
SE <- coef(summary(msm.sw.cont))[, 2]
lcl <- beta - qnorm(0.975) * SE
ucl <- beta + qnorm(0.975) * SE
cbind(beta, lcl, ucl)

lcl2 <- beta - 1.96 * SE
ucl2 <- beta + 1.96 * SE
Res2 <- cbind(beta, lcl2, ucl2)
Res2



# Program 12.5
# Estimating the parameters of a marginal structural logistic model
# Data from NHEFS

table(nhefs.nmv$qsmk, nhefs.nmv$death)

# First, estimation of stabilized weights sw (same as in Program 12.3)
# Second, fit logistic model below
msm.logistic <- geeglm(
  death ~ qsmk,
  data = nhefs.nmv,
  weights = sw,
  id = seqn,
  family = binomial(),
  corstr = "independence"
)

summary(msm.logistic)

beta <- coef(msm.logistic)
SE <- coef(summary(msm.logistic))[, 2]
lcl <- beta - qnorm(0.975) * SE
ucl <- beta + qnorm(0.975) * SE
cbind(beta, lcl, ucl)

table(nhefs.nmv$sex)

denom.fit <-
  glm(
    qsmk ~ as.factor(sex) + as.factor(race) + age + I(age ^ 2) +
      as.factor(education) + smokeintensity +
      I(smokeintensity ^ 2) + smokeyrs + I(smokeyrs ^ 2) +
      as.factor(exercise) + as.factor(active) + wt71 + I(wt71 ^ 2),
    family = binomial(),
    data = nhefs.nmv
  )
summary(denom.fit)

pd.qsmk <- predict(denom.fit, type = "response")

numer.fit <-
  glm(qsmk ~ as.factor(sex), family = binomial(), data = nhefs.nmv)
summary(numer.fit)

pn.qsmk <- predict(numer.fit, type = "response")

nhefs.nmv$sw.a <-
  ifelse(nhefs.nmv$qsmk == 0, ((1 - pn.qsmk) / (1 - pd.qsmk)),
         (pn.qsmk / pd.qsmk))

summary(nhefs.nmv$sw.a)

sd(nhefs.nmv$sw.a)

msm.emm <- geeglm(
  wt82_71 ~ as.factor(qsmk) + as.factor(sex)
  + as.factor(qsmk):as.factor(sex),
  data = nhefs.nmv,
  weights = sw.a,
  id = seqn,
  corstr = "independence"
)
summary(msm.emm)


msm.emm <- geeglm(
  wt82_71 ~ as.factor(qsmk) * as.factor(sex),
  data = nhefs.nmv,
  weights = sw.a,
  id = seqn,
  corstr = "independence"
)
summary(msm.emm)

beta <- coef(msm.emm)
SE <- coef(summary(msm.emm))[, 2]
lcl <- beta - qnorm(0.975) * SE
ucl <- beta + qnorm(0.975) * SE
cbind(beta, lcl, ucl)



# https://remlapmot.github.io/cibookex-r/outcome-regression-and-propensity-scores.html
# 15. Outcome regression and propensity scores
# Program 15.1
# Estimating the average causal effect within levels of confounders under the assumption of effect-measure modification by smoking intensity ONLY
# Data from NHEFS
# library(here)

nhefs <- read_excel(here("data", "NHEFS.xls"))
nhefs$cens <- ifelse(is.na(nhefs$wt82), 1, 0)

# regression on covariates, allowing for some effect modification
fit <- glm(wt82_71 ~ qsmk + sex + race + age + I(age*age) + as.factor(education)
           + smokeintensity + I(smokeintensity*smokeintensity) + smokeyrs
           + I(smokeyrs*smokeyrs) + as.factor(exercise) + as.factor(active)
           + wt71 + I(wt71*wt71) + I(qsmk*smokeintensity), data=nhefs)
summary(fit)
install.packages("multcomp") # install packages if necessary
library("multcomp")

makeContrastMatrix <- function(model, nrow, names) {
  m <- matrix(0, nrow = nrow, ncol = length(coef(model)))
  colnames(m) <- names(coef(model))
  rownames(m) <- names
  return(m)
}
K1 <- makeContrastMatrix(fit, 2, c('Effect of Quitting Smoking at Smokeintensity of 5',
                                   'Effect of Quitting Smoking at Smokeintensity of 40'))
# (step 2) fill in the relevant non-zero elements 
K1[1:2, 'qsmk'] <- 1
K1[1:2, 'I(qsmk * smokeintensity)'] <- c(5, 40)

# (step 3) check the contrast matrix
K1 

estimates1 <- glht(fit, K1)
summary(estimates1)

confint(estimates1)

fit2 <- glm(wt82_71 ~ qsmk + sex + race + age + I(age*age) + as.factor(education)
            + smokeintensity + I(smokeintensity*smokeintensity) + smokeyrs
            + I(smokeyrs*smokeyrs) + as.factor(exercise) + as.factor(active)
            + wt71 + I(wt71*wt71), data=nhefs)

summary(fit2)


# Program 15.2
# Estimating and plotting the propensity score
# Data from NHEFS
fit3 <- glm(qsmk ~ sex + race + age + I(age*age) + as.factor(education)
            + smokeintensity + I(smokeintensity*smokeintensity) + smokeyrs
            + I(smokeyrs*smokeyrs) + as.factor(exercise) + as.factor(active)
            + wt71 + I(wt71*wt71), data=nhefs, family=binomial())
summary(fit3)

nhefs$ps <- predict(fit3, nhefs, type="response")
summary(nhefs$ps[nhefs$qsmk==0])
summary(nhefs$ps[nhefs$qsmk==1])
fivenum(nhefs$ps[nhefs$qsmk==1])

library("ggplot2")
library("dplyr")

ggplot(nhefs, aes(x = ps, fill = qsmk)) + geom_density(alpha = 0.2) +
  xlab('Probability of Quitting Smoking During Follow-up') +
  ggtitle('Propensity Score Distribution by Treatment Group') +
  scale_fill_discrete('') +
  theme(legend.position = 'bottom', legend.direction = 'vertical')

# alternative plot with histograms
nhefs <- nhefs %>% mutate(qsmklabel = ifelse(qsmk == 1,
                                             yes = 'Quit Smoking 1971-1982',
                                             no = 'Did Not Quit Smoking 1971-1982'))

ggplot(nhefs, aes(x = ps, fill = as.factor(qsmk), color = as.factor(qsmk))) +
  geom_histogram(alpha = 0.3, position = 'identity', bins=15) +
  facet_grid(as.factor(qsmk) ~ .) +
  xlab('Probability of Quitting Smoking During Follow-up') +
  ggtitle('Propensity Score Distribution by Treatment Group') +
  scale_fill_discrete('') +
  scale_color_discrete('') +
  theme(legend.position = 'bottom', legend.direction = 'vertical')

# attempt to reproduce plot from the book
nhefs %>%
  mutate(ps.grp = round(ps/0.05) * 0.05) %>%
  group_by(qsmk, ps.grp) %>%
  summarize(n = n()) %>%
  ungroup() %>%
  mutate(n2 = ifelse(qsmk == 0, yes = n, no =  -1*n)) %>%
  ggplot(aes(x = ps.grp, y = n2, fill = as.factor(qsmk), colour = as.factor(qsmk))) +
  geom_bar(stat = 'identity', position = 'identity', alpha=0.5) +
  geom_text(aes(label = n, x = ps.grp, y = n2 + ifelse(qsmk == 0, 8, -8))) +
  xlab('Probability of Quitting Smoking During Follow-up') +
  ylab('N') +
  ggtitle('Propensity Score Distribution by Treatment Group') +
  scale_fill_discrete('') +   scale_colour_discrete('') +
  scale_x_continuous(breaks = seq(0, 1, 0.05)) +
  theme(legend.position = 'bottom', legend.direction = 'vertical',
        axis.ticks.y = element_blank(),
        axis.text.y = element_blank())


# Program 15.3
# Stratification on the propensity score
# Data from NHEFS
# calculation of deciles
nhefs$ps.dec <- cut(nhefs$ps, 
                    breaks=c(quantile(nhefs$ps, probs=seq(0,1,0.1))),
                    labels=seq(1:10),
                    include.lowest=TRUE)

#install.packages("psych") # install package if required
library("psych")

describeBy(nhefs$ps, list(nhefs$ps.dec, nhefs$qsmk))


# function to create deciles easily
decile <- function(x) {
  return(factor(quantcut(x, seq(0, 1, 0.1), labels = FALSE)))
}

# regression on PS deciles, allowing for effect modification
for (deciles in c(1:10)) {
  print(t.test(wt82_71~qsmk, data=nhefs[which(nhefs$ps.dec==deciles),]))
}

# regression on PS deciles, not allowing for effect modification
fit.psdec <- glm(wt82_71 ~ qsmk + as.factor(ps.dec), data = nhefs)
summary(fit.psdec)
confint.lm(fit.psdec)



fitIR.psdec <- glm(wt82_71 ~ qsmk * as.factor(ps.dec), data = nhefs)
summary(fitIR.psdec)
confint.lm(fitIR.psdec)
confint(fitIR.psdec)
?stats::confint.lm
?stats::confint


# https://remlapmot.github.io/cibookex-r/instrumental-variables-estimation.html

# 16. Instrumental variables estimation
# Program 16.1
# Estimating the average causal using the standard IV estimator via the calculation of sample averages
# Data from NHEFS

nhefs$cens <- ifelse(is.na(nhefs$wt82), 1, 0)
summary(nhefs$price82)

nhefs.iv <- nhefs[which(!is.na(nhefs$wt82) & !is.na(nhefs$price82)),]
nhefs.iv$highprice <- ifelse(nhefs.iv$price82>=1.5, 1, 0)

table(nhefs.iv$highprice, nhefs.iv$qsmk)

options('digits')
t.test(wt82_71 ~ highprice, data=nhefs.iv)

options(digits = 8)
options('digits')



# Program 16.2
# Estimating the average causal effect using the standard IV estimator via two-stage-least-squares regression
# Data from NHEFS

library(sem) 

model1 <- tsls(wt82_71 ~ qsmk, ~ highprice, data = nhefs.iv)
summary(model1)
confint(model1)

model1.lm <- lm(wt82_71 ~ qsmk, data = nhefs.iv)
summary(model1.lm)

model1.glm <- glm(wt82_71 ~ qsmk, ~ highprice, family = gaussian, weights=NULL, data = nhefs.iv)
summary(model1.glm)

# Program 16.3
# Estimating the average causal using the standard IV estimator via additive marginal structural models
# Data from NHEFS
# G-estimation: Checking one possible value of psi
# See Chapter 14 for program that checks several values and computes 95% confidence intervals
nhefs.iv$psi <- 2.396
nhefs.iv$Hpsi <- nhefs.iv$wt82_71-nhefs.iv$psi*nhefs.iv$qsmk

#install.packages("geepack") # install package if required
library("geepack")
g.est <- geeglm(highprice ~ Hpsi, data=nhefs.iv, id=seqn, family=binomial(),
                corstr="independence")
summary(g.est)
confint(g.est)

beta <- coef(g.est)
SE <- coef(summary(g.est))[,2]
lcl <- beta-qnorm(0.975)*SE 
ucl <- beta+qnorm(0.975)*SE
cbind(beta, lcl, ucl)


# Program 16.4
# Estimating the average causal using the standard IV estimator with altnerative proposed instruments
# Data from NHEFS
summary(tsls(wt82_71 ~ qsmk, ~ ifelse(price82 >= 1.6, 1, 0), data = nhefs.iv))

summary(tsls(wt82_71 ~ qsmk, ~ ifelse(price82 >= 1.7, 1, 0), data = nhefs.iv))
summary(tsls(wt82_71 ~ qsmk, ~ ifelse(price82 >= 1.8, 1, 0), data = nhefs.iv))
summary(tsls(wt82_71 ~ qsmk, ~ ifelse(price82 >= 1.9, 1, 0), data = nhefs.iv))


# Program 16.5
# Estimating the average causal using the standard IV estimator
# Conditional on baseline covariates
# Data from NHEFS

model2 <- tsls(wt82_71 ~ qsmk + sex + race + age + smokeintensity + smokeyrs + 
                 as.factor(exercise) + as.factor(active) + wt71,
               ~ highprice + sex + race + age + smokeintensity + smokeyrs + as.factor(exercise) +
                 as.factor(active) + wt71, data = nhefs.iv)
summary(model2)


# https://remlapmot.github.io/cibookex-r/g-estimation-of-structural-nested-models.html
# 14. G-estimation of Structural Nested Models
# Program 14.1
# Preprocessing, ranks of extreme observations, IP weights for censoring
# Data from NHEFS

#install.packages("readxl") # install package if required
# library("readxl")
# nhefs <- read_excel(here("data", "NHEFS.xls"))

# some processing of the data
nhefs$cens <- ifelse(is.na(nhefs$wt82), 1, 0)

# ranking of extreme observations
#install.packages("Hmisc")
library(Hmisc)

# Hmisc::describe
describe(nhefs$wt82_71)

# estimation of denominator of ip weights for C
cw.denom <- glm(cens==0 ~ qsmk + sex + race + age + I(age^2) 
                + as.factor(education) + smokeintensity + I(smokeintensity^2) 
                + smokeyrs + I(smokeyrs^2) + as.factor(exercise) 
                + as.factor(active) + wt71 + I(wt71^2), 
                data = nhefs, family = binomial("logit"))
summary(cw.denom)

nhefs$pd.c <- predict(cw.denom, nhefs, type="response")
nhefs$wc <- ifelse(nhefs$cens==0, 1/nhefs$pd.c, NA) 


# Program 14.2
# G-estimation of a 1-parameter structural nested mean model
# Brute force search
# Data from NHEFS
# G-estimation: Checking one possible value of psi
# #install.packages("geepack")
# library("geepack")

nhefs$psi <- 3.446
nhefs$Hpsi <- nhefs$wt82_71 - nhefs$psi*nhefs$qsmk

fit <- geeglm(qsmk ~ sex + race + age + I(age*age) + as.factor(education)
              + smokeintensity + I(smokeintensity*smokeintensity) + smokeyrs
              + I(smokeyrs*smokeyrs) + as.factor(exercise) + as.factor(active)
              + wt71 + I(wt71*wt71) + Hpsi, family=binomial, data=nhefs,
              weights=wc, id=seqn, corstr="independence")
summary(fit)

# G-estimation: Checking multiple possible values of psi
#install.packages("geepack")
grid <- seq(from = 2,to = 5, by = 0.1)
j = 0
Hpsi.coefs <- cbind(rep(NA,length(grid)), rep(NA, length(grid)))
colnames(Hpsi.coefs) <- c("Estimate", "p-value")

for (i in grid){
  psi = i
  j = j+1
  nhefs$Hpsi <- nhefs$wt82_71 - psi * nhefs$qsmk 
  
  gest.fit <- geeglm(qsmk ~ sex + race + age + I(age*age) + as.factor(education)
                     + smokeintensity + I(smokeintensity*smokeintensity) + smokeyrs
                     + I(smokeyrs*smokeyrs) + as.factor(exercise) + as.factor(active)
                     + wt71 + I(wt71*wt71) + Hpsi, family=binomial, data=nhefs,
                     weights=wc, id=seqn, corstr="independence")
  Hpsi.coefs[j,1] <- summary(gest.fit)$coefficients["Hpsi", "Estimate"]
  Hpsi.coefs[j,2] <- summary(gest.fit)$coefficients["Hpsi", "Pr(>|W|)"]
}

Hpsi.coefs


# Program 14.3
# G-estimation for 2-parameter structural nested mean model
# Closed form estimator
# Data from NHEFS
# G-estimation: Closed form estimator linear mean models

logit.est <- glm(qsmk ~ sex + race + age + I(age^2) + as.factor(education) 
                 + smokeintensity + I(smokeintensity^2) + smokeyrs 
                 + I(smokeyrs^2) + as.factor(exercise) + as.factor(active) 
                 + wt71 + I(wt71^2), data = nhefs, weight = wc, 
                 family = binomial())
summary(logit.est)

nhefs$pqsmk <- predict(logit.est, nhefs, type = "response")
describe(nhefs$pqsmk)
summary(nhefs$pqsmk)

options(digits=8)
options('digits')
nhefs.c <- nhefs[which(!is.na(nhefs$wt82)),]
with(nhefs.c, sum(wc*wt82_71*(qsmk-pqsmk)) / sum(wc*qsmk*(qsmk - pqsmk)))

# G-estimation: Closed form estimator for 2-parameter model
diff = with(nhefs.c, qsmk - pqsmk)
diff2 = with(nhefs.c, wc * diff)

lhs = matrix(0,2,2)
lhs[1,1] = with(nhefs.c, sum(qsmk * diff2))
lhs[1,2] = with(nhefs.c, sum(qsmk * smokeintensity  * diff2))
lhs[2,1] = with(nhefs.c, sum(qsmk * smokeintensity * diff2))
lhs[2,2] = with(nhefs.c, sum(qsmk * smokeintensity * smokeintensity * diff2))

rhs = matrix(0,2,1)
rhs[1] = with(nhefs.c, sum(wt82_71 * diff2))
rhs[2] = with(nhefs.c, sum(wt82_71 * smokeintensity * diff2))

psi = t(solve(lhs,rhs))
psi


# https://www.youtube.com/watch?v=HpeGi3rRlJ0&list=PL_onPhFCkVQimvhuSAFrC8VWLEyNygQR5&index=46
install.packages('ivpack')
library(ivpack)

data(card.data)
mean(card.data$nearc4)

exp(1.27) # 3.5608526


# https://www.youtube.com/watch?v=oajyLtZJIBM&list=PL_onPhFCkVQimvhuSAFrC8VWLEyNygQR5&index=24c
install.packages(c('sensitivity2x2xk', 'sensitivityfull'))
library(sensitivity2x2xk)
library(sensitivityfull)

library(tableone)
library(Matching)

load(url("http://biostat.mc.vanderbilt.edu/wiki/pub/Main/Datasets/rhc.sav"))


rhc <- read_csv("D:/1ASReece/Research/2020 Res/Causal Inference/R Code/Data/csv/rhc.csv")
View(rhc)

ARF     <- as.numeric(rhc$cat1=="ARF")
CHF     <- as.numeric(rhc$cat1=="CHF")
Cirr    <- as.numeric(rhc$cat1=="Cirrhosis")
colcan  <- as.numeric(rhc$cat1=="Colon Cancer")
Coma    <- as.numeric(rhc$cat1=="Coma")
COPD    <- as.numeric(rhc$cat1=="COPD")
lungcan <- as.numeric(rhc$cat1=="Lung Cancer")
MOSF    <- as.numeric(rhc$cat1=="MOSF w/Malignancy")
sepsis  <- as.numeric(rhc$cat1=="MOSF w/Sepsis")
female  <- as.numeric(rhc$se  =="Female")
died    <- as.numeric(rhc$death =="Yes")
age     <- as.numeric(rhc$age)
treatment<- as.numeric(rhc$swang1=="RHC")
meanbp1 <- as.numeric(rhc$meanbp1)


mydata <- cbind(ARF, CHF, Cirr, colcan, Coma, lungcan, MOSF, sepsis, age, female, meanbp1, treatment, died)
mydata <- data.frame(mydata)
head(mydata)
dim(mydata); names(mydata)

xvars <- c("ARF", "CHF", "Cirr", "colcan", "Coma", "lungcan", "MOSF", "sepsis", "age", "female", "meanbp1")

table1 <- CreateTableOne(vars=xvars, strata="treatment", data=mydata, test=FALSE)
print(table1, smd=TRUE)

table1 <- CreateTableOne(vars=xvars, strata="treatment", data=mydata, test=TRUE)
print(table1, smd=TRUE)

greedymatch   <- Match(Tr = treatment, M=1, X=mydata[1:10])
matched       <- mydata[unlist(greedymatch[c("index.treated", "index.control")]),]

matchedtab1  <- CreateTableOne(vars=xvars, strata = "treatment", 
                               data=matched, test=FALSE)
print(matchedtab1, smd=TRUE)

# outcome analysis
y_trt  <- matched$died[matched$treatment==1]
y_con  <- matched$died[matched$treatment==0]

# pairwise difference
diffy <- y_trt - y_con

#paired t-test
t.test(diffy)


# McNemar Test
table(y_con, y_trt)

mcnemar.test(matrix(c(974,386,521,318),2,2))

 
# r4cbalance package has many more balancing options:
#   http://obsstudies.org/files/rcbalance_paper_v7r2.pdf
# tableone package vignette useful code for creating figures and tables:
#   https://cran.r-project.org/web/packages/tableone/vignettes/smd.html


#####################
##################### TableOne Vignette
#####################
# https://cran.r-project.org/web/packages/tableone/vignettes/smd.html
rhc2 <- read.csv("http://biostat.mc.vanderbilt.edu/wiki/pub/Main/DataSets/rhc.csv")
glimpse(rhc2)

library(tableone)
## PS matching
library(Matching)
## Weighted analysis
library(survey)
## Reorganizing data
library(reshape2)
## plotting
library(ggplot2)


## Covariates
vars <- c("age","sex","race","edu","income","ninsclas","cat1","das2d3pc","dnr1",
          "ca","surv2md1","aps1","scoma1","wtkilo1","temp1","meanbp1","resp1",
          "hrt1","pafi1","paco21","ph1","wblc1","hema1","sod1","pot1","crea1",
          "bili1","alb1","resp","card","neuro","gastr","renal","meta","hema",
          "seps","trauma","ortho","cardiohx","chfhx","dementhx","psychhx",
          "chrpulhx","renalhx","liverhx","gibledhx","malighx","immunhx",
          "transhx","amihx")

## Construct a table
tabUnmatched <- CreateTableOne(vars = vars, strata = "swang1", data = rhc, test = FALSE)
## Show table with SMD
print(tabUnmatched, smd = TRUE)
print(tabUnmatched, smd = TRUE, order(rev(as.numeric(as.character(tabUnmatched$SMD)))))
print(tabUnmatched)

addmargins(table(ExtractSmd(tabUnmatched) > 0.1))

print(table(ExtractSmd(tabUnmatched) > 0.1))

ExtractSmd(tabUnmatched) > 0.1

margin(table(ExtractSmd(tabUnmatched) > 0.1))

range(rhc$swang1)

## Fit model
psModel <- glm(formula = swang1 ~ age + sex + race + edu + income + ninsclas +
                 cat1 + das2d3pc + dnr1 + ca + surv2md1 + aps1 + scoma1 +
                 wtkilo1 + temp1 + meanbp1 + resp1 + hrt1 + pafi1 +
                 paco21 + ph1 + wblc1 + hema1 + sod1 + pot1 + crea1 +
                 bili1 + alb1 + resp + card + neuro + gastr + renal +
                 meta + hema + seps + trauma + ortho + cardiohx + chfhx +
                 dementhx + psychhx + chrpulhx + renalhx + liverhx + gibledhx +
                 malighx + immunhx + transhx + amihx,
               family  = binomial(link = "logit"),
               data    = rhc)

## Predicted probability of being assigned to RHC
rhc$pRhc <- predict(psModel, type = "response")
## Predicted probability of being assigned to no RHC
rhc$pNoRhc <- 1 - rhc$pRhc

## Predicted probability of being assigned to the
## treatment actually assigned (either RHC or no RHC)
rhc$pAssign <- NA
rhc$pAssign[rhc$swang1 == "RHC"]    <- rhc$pRhc[rhc$swang1   == "RHC"]
rhc$pAssign[rhc$swang1 == "No RHC"] <- rhc$pNoRhc[rhc$swang1 == "No RHC"]
## Smaller of pRhc vs pNoRhc for matching weight
rhc$pMin <- pmin(rhc$pRhc, rhc$pNoRhc)


## Predicted probability of being assigned to the
## treatment actually assigned (either RHC or no RHC)
rhc$pAssign <- NA
rhc$pAssign[rhc$swang1 == "RHC"]    <- rhc$pRhc[rhc$swang1   == "RHC"]
rhc$pAssign[rhc$swang1 == "No RHC"] <- rhc$pNoRhc[rhc$swang1 == "No RHC"]
## Smaller of pRhc vs pNoRhc for matching weight
rhc$pMin <- pmin(rhc$pRhc, rhc$pNoRhc)

listMatch <- Match(Tr       = (rhc$swang1 == "RHC"),      # Need to be in 0,1
                   ## logit of PS,i.e., log(PS/(1-PS)) as matching scale
                   X        = log(rhc$pRhc / rhc$pNoRhc),
                   ## 1:1 matching
                   M        = 1,
                   ## caliper = 0.2 * SD(logit(PS))
                   caliper  = 0.2,
                   replace  = FALSE,
                   ties     = TRUE,
                   version  = "fast")
## Extract matched data
rhcMatched <- rhc[unlist(listMatch[c("index.treated","index.control")]), ]

## Construct a table
tabMatched <- CreateTableOne(vars = vars, strata = "swang1", data = rhcMatched, test = FALSE)
## Show table with SMD
print(tabMatched, smd = TRUE)


install.packages("rcbalance")
library(rcbalance)




####### CreateTableOne HelpPage
## Load
library(tableone)

## Load Mayo Clinic Primary Biliary Cirrhosis Data
library(survival)
data(pbc)
## Check variables
head(pbc)

## Make categorical variables factors
varsToFactor <- c("status","trt","ascites","hepato","spiders","edema","stage")
pbc[varsToFactor] <- lapply(pbc[varsToFactor], factor)

## Create a variable list
dput(names(pbc))
vars <- c("time","status","age","sex","ascites","hepato",
          "spiders","edema","bili","chol","albumin",
          "copper","alk.phos","ast","trig","platelet",
          "protime","stage")

## Create Table 1 stratified by trt
tableOne <- CreateTableOne(vars = vars, strata = c("trt"), data = pbc)



# https://cran.r-project.org/web/packages/tableone/vignettes/smd.html

glimpse(rhc)

rhc$sex2       <- as.numeric(rhc$sex   =="Female")
rhc$death2     <- as.numeric(rhc$death =="Yes")
rhc$age2       <- as.numeric(rhc$age)
rhc$treatment2 <- as.numeric(rhc$swang1=="RHC")
rhc$meanbp2    <- as.numeric(rhc$meanbp1)
rhc$resp2      <- as.numeric(rhc$resp   =="Yes")

rhc$sepsis2    <- as.numeric(rhc$seps   =="Yes")
rhc$trauma2    <- as.numeric(rhc$trauma =="Yes")
rhc$ortho2     <- as.numeric(rhc$ortho  =="Yes")

# cardiohx <int> 
# chfhx    <int> 
# dementhx <int> 
# psychhx  <int>
# chrpulhx <int> 
# renalhx  <int> 
# liverhx  <int> 
# gibledhx <int> 
# malighx  <int> 
# immunhx  <int> 
# transhx  <int> 
# amihx    <int> 

psModel <- glm(formula = treatment2 ~ age2 + sex2 + scoma1 +
                 wtkilo1 + temp1 + meanbp2 + resp1 + hrt1 + pafi1 +
                 paco21 + ph1 + wblc1 + hema1 + sod1 + pot1 + crea1 +
                 bili1 + alb1 + resp2 + crea1 + paco21 + ph1 + # urin1 + 
                 race + edu + income +
                 sepsis2 + trauma2 + ortho2 + cardiohx + chfhx + death2 +
                 dementhx + psychhx + chrpulhx + renalhx + liverhx + gibledhx +
                 malighx + immunhx + transhx + amihx,
               family  = binomial(link = "logit"),
               data    = rhc)   

### See argument family   

# family(object, ...)
# 
# binomial(link = "logit")
# gaussian(link = "identity")
# Gamma(link = "inverse")
# inverse.gaussian(link = "1/mu^2")
# poisson(link = "log")
# quasi(link = "identity", variance = "constant")
# quasibinomial(link = "logit")
# quasipoisson(link = "log")

## Predicted probability of being assigned to RHC
rhc$pRhc <- predict(psModel, type = "response")
## Predicted probability of being assigned to no RHC
rhc$pNoRhc <- 1 - rhc$pRhc

## Predicted probability of being assigned to the
## treatment actually assigned (either RHC or no RHC)
rhc$pAssign <- NA
rhc$pAssign[rhc$swang1 == "RHC"]    <- rhc$pRhc[rhc$swang1   == "RHC"]
rhc$pAssign[rhc$swang1 == "No RHC"] <- rhc$pNoRhc[rhc$swang1 == "No RHC"]
## Smaller of pRhc vs pNoRhc for matching weight
rhc$pMin <- pmin(rhc$pRhc, rhc$pNoRhc)


listMatch <- Match(Tr       = (rhc$swang1 == "RHC"),      # Need to be in 0,1
                   ## logit of PS,i.e., log(PS/(1-PS)) as matching scale
                   X        = log(rhc$pRhc / rhc$pNoRhc),
                   ## 1:1 matching
                   M        = 1,
                   ## caliper = 0.2 * SD(logit(PS))
                   caliper  = 0.2,
                   replace  = FALSE,
                   ties     = TRUE,
                   version  = "fast")
## Extract matched data
rhcMatched <- rhc[unlist(listMatch[c("index.treated","index.control")]), ]


vars <- c("age2","sex2","scoma1","wtkilo1","temp1","meanbp2","resp1","hrt1","pafi1",
"paco21"," ph1"," wblc1","hema1","sod1","pot1","crea1",
"bili1"," alb1","resp2","crea1","paco21","ph1",
"race","edu","income","sepsis2","trauma2","ortho2","cardiohx","chfhx",
"death2","dementhx","psychhx","chrpulhx","renalhx","liverhx","gibledhx",
"malighx", "immunhx","transhx", "amihx")


## Construct a table - Unmatched
tabUnmatched <- CreateTableOne(vars = vars, strata = "swang1", data = rhc, test = FALSE)
## Show table with SMD
print(tabUnmatched, smd = TRUE)


## Construct a table
tabMatched <- CreateTableOne(vars = vars, strata = "swang1", data = rhcMatched, test = FALSE)
## Show table with SMD
print(tabMatched, smd = TRUE)

addmargins(table(ExtractSmd(tabMatched) > 0.1))

library(survey)

## Matching weight
rhc$mw <- rhc$pMin / rhc$pAssign
## Weighted data
rhcSvy <- svydesign(ids = ~ 1, data = rhc, weights = ~ mw)

## Construct a table (This is a bit slow.)
tabWeighted <- svyCreateTableOne(vars = vars, strata = "swang1", data = rhcSvy, test = FALSE)
## Show table with SMD
print(tabWeighted, smd = TRUE)

addmargins(table(ExtractSmd(tabWeighted) > 0.1))

summary(tabUnmatched)
summary(tabMatched)
summary(tabWeighted)

### Now Plotting Data
dataPlot <- data.frame(variable  = rownames(ExtractSmd(tabUnmatched)),
                       Unmatched = ExtractSmd(tabUnmatched),
                       Matched   = ExtractSmd(tabMatched),
                       Weighted  = ExtractSmd(tabWeighted))

# svyCreatTableOne HelpPage
## nonnormal specifies variables to be shown as median [IQR]
print(tab1, nonnormal = "HI_CHOL", contDigits = 3, catDigits = 2,
      pDigits = 4, smd = TRUE)

## minMax changes it to median [min, max]
print(tab1, nonnormal = "HI_CHOL", minMax = TRUE, contDigits = 3,
      catDigits = 2, pDigits = 4, smd = TRUE)



## Load packages
library(tableone)
library(survey)

## Create a weighted survey design object
data(nhanes)
nhanesSvy <- svydesign(ids = ~ SDMVPSU, strata = ~ SDMVSTRA, weights = ~ WTMEC2YR,
                       nest = TRUE, data = nhanes)

## Create a table object
## factorVars are converted to factors; no need for variables already factors
## strata will stratify summaries; leave it unspecified for overall summaries
tab1 <- svyCreateTableOne(vars = c("HI_CHOL","race","agecat","RIAGENDR"),
                          strata = "RIAGENDR", data = nhanesSvy,
                          factorVars = c("race","RIAGENDR"))

## Detailed output
summary(tab1)

## Default formatted printing
tab1

## nonnormal specifies variables to be shown as median [IQR]
print(tab1, nonnormal = "HI_CHOL", contDigits = 3, catDigits = 2,
      pDigits = 4, smd = TRUE)

## minMax changes it to median [min, max]
print(tab1, nonnormal = "HI_CHOL", minMax = TRUE, contDigits = 3,
      catDigits = 2, pDigits = 4, smd = TRUE)

## showAllLevels can be used tow show levels for all categorical variables
print(tab1, showAllLevels = TRUE, smd = TRUE)

## To see all printing options
?print.TableOne

## To examine categorical variables only
tab1$CatTable

## To examine continuous variables only
tab1$ContTable

## If SMDs are needed as numericals, use ExtractSmd()
ExtractSmd(tab1)


dataPlot <- data.frame(variable  = rownames(ExtractSmd(tabUnmatched)),
                       Unmatched = ExtractSmd(tabUnmatched),
                       Matched   = ExtractSmd(tabMatched),
                       Weighted  = ExtractSmd(tabWeighted))
head(dataPlot)

library(reshape2)

dataPlotMelt <- melt(data          = dataPlot,
                     id.vars       = c("variable"),
                     variable.name = "Method",
                     value.name    = "SMD")
head(dataPlotMelt)


varNames <- as.character(dataPlot$variable)[order(dataPlot$X1.vs.2.2)]
varNames <- as.character(dataPlot$variable)[rev(order(dataPlot$X1.vs.2.2))]
varNames <- as.character(dataPlot$variable)[order(dataPlot$X1.vs.2.2)]
dataPlotMelt$variable <- factor(dataPlotMelt$variable, levels = varNames)


######### Now Plotting
ggplot(data = dataPlotMelt, mapping = aes(x = variable, y = SMD,
                                          group = Method, color = Method)) +
  geom_line() +
  geom_point() +
  geom_hline(yintercept = 0.1, color = "black", size = 0.1) +
  coord_flip() +
  theme_bw() + theme(legend.key = element_blank())


resCombo <- cbind(print(tabUnmatched, printToggle = FALSE),
                  print(tabMatched,   printToggle = FALSE),
                  print(tabWeighted,  printToggle = FALSE))

## Add group name row, and rewrite column names
resCombo <- rbind(Group = rep(c("No RHC","RHC"), 3), resCombo)
colnames(resCombo) <- c("Unmatched","","Matched","","Weighted","")
print(resCombo, quote = FALSE)


################ Now Analysis
## Unmatched model (unadjsuted)
glmUnmatched <- glm(formula = (death2== "1") ~ swang1,
                    family  = binomial(link = "logit"),
                    data    = rhc)
## Matched model
glmMatched <- glm(formula = (death2 == "1") ~ swang1,
                  family  = binomial(link = "logit"),
                  data    = rhcMatched)
## Weighted model
glmWeighted <- svyglm(formula = (death2 == "1") ~ swang1,
                      family  = binomial(link = "logit"),
                      design    = rhcSvy)

## Show results together
resTogether <- list(Unmatched = ShowRegTable(glmUnmatched, printToggle = FALSE),
                    Matched   = ShowRegTable(glmMatched, printToggle = FALSE),
                    Weighted  = ShowRegTable(glmWeighted, printToggle = FALSE))
print(resTogether, quote = FALSE)
print(resTogether, quote = TRUE)
print(resTogether, quote = FALSE)


##############################################################################################################################################################################
##############################################################################################################################################################################
######## Sensitivity packages for 2by2 tables

# install.packages(c('sensitivitymv', 'sensitivitymw'))
library(sensitivitymv)     # senmv()
library(sensitivitymw)     # senmw() and senmwCI()
library(sensitivityfull)
install.packages('sensitivitymult')
library(sensitivitymult)    # senm() and senmCI()

# in sensitivitymult helpPage
# In particular, in the sensitivitymv package, the rows of y are matched sets, 


##############################################################################################################################################################################
##############################################################################################################################################################################
######## Match, MatchBalance

# Match HelpPage & MatchBalance HelpPage

Examples

# Replication of Dehejia and Wahba psid3 model
#
# Dehejia, Rajeev and Sadek Wahba. 1999.``Causal Effects in
# Non-Experimental Studies: Re-Evaluating the Evaluation of Training
# Programs.''Journal of the American Statistical Association 94 (448):
# 1053-1062.

data(lalonde)

#
# Estimate the propensity model
#
glm1  <- glm(treat~age + I(age^2) + educ + I(educ^2) + black +
               hisp + married + nodegr + re74  + I(re74^2) + re75 + I(re75^2) +
               u74 + u75, family=binomial, data=lalonde)


#
#save data objects
#
X  <- glm1$fitted
Y  <- lalonde$re78
Tr  <- lalonde$treat

#
# one-to-one matching with replacement (the "M=1" option).
# Estimating the treatment effect on the treated (the "estimand" option defaults to ATT).
#
rr  <- Match(Y=Y, Tr=Tr, X=X, M=1);
summary(rr)

# Let's check the covariate balance
# 'nboots' is set to small values in the interest of speed.
# Please increase to at least 500 each for publication quality p-values.  
mb  <- MatchBalance(treat~age + I(age^2) + educ + I(educ^2) + black +
                      hisp + married + nodegr + re74  + I(re74^2) + re75 + I(re75^2) +
                      u74 + u75, data=lalonde, match.out=rr, nboots=10)

mb  <- MatchBalance(treat~age + I(age^2) + educ + I(educ^2) + black +
                      hisp + married + nodegr + re74  + I(re74^2) + re75 + I(re75^2) +
                      u74 + u75, data=lalonde, match.out=rr, nboots=500)


class(rr); dim(rr); names(rr); head(rr) 
str(rr, max.level=0)
str(rr, max.level=1)
str(rr, max.level=2)


install.packages(c('optmatch', 'rcbalance'))
install.packages(c('optmatch'))
library(optmatch)
library(rcbalance)

##############################################################################################################################################################################
##############################################################################################################################################################################
######## MatchIt

# https://www.youtube.com/watch?v=iRYvJAn6AuI&list=PL_onPhFCkVQimvhuSAFrC8VWLEyNygQR5&index=28

install.packages('MatchIt')
library(MatchIt)

pscore <- psmodel$fitted.values

install.packages('svydesign')
library(svydesign)
library(survey)
library(ipw)


##############################################################################################################################################################################
##############################################################################################################################################################################
######## ipw

install.packages(c('ipw','cluster','survey'))
library(ipw)
library(cluster)
library(survey)


##############################################################################################################################################################################
##############################################################################################################################################################################
######## drtmle

# https://cran.r-project.org/web/packages/drtmle/vignettes/using_drtmle.html
# https://github.com/benkeser/drtmle

install.packages(c('drtmle','future','future.batchtools','earth','parallel','SuperLearner'))
install.packages(c('Formula','plotrix','nnls','nloptr','np'))
install.packages("drtmle")
library(drtmle)
library(future)
library(future.batchtools)
library(earth)
library(parallel)
library(SuperLearner)

library(np)
library(Formula)
library(plotrix)
library(nnls)
library(nloptr)


# https://github.com/benkeser/drtmle

# load packages
library(drtmle)
#> drtmle: TMLE with doubly robust inference
#> Version: 1.0.5
library(SuperLearner)
#> Loading required package: nnls
#> Super Learner
#> Version: 2.0-25
#> Package created on 2019-08-05

# simulate simple data structure
set.seed(12345)
n <- 200
W <- data.frame(W1 = runif(n,-2,2), W2 = rbinom(n,1,0.5))
A <- rbinom(n, 1, plogis(-2 + W$W1 - 2*W$W1*W$W2))
Y <- rbinom(n, 1, plogis(-2 + W$W1 - 2*W$W1*W$W2 + A))

# estimate the covariate-adjusted marginal mean for A = 1 and A = 0
# here, we do not properly estimate the propensity score
fit1 <- drtmle(W = W, A = A, Y = Y, # input data
               a_0 = c(0, 1), # return estimates for A = 0 and A = 1
               SL_Q = "SL.npreg", # use kernel regression for E(Y | A = a, W)
               glm_g = "W1 + W2", # use misspecified main terms glm for E(A | W)
               SL_Qr = "SL.npreg", # use kernel regression to guard against
               # misspecification of outcome regression
               SL_gr = "SL.npreg", # use kernel regression to guard against
               # misspecification of propensity score
               returnModels = TRUE # for visualizing fits later
)
# print the output
fit1
#> $est
#>            
#> 0 0.1729750
#> 1 0.3620682
#> 
#> $cov
#>              0            1
#> 0 8.823949e-04 2.366906e-05
#> 1 2.366906e-05 7.155764e-03

# get confidence intervals for marginal means
# truth is E[Y(1)] = 0.29, E[Y(0)] = 0.15
ci_fit1 <- ci(fit1)
# print the output
ci_fit1
#> $drtmle
#>     est   cil   ciu
#> 0 0.173 0.115 0.231
#> 1 0.362 0.196 0.528

# get confidence intervals for ate
# truth is E[Y(1)] - E[Y(0)] = 0.14
ci_ate1 <- ci(fit1, contrast = c(-1, 1))
# print the output
ci_ate1
#> $drtmle
#>                   est   cil   ciu
#> E[Y(1)]-E[Y(0)] 0.189 0.014 0.364
# This method requires estimation of additional univariate regressions to ensure doubly robust confidence intervals and hypothesis tests. 
# The method for estimation are input via SL.Qr and SL.gr or glm.Qr and glm.gr if parametric models are desired). 
# These additional fits can be visualized by the plot method for drtmle.

layout(t(1:3))
plot(fit1, ask = FALSE)
# Inference for super learner-based IPTW
# The package additionally includes a function for computing valid confidence intervals about an inverse probability of treatment weight (IPTW)
# estimator when super learning is used to estimate the propensity score.

# fit iptw
fit2 <- adaptive_iptw(Y = Y, A = A, W = W, a_0 = c(0, 1),
                      SL_g = c("SL.glm", "SL.mean", "SL.step.interaction"),
                      SL_Qr = "SL.npreg")
#> Loading required package: nloptr
#> Loading required package: nloptr
#> Loading required package: nloptr
#> Loading required package: nloptr
# print the output
fit2
#> $est
#>            
#> 0 0.1739449
#> 1 0.2425360
#> 
#> $cov
#>              0            1
#> 0 8.560329e-04 8.966488e-05
#> 1 8.966488e-05 2.244440e-02

# compute a confidence interval for margin means
ci_fit2 <- ci(fit2)
# print the output
ci_fit2
#> $iptw_tmle
#>     est    cil   ciu
#> 0 0.174  0.117 0.231
#> 1 0.243 -0.051 0.536

# compute a confidence interval for the ate
ci_ate2 <- ci(fit2, contrast = c(-1, 1))
# print the output
ci_ate2
#> $iptw_tmle
#>                   est    cil   ciu
#> E[Y(1)]-E[Y(0)] 0.069 -0.229 0.367



##############################################################################################################################################################################
##############################################################################################################################################################################
######## ASD

ASDKLTab     <- read_csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTab_5.csv")
ASDKLTab$Year <- as.integer(ASDKLTab$Year)
dim(ASDKLTab); names(ASDKLTab); class(ASDKLTab); head(ASDKLTab); glimpse(ASDKLTab); summary(ASDKLTab); length(unique(ASDKLTab$State)) # 37

ASDKLTaba <- ASDKLTab %>% arrange(State, Year); head(ASDKLTaba, n=20)

ASDKLTaba$BivCI    <- cut_interval(ASDKLTaba$mrjmon, 2)
ASDKLTaba$TriCI    <- cut_interval(ASDKLTaba$mrjmon, 3)
ASDKLTaba$QQuinCI  <- cut_interval(ASDKLTaba$mrjmon, 5)
ASDKLTaba$SixCI    <- cut_interval(ASDKLTaba$mrjmon, 6)
ASDKLTaba$SevCI    <- cut_interval(ASDKLTaba$mrjmon, 7)
ASDKLTaba$DecCI    <- cut_interval(ASDKLTaba$mrjmon, 10)
ASDKLTaba$Tri2CI   <- ASDKLTaba$TriCI
ASDKLTaba$Tri2CI[ASDKLTaba$TriCI=="(0.0708,0.111]"] <- "[0.0304,0.0708]"
table(ASDKLTaba$Tri2CI)

Gr5 <- 
ggplot(ASDKLTaba, aes(QuinCI, log(ASDRt))) +
  geom_boxplot(notch=T)+ 
  ggtitle('Log (ASD Rate) by Quintile') +
  theme_plotE()

Gr55 <- 
  ggplot(ASDKLTaba, aes(QQuinCI, log(ASDRt))) +
  geom_boxplot(notch=T)+ 
  ggtitle('Log (ASD Rate) by Quintile') +
  theme_plotE()


Gr2 <- 
ggplot(ASDKLTaba, aes(BivCI, log(ASDRt))) +
  geom_boxplot(notch=T) +
  ggtitle('Log (ASD Rate) by Dichotomous Quantiles') +
  theme_plotE()

Gr3 <- 
ggplot(ASDKLTaba, aes(TriCI, log(ASDRt))) +
  geom_boxplot(notch=T)+ 
  ggtitle('Log (ASD Rate) by Tertiles') +
  theme_plotE()

Gr3C <- 
ggplot(ASDKLTaba, aes(Tri2CI, log(ASDRt))) +
  geom_boxplot(notch=T) + 
  ggtitle('Log (ASD Rate) by Tertiles with Tertiles 1 & 2 Collapsed') +
  theme_plotE()

Gr4 <- 
ggplot(ASDKLTaba, aes(QuartCI, log(ASDRt))) +
  geom_boxplot(notch=T)+ 
  ggtitle('Log (ASD Rate) by Quartiles') +
  theme_plotE()

Gr5 <- 
  ggplot(ASDKLTaba, aes(QQuinCI, log(ASDRt))) +
  geom_boxplot(notch=T)+ 
  ggtitle('Log (ASD Rate) by Sextiles') +
  theme_plotE()

Gr6 <- 
  ggplot(ASDKLTaba, aes(SixCI, log(ASDRt))) +
  geom_boxplot(notch=T)+ 
  ggtitle('Log (ASD Rate) by Sextiles') +
  theme_plotE()

Gr7 <- 
  ggplot(ASDKLTaba, aes(SevCI, log(ASDRt))) +
  geom_boxplot(notch=T)+ 
  ggtitle('Log (ASD Rate) by Septiles') +
  theme_plotE()

Gr10 <- 
  ggplot(ASDKLTaba, aes(DecCI, log(ASDRt))) +
  geom_boxplot(notch=T)+ 
  ggtitle('Log (ASD Rate) by Deciles') +
  theme_plotE()

ggarrange(Gr3C, Gr3, Gr5, Gr4, Gr2, Gr6, nrow=2, ncol=3)

t.test(log(ASDKLTaba$ASDRt) ~ ASDKLTaba$Tri2CI)
t.test(log(ASDKLTaba$ASDRt) ~ ASDKLTaba$BivCI)


## Check Chi for Trend in BivCI
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$BivCI, mean)
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$BivCI, median)
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$BivCI, sd)
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$BivCI, se)

## Check Chi for Trend in Tri2CI
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$Tri2CI, mean)
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$Tri2CI, median)
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$Tri2CI, sd)
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$Tri2CI, se)

## Check Chi for Trend in Quintiles
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$QuinCI, mean)
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$QuinCI, median)
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$QuinCI, sd)
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$QuinCI, se)

tapply((ASDKLTaba$ASDRt), ASDKLTaba$QuinCI, fivenum)


tapply((ASDKLTaba$ASDRt), ASDKLTaba$QuinCI, fivenum)

## Check Chi for Trend in Sextiles
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$SixCI, mean)
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$SixCI, median)
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$SixCI, sd)
tapply(log(ASDKLTaba$ASDRt), ASDKLTaba$SixCI, se)

names(ASDKLTaba); glimpse(ASDKLTaba)


USSttBth     <- read_csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/Bth9518S_2.csv")


names(USSttBth)[3] <- 'Births'
USSttBth$Year   <- as.numeric(USSttBth$Year)
dim(USSttBth)
glimpse(USSttBth)
head(USSttBth, 20)
ASDKLTaba$Year <- as.numeric(ASDKLTaba$Year)
glimpse(ASDKLTaba)
head(ASDKLTaba[,c(1:3)])


ASDKLTabab <- ASDKLTaba %>% left_join(USSttBth, by = c("State", "Year"))
# ASDKLTabab <- merge(ASDKLTaba, USSttBth, by = c("State", "Year"))
# ASDKLTabab <- merge(ASDKLTaba, USSttBth)

table(ASDKLTabab$Year)
length(na.omit(ASDKLTabab$Births))

dim(ASDKLTabab); names(ASDKLTabab)
print(ASDKLTabab[1:30,c(1:3, 62)], n=30)

ASDKLTabab$ASDNo.  <- round(ASDKLTabab$ASDRt * ASDKLTabab$Births / 10000)
range(na.omit(ASDKLTabab$ASDNo.)) # 17 3466

unique(ASDKLTabab$SixCI)
class(ASDKLTabab$SixCI)
ASDKLTabab$fSixCI       <- ASDKLTabab$SixCI
levels(ASDKLTabab$fSixCI)
levels(ASDKLTabab$fSixCI) <- c("1","2","3","4","5","6")
levels(ASDKLTabab$fSixCI)
table(ASDKLTabab$SixCI)
table(ASDKLTabab$fSixCI)

### Graphing Kriged Data
Gr66 <- 
  ggplot(ASDKLTabab, aes(fSixCI, log(ASDRt), colour=fSixCI, fill=fSixCI)) +
  geom_boxplot(notch=T, alpha=0.25, show.legend = F)+ 
  ggtitle('Log (ASD Rate) by Sextiles') +
  theme_plotE() +
  labs(x="Monthly Cannabis Use Sextiles", y="Log (ASD Rate)")


names(ASDKLTabab)
ASDKLTabab$fQQuinnCI <- ASDKLTabab$QQuinCI
levels(ASDKLTabab$fQQuinnCI)
levels(ASDKLTabab$fQQuinnCI) <- c("1","2","3","4","5")
levels(ASDKLTabab$fQQuinnCI)

ASDKLTabab$fQQuinnCICI                               <- "1"
ASDKLTabab$fQQuinnCICI[ASDKLTabab$fQQuinnCI=="4"]     <- "2"
ASDKLTabab$fQQuinnCICI[ASDKLTabab$fQQuinnCI=="5"]     <- "2"
table(ASDKLTabab$fQQuinnCICI)

### BEST WINNING t.test!!!
t.test(log(ASDKLTabab$ASDRt) ~ ASDKLTabab$fQQuinnCICI)   # t = -3.4821, df = 40.073, p-value = 0.001217

Gr55KrigeDich <- 
  ggplot(ASDKLTabab, aes(fQQuinnCICI, log(ASDRt), colour=fQQuinnCICI, fill=fQQuinnCICI)) +
  geom_boxplot(notch=T, alpha=0.25, show.legend = F)+ 
  ggtitle('Log (ASD Rate) by Quintiles 1, 2 & 3 Vs. Quintiles 4 & 5
- Kriged Data') +
  theme_plotE() +
  labs(x="Monthly Cannabis Use Quintiles", y="Log (ASD Rate)")

length(ASDKLTabab$ASDRt)
length(na.omit(ASDKLTabab$ASDRt))
length(ASDKLTabab$fQQuinnCI)

## Check Chi for Trend in Quintiles
tapply(log(ASDKLTabab$ASDRt), ASDKLTabab$fQQuinnCI, mean)
tapply(log(ASDKLTabab$ASDRt), ASDKLTabab$fQQuinnCI, median)
tapply(log(ASDKLTabab$ASDRt), ASDKLTabab$fQQuinnCI, sd)
tapply(log(ASDKLTabab$ASDRt), ASDKLTabab$fQQuinnCI, se)

## Check Chi for Trend in Quintiles - Not Logged
tapply((ASDKLTabab$ASDRt), ASDKLTabab$fQQuinnCI, mean)
tapply((ASDKLTabab$ASDRt), ASDKLTabab$fQQuinnCI, median)
tapply((ASDKLTabab$ASDRt), ASDKLTabab$fQQuinnCI, sd)
tapply((ASDKLTabab$ASDRt), ASDKLTabab$fQQuinnCI, se)

tapply((ASDKLTabab$ASDRt), ASDKLTabab$fQQuinnCI, fivenum)

## Check Chi for Trend in Quintiles - Not Logged & Dichotomized
tapply((ASDKLTabab$ASDRt), ASDKLTabab$fQQuinnCICI, mean)
tapply((ASDKLTabab$ASDRt), ASDKLTabab$fQQuinnCICI, median)
tapply((ASDKLTabab$ASDRt), ASDKLTabab$fQQuinnCICI, sd)
tapply((ASDKLTabab$ASDRt), ASDKLTabab$fQQuinnCICI, se)

tapply((ASDKLTabab$ASDRt), ASDKLTabab$fQQuinnCICI, fivenum)

dim(ASDKLTabab); names(ASDKLTabab); head(ASDKLTabab); glimpse(ASDKLTabab)

ASDKLTabab$fQQuinnCI     <-   as.integer(as.character(ASDKLTabab$fQQuinnCI))
ASDKLTabab$fQQuinnCICI   <-   as.integer(as.character(ASDKLTabab$fQQuinnCICI))

dim(ASDKLTabab)
length(na.omit(ASDKLTabab$Births))  # 288

names(ASDKLTabab)

## (True) Quintiles == fQQuinnCI
ASDKLTababAQuS  <- ASDKLTabab %>%
  arrange(fQQuinnCI)  %>%
  group_by(fQQuinnCI) %>%
  summarise(
    ASDNoTot  = sum(ASDNo., na.rm=T),
    BirthTot  = sum(Births, na.rm=T),
    NBthsTot  = BirthTot - ASDNoTot)
ASDKLTababAQuS


## Dichotomized Quintiles == fQQuinnCICI
ASDKLTababADi  <- ASDKLTabab %>%
  arrange(fQQuinnCICI)  %>%
  group_by(fQQuinnCICI) %>%
  summarise(
    ASDNoTot  = sum(ASDNo., na.rm=T),
    BirthTot  = sum(Births, na.rm=T),
    NBthsTot  = BirthTot - ASDNoTot)
ASDKLTababADi


chisq.test(ASDKLTababAQuS[,c(2,4)])
pchisq(1500, 4, lower.tail = F)
chisq.test(ASDKLTababADi[,c(2,4)])


## Sextiles == fSixCI
ASDKLTababA6  <- ASDKLTabab %>%
  arrange(fSixCI)  %>%
  group_by(fSixCI) %>%
  summarise(
    ASDNoTot  = sum(ASDNo., na.rm=T),
    BirthTot  = sum(Births, na.rm=T),
    NBthsTot  = BirthTot - ASDNoTot)
ASDKLTababA6

chisq.test(ASDKLTababA6[,c(2,4)])
pchisq(1500, 5, lower.tail = F)


# write_csv(ASDKLTabab,     "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab.csv")
# write_csv(ASDKLTababAQuS, "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTababAQuS.csv")
# write_csv(ASDKLTababADi,  "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTababADi.csv")
# write_csv(ASDKLTababA6,   "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTababA6.csv")
# write_csv(ASDKLTaba,      "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTaba")


###########################################################
###########################################################
################ Raw Data

dim(ASDRaw); names(ASDRaw); head(ASDRaw); glimpse(ASDRaw)
length(na.omit(ASDRaw$ASDRt))

USSttBth     <- read_csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/Bth9518S_2.csv")

ASDRawB <-  ASDRaw %>% left_join(USSttBth, by = c('State', 'Year'))
names(ASDRawB)[c(26,29,30,31)] <- c("AIAN_", "NHBlack", "NHPI", "NHWhite")
dim(ASDRawB); names(ASDRawB)
ASDRawB$ASDNo.  <- round(ASDRawB$ASDRt * ASDRawB$Births / 10000)
range(na.omit(ASDRawB$ASDNo.))   # 14 3466

ASDRawB$SixCI   <- cut_interval(ASDRawB$mrjmon, 6)
ASDRawB$fSixCI  <- ASDRawB$SixCI
levels(ASDRawB$fSixCI)
levels(ASDRawB$fSixCI) <- c("1","2","3","4","5","6")
levels(ASDRawB$fSixCI)

ASDRawBna <- subset(ASDRawB, SixCI !="NA"); dim(ASDRawBna)

Gr66Raw <- 
  ggplot(ASDRawBna, aes(fSixCI, log(ASDRt), colour=fSixCI, fill=fSixCI)) +
  geom_boxplot(notch=T, alpha=0.25, show.legend = F)+ 
  ggtitle('Log (ASD Rate) by Sextiles - All Data') +
  theme_plotE() +
  labs(x="Monthly Cannabis Use Quintiles", y="Log (ASD Rate)")


ASDRawB$QQuinCI  <- cut_interval(ASDRawB$mrjmon, 5)

ASDRawB$fQQuinCI <- ASDRawB$QQuinCI
levels(ASDRawB$fQQuinCI)
levels(ASDRawB$fQQuinCI) <- c("1","2","3","4","5")
levels(ASDRawB$fQQuinCI)

ASDRawB5na       <- subset(ASDRawB, QQuinCI !="NA" & ASDRt !="NA")
dim(ASDRawB5na)

Gr55Raw <- 
  ggplot(ASDRawB5na, aes(fQQuinCI, log(ASDRt), colour=fQQuinCI, fill=fQQuinCI)) +
  geom_boxplot(notch=T, alpha=0.25, show.legend = F)+ 
  ggtitle('Log (ASD Rate) by Quintiles 
- All Data') +
  theme_plotE() +
  labs(x="Monthly Cannabis Use Quintiles", y="Log (ASD Rate)")


ggsave(Gr55Raw, "Gr55Raw.pdf", width = 8, height = 6.5, units="in", dpi=1200,
       path = "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/Figures/NewFigg")
ggsave(Gr55Raw, "Gr55Raw.wmf", width = 8, height = 6.5, units="in", dpi=1200,
       path = "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/Figures/NewFigg")
ggsave(Gr55Raw, "Gr55Raw.tiff", , width = 8, height = 6.5, units="in", dpi=1200,
        path = "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/Figures/NewFigg")



dim(ASDRawB5na)

ASDRawB5na$fQQuinCICI                               <- "1"
ASDRawB5na$fQQuinCICI[ASDRawB5na$fQQuinCI=="4"]     <- "2" 
ASDRawB5na$fQQuinCICI[ASDRawB5na$fQQuinCI=="5"]     <- "2" 
table(ASDRawB5na$fQQuinCICI)

Gr55RawDich <- 
  ggplot(ASDRawB5na, aes(fQQuinCICI, log(ASDRt), colour=fQQuinCICI, fill=fQQuinCICI)) +
  geom_boxplot(notch=T, alpha=0.25, show.legend = F)+ 
  ggtitle('Log (ASD Rate) by Quintiles 1, 2 & 3 Vs. Quintiles 4 & 5
- All Data') +
  theme_plotE() +
  labs(x="Monthly Cannabis Use by Dichotomized Quintiles", y="Log (ASD Rate)")

class(Gr55Raw)
class(Gr55RawDich)
ggarrange(Gr55Raw, Gr55RawDich, nrow=1, ncol=2)

Boxplots <- ggarrange(Gr55Raw, Gr55RawDich, nrow=1, ncol=2)

ggsave("Boxplots.pdf", width = 11, height = 5, units="in", dpi=1200,
       path = "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/Figures/NewFigg")
ggsave("Boxplots.wmf", width = 11, height = 5, units="in", dpi=1200,
       path = "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/Figures/NewFigg")
ggsave("Boxplots.tiff", width = 11, height = 5, units="in", dpi=1200,
       path = "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/Figures/NewFigg")


tapply(ASDRawB5na$ASDRt, ASDRawB5na$QQuinCI,   fivenum)
tapply(ASDRawB5na$ASDRt, ASDRawB5na$QQuinCI,   fivenum)

tapply(ASDRawB5na$ASDRt, ASDRawB5na$fQQuinCI,   fivenum)
tapply(ASDRawB5na$ASDRt, ASDRawB5na$fQQuinCICI, fivenum)

summary(ASDRawB5na$ASDRt ~ ASDRawB5na$fQQuinCI)

names(ASDRawB5na)

tapply(ASDRawB5na$ASDRt, ASDRawB5na$fQQuinCI,   length)
tapply(ASDRawB5na$ASDRt, ASDRawB5na$fQQuinCICI, length)


############# WINNING t.test!!!!
t.test(log(ASDRawB5na$ASDRt) ~ ASDRawB5na$fQQuinCICI)  #  t = -2.9784, df = 34.754, p-value = 0.005253

## Check Chi for Trend in Quintiles - All Data
tapply(log(ASDRawB5na$ASDRt), ASDRawB5na$fQQuinCICI, mean)
tapply(log(ASDRawB5na$ASDRt), ASDRawB5na$fQQuinCICI, median)
tapply(log(ASDRawB5na$ASDRt), ASDRawB5na$fQQuinCICI, sd)
tapply(log(ASDRawB5na$ASDRt), ASDRawB5na$fQQuinCICI, se)

## Check Chi for Trend in Quintiles - All Data
tapply((ASDRawB5na$ASDRt), ASDRawB5na$fQQuinCICI, mean)
tapply((ASDRawB5na$ASDRt), ASDRawB5na$fQQuinCICI, median)
tapply((ASDRawB5na$ASDRt), ASDRawB5na$fQQuinCICI, sd)
tapply((ASDRawB5na$ASDRt), ASDRawB5na$fQQuinCICI, se)

tapply((ASDRawB5na$ASDRt), ASDRawB5na$fQQuinCI, fivenum)
tapply((ASDRawB5na$ASDRt), ASDRawB5na$fQQuinCICI, fivenum)


# write_csv(ASDRawB5na, "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDRawB5na.csv")


##############################################################################################################################################################################
##############################################################################################################################################################################
######## ASD Now w iptw.tm and data == ASDKLTabab

library(ipw)
library(cluster)
library(survey)

dim(ASDKLTabab); names(ASDKLTabab); class(ASDKLTabab); print(ASDKLTabab[1:10,c(1:3,62:66)], n=10)
ASDKLTabab$tstart <-  ASDKLTabab$Year - 2007
range(ASDKLTabab$tstart)   # -1, 7
length(ASDKLTabab$tstart)  # 288
table(ASDKLTabab$tstart)   # 36 x 8

ASDKLTabab$tend   <- ASDKLTabab$tstart + 1
table(ASDKLTabab$tend)

summary(ASDKLTabab)
unique(ASDKLTabab$State)

ASDKLTabab2                                                <- ASDKLTabab
ASDKLTabab2$State[ASDKLTabab2$State=="New Jersey"]         <- "New_Jersey"
ASDKLTabab2$State[ASDKLTabab2$State=="New York"]           <- "New_York"
ASDKLTabab2$State[ASDKLTabab2$State=="North Carolina"]     <- "North_Carolina"
ASDKLTabab2$State[ASDKLTabab2$State=="North Dakota"]       <- "North_Dakota"
ASDKLTabab2$State[ASDKLTabab2$State=="South Dakota"]       <- "South_Dakota"
ASDKLTabab2$State[ASDKLTabab2$State=="Rhode Island"]       <- "Rhode_Island"
ASDKLTabab2$State[ASDKLTabab2$State=="West Virginia"]      <- "West_Virginia"
unique(ASDKLTabab2$State)
class(ASDKLTabab2$State)
ASDKLTabab2$State      <- as.factor(ASDKLTabab2$State)
levels(ASDKLTabab2$State)
ASDKLTabab2$StateN <- ASDKLTabab2$State
levels(ASDKLTabab2$StateN)
levels(ASDKLTabab2$StateN) <- 1:36
levels(ASDKLTabab2$StateN)
ASDKLTabab2$StateN     <- as.numeric(as.character(ASDKLTabab2$StateN))
class(ASDKLTabab2$StateN)
names(ASDKLTabab2); glimpse(ASDKLTabab2)

ASDKLTabab2A <- ASDKLTabab2 %>% arrange(Year)
class(ASDKLTabab2A); print(ASDKLTabab2A[,1:4], n=20)

ASDKLTabab2Adf <- as.data.frame(ASDKLTabab2A)

table(ASDKLTabab2Adf$fQQuinnCICI)
ASDKLTabab2Adf$fQQuinnCICIExp <- ASDKLTabab2Adf$fQQuinnCICI -1
table(ASDKLTabab2Adf$fQQuinnCICIExp)

# write_csv(ASDKLTabab2,    "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2.csv")
# write_csv(ASDKLTabab2A,   "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2A.csv")
# write_csv(ASDKLTabab2Adf, "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2Adf.csv")

names(ASDKLTabab2Adf)

##################################################
##################################################
#############  Shaprio's

shapiro.test(ASDKLTabab2Adf$cigmon)
shapiro.test(log(ASDKLTabab2Adf$cigmon))          # Don't 
shapiro.test(ASDKLTabab2Adf$abodalc)
shapiro.test(log(ASDKLTabab2Adf$abodalc))         # Don't
shapiro.test(ASDKLTabab2Adf$mrjmon)
shapiro.test(log(ASDKLTabab2Adf$mrjmon))          # log it
shapiro.test(ASDKLTabab2Adf$anlyr)
shapiro.test(log(ASDKLTabab2Adf$anlyr))           # log it
shapiro.test(ASDKLTabab2Adf$cocyr)
shapiro.test(log(ASDKLTabab2Adf$cocyr))           # log it


shapiro.test(ASDKLTabab2Adf$White)
shapiro.test(log(ASDKLTabab2Adf$White))           # Don't 
shapiro.test(ASDKLTabab2Adf$Black)
shapiro.test(log(ASDKLTabab2Adf$Black))           # log it
shapiro.test(ASDKLTabab2Adf$AIAN)
shapiro.test(log(ASDKLTabab2Adf$AIAN))            # log it
shapiro.test(ASDKLTabab2Adf$MHY)
shapiro.test(log(ASDKLTabab2Adf$MHY))             # log it

shapiro.test(ASDKLTabab2Adf$NHWhiteTCan)
shapiro.test(log(ASDKLTabab2Adf$NHWhiteTCan))     # log it
shapiro.test(ASDKLTabab2Adf$NHBlackTCan)
shapiro.test(log(ASDKLTabab2Adf$NHBlackTCan))     # log it
shapiro.test(ASDKLTabab2Adf$HispanicTCan)
shapiro.test(log(ASDKLTabab2Adf$HispanicTCan))    # log it
shapiro.test(ASDKLTabab2Adf$AsianTCan)
shapiro.test(log(ASDKLTabab2Adf$AsianTCan))       # log it
shapiro.test(ASDKLTabab2Adf$AIANTCan)
shapiro.test(log(ASDKLTabab2Adf$AIANTCan))        # log it
shapiro.test(ASDKLTabab2Adf$NHPITCan)
shapiro.test(log(ASDKLTabab2Adf$NHPITCan))        # log it

##################################################
##################################################
#############  ipwtm
temp <- ipwtm(exposure = mrjmon, family = "gaussian",
              numerator = ~ White + Black + AIAN + MHY + AsPI,
              denominator = ~ White + Black + AIAN + MHY + AsPI + mrjmon,
                # NHWhiteTPPot + NHBlackTPPot + HispanicTPPot + AsianTPPot +
                # AIANTPPot + NHPITPPot + mrjmon,
              tstart = tstart, timevar = tend,
              id = State, corstr=AR1, trunc=NULL, type="all",
              data = ASDKLTabab2Adf)

temp <- ipwtm(exposure = mrjmon, family = "gaussian",
              numerator = ~ 1,
              denominator = ~ 1 +
              NHWhiteTPPot + NHBlackTPPot + HispanicTPPot + AsianTPPot +
              AIANTPPot + NHPITPPot + mrjmon,
              tstart = tstart, timevar = tend,
              id = State, corstr=AR1, type="all",
              data = ASDKLTabab2Adf)

########### FULL MODEL WORKS WELL NOW!!!!
temp <- ipwtm(exposure = mrjmon, family = "gaussian", link="log",
              numerator = ~ White + log(Black) + log(AIAN) + log(MHY),
              denominator = ~ White + log(Black) + log(AIAN) + log(MHY) + log(mrjmon) +
              log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
              log(AIANTPPot) + log(NHPITPPot),
              tstart = tstart, timevar = tend,
              id = StateN, corstr=AR1, trunc=0.01, type="all",
              data = ASDKLTabab2Adf)
summary(temp$ipw.weights)
ipwplot(temp$ipw.weights, data=ASDKLTabab2Adf)

### Now Pasting the Weights to the Dataset

ASDKLTabab2Adf$sw <- temp$ipw.weights

########### Weights Revised!!!!
temp <- ipwtm(exposure = mrjmon, family = "gaussian", link="log",
              numerator = ~ cigmon + abodalc + log(anlyr) + log(cocyr) +
                White + log(Black) + log(AIAN) + log(MHY),
              denominator = ~ cigmon + abodalc + log(anlyr) + log(cocyr) +
                White + log(Black) + log(AIAN) + log(MHY) + log(mrjmon) +
                log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                log(AIANTPPot) + log(NHPITPPot),
              tstart = tstart, timevar = tend,
              id = StateN, corstr=ar1, trunc=0.5, type="all",
              data = ASDKLTabab2AdfaRr)
summary(temp$ipw.weights)
ipwplot(temp$ipw.weights, data=ASDKLTabab2Adf)

### Now Pasting the Weights to the Dataset

ASDKLTabab2Adf$sw <- temp$ipw.weights

########### Now Just Substances
temp <- ipwtm(exposure = mrjmon, family = "gaussian", link="log",
              numerator = ~ cigmon + abodalc + log(anlyr) + log(cocyr),
                # White + log(Black) + log(AIAN) + log(MHY),
              denominator = ~ cigmon + abodalc + log(mrjmon) + log(anlyr) + log(cocyr),
                # White + log(Black) + log(AIAN) + log(MHY) + 
                # log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                # log(AIANTPPot) + log(NHPITPPot),
              tstart = tstart, timevar = tend,
              id = StateN, corstr=AR1, trunc=0.01, type="all",
              data = ASDKLTabab2Adf)
summary(temp$ipw.weights)
ipwplot(temp$ipw.weights, data=ASDKLTabab2Adf)

### Now Pasting the Weights to the Dataset

ASDKLTabab2Adf$swSubs <- temp$ipw.weights



##################################################
##################################################
#############  ipwtm
temp <- ipwtm(exposure = mrjmon, family = "gaussian", link="log",
              numerator = ~ White + Black + AIAN + MHY + AsPI,
              denominator = ~ White + Black + AIAN + MHY + AsPI + mrjmon,
              # NHWhiteTPPot + NHBlackTPPot + HispanicTPPot + AsianTPPot +
              # AIANTPPot + NHPITPPot + mrjmon,
              tstart = tstart, timevar = tend,
              id = StateN, corstr=AR1, trunc=NULL, type="all",
              data = ASDKLTabab2Adfa)

temp <- ipwtm(exposure = mrjmon, family = "gaussian",
              numerator = ~ 1,
              denominator = ~ 1 +
                NHWhiteTPPot + NHBlackTPPot + HispanicTPPot + AsianTPPot +
                AIANTPPot + NHPITPPot + mrjmon,
              tstart = tstart, timevar = tend,
              id = StateN, corstr=AR1, type="all",
              data = ASDKLTabab2Adf)

########### FULL MODEL WORKS WELL NOW!!!!
temp <- ipwtm(exposure = mrjmon, family = "gaussian", link="log",
              numerator = ~ White + log(Black) + log(AIAN) + log(MHY),
              denominator = ~ White + log(Black) + log(AIAN) + log(MHY) + log(mrjmon) +
                log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                log(AIANTPPot) + log(NHPITPPot),
              tstart = tstart, timevar = tend,
              id = StateN, corstr=AR1, trunc=0.1, type="all",
              data = ASDKLTabab2Adf)
summary(temp$ipw.weights)
ipwplot(temp$ipw.weights, data=ASDKLTabab2Adf)

### Now Pasting the Weights to the Dataset

ASDKLTabab2Adf$sw <- temp$ipw.weights

names(ASDKLTabab2Adfa); head(ASDKLTabab2Adfa)

ASDKLTabab2Adfar <- ASDKLTabab2Adfa[,c(69,67,68,1:66,70:78)]
names(ASDKLTabab2Adfar); head(ASDKLTabab2Adfar)

ASDKLTabab2AdfaR <- ASDKLTabab2Adfar[,-1]
names(ASDKLTabab2AdfaR)
ASDKLTabab2AdfaR$State2 <- ASDKLTabab2AdfaR$State
ASDKLTabab2AdfaR$State2 <- as.factor(ASDKLTabab2AdfaR$State2)
levels(ASDKLTabab2AdfaR$State2)
levels(ASDKLTabab2AdfaR$State2) <- 1:36
levels(ASDKLTabab2AdfaR$State2)
class(ASDKLTabab2AdfaR$State2)
ASDKLTabab2AdfaR$fQQuinnCICIExp    <- as.integer(ASDKLTabab2AdfaR$fQQuinnCICIExp)
ASDKLTabab2AdfaR$fQQuinnCIExp      <- as.integer(ASDKLTabab2AdfaR$fQQuinnCIExp)
ASDKLTabab2AdfaR$State2  <- as.numeric(as.character(ASDKLTabab2AdfaR$State2))
unique(ASDKLTabab2AdfaR$State2)
table(ASDKLTabab2AdfaR$State2)
dim(ASDKLTabab2AdfaR)
ASDKLTabab2AdfaRr    <- ASDKLTabab2AdfaR[,c(78,1:77)]
names(ASDKLTabab2AdfaRr)[1] <- "StateN"
ASDKLTabab2AdfaRr$State2 <- as.integer(ASDKLTabab2AdfaRr$StateN)
ASDKLTabab2AdfaRr$StateN <- as.integer(ASDKLTabab2AdfaRr$StateN)
ASDKLTabab2AdfaRr$QQuinnCICI <- as.numeric(as.character(ASDKLTabab2AdfaRr$fQQuinnCICI))
dim(ASDKLTabab2AdfaRr); names(ASDKLTabab2AdfaRr); head(ASDKLTabab2AdfaRr); summary(ASDKLTabab2AdfaRr); glimpse(ASDKLTabab2AdfaRr)


length(ASDKLTabab2AdfaRr$StateN); summary(ASDKLTabab2AdfaRr$StateN); table(ASDKLTabab2AdfaRr$StateN)
class(ASDKLTabab2AdfaRr$StateN); range(ASDKLTabab2AdfaRr$StateN)
class(ASDKLTabab2AdfaRr$mrjmon)

ASDKLTabab2AdfaRrdf <- as.data.frame(ASDKLTabab2AdfaRr)

########### Weights Revised!!!!
temp <- ipwtm(exposure = mrjmon, family = "gaussian", link="log",
              numerator = ~ cigmon + abodalc + log(anlyr) + log(cocyr) +
                White + log(Black) + log(AIAN) + log(MHY),
              denominator = ~ cigmon + abodalc + log(anlyr) + log(cocyr) +
                White + log(Black) + log(AIAN) + log(MHY) + log(mrjmon) +
                log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                log(AIANTPPot) + log(NHPITPPot),
              tstart = tstart, timevar = tend,
              id = StateN, corstr=ar1, trunc=0.01, type="all",
              data = ASDKLTabab2AdfaRrdf)

temp <- ipwtm(exposure = mrjmon, family = "gaussian", link="log",
              numerator = ~ cigmon + abodalc + (anlyr) + (cocyr) +
                White + (Black) + (AIAN) + (MHY),
              denominator = ~ cigmon + abodalc + (anlyr) + (cocyr) +
                White + (Black) + (AIAN) + (MHY) + 
                (NHWhiteTPPot) + (NHBlackTPPot) + (HispanicTPPot) + (AsianTPPot) +
                (AIANTPPot) + (NHPITPPot),
              tstart = tstart, timevar = tend,
              id = StateN, corstr=ar1, trunc=0.03, type="all",
              data = ASDKLTabab2AdfaRrdf)

summary(temp$ipw.weights)
summary(temp$weights.trunc)
ipwplot(temp$ipw.weights)
ipwplot(temp$weights.trunc)
ipwplot(temp$weights.trunc, add=TRUE)
plot(temp$ipw.weights, size=2, pch=2)
plot(temp$weights.trunc, add=TRUE, col='red', type="l", lty=2)
plot(temp$ipw.weights)

ipwplot(c(temp$ipw.weights, temp$weights.trunc), lty=c(1,2))


ASDKLTabab2AdfaRrdf$TrW02 <- temp$weights.trunc
ASDKLTabab2AdfaRrdf$sw3   <- temp$ipw.weights

# write_csv(ASDKLTabab2AdfaRrdf, "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2AdfaRrdf.csv")



temp <- ipwtm(exposure = mrjmon, family = "gaussian", link="log",
              numerator = ~ cigmon,
              denominator = ~ cigmon + mrjmon,
              tstart = tstart, timevar = tend,
              id = id, corstr=AR1, trunc=0.01, type="all",
              data = ASDKLTabab2AdfaRr_)


ASDKLTabab2AdfaRr_ <- ASDKLTabab2AdfaRr
names(ASDKLTabab2AdfaRr_)[1] <- "id"
names(ASDKLTabab2AdfaRr_); head(ASDKLTabab2AdfaRr_)

summary(sqrt(ASDKLTabab2AdfaRr_$mrjmon))
hist(sqrt(ASDKLTabab2AdfaRr_$mrjmon))
hist((ASDKLTabab2AdfaRr_$mrjmon))
is.vector(ASDKLTabab2AdfaRr_$mrjmon)   # TRUE
is.numeric(ASDKLTabab2AdfaRr_$mrjmon)  # TRUE
is.numeric(ASDKLTabab2AdfaRr_$cigmon)  # TRUE
is.vector(ASDKLTabab2AdfaRr_$cigmon)   # TRUE
is.integer(ASDKLTabab2AdfaRr_$id)      # TRUE
hist(log(ASDKLTabab2AdfaRr_$mrjmon))
class(ASDKLTabab2AdfaRr_$mrjmon)
table(ASDKLTabab2AdfaRr_$fQQuinnCICIExp)
class(ASDKLTabab2AdfaRr_$fQQuinnCICIExp)
ASDKLTabab2AdfaRr_$fQQuinnCICIExp  <- as.numeric(ASDKLTabab2AdfaRr_$fQQuinnCICIExp)


temp <- ipwpoint(exposure = mrjmon, family = "gaussian", link="log",
              numerator = ~ cigmon + abodalc + log(anlyr) + log(cocyr) +
                White + log(Black) + log(AIAN) + log(MHY),
              denominator = ~ cigmon + abodalc + log(anlyr) + log(cocyr) +
                White + log(Black) + log(AIAN) + log(MHY) + log(mrjmon) +
                log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                log(AIANTPPot) + log(NHPITPPot),
              # tstart = tstart, timevar = tend,
              # corstr=ar1, type="all", id = id,  
              trunc=0.01, 
              data = ASDKLTabab2AdfaRr_)

temp <- ipwpoint(exposure = fQQuinnCICIExp, family = "binomial", link="logit",
                 numerator = ~ cigmon + abodalc + log(anlyr) + log(cocyr) +
                   White + log(Black) + log(AIAN) + log(MHY),
                 denominator = ~ cigmon + abodalc + log(anlyr) + log(cocyr) +
                   White + log(Black) + log(AIAN) + log(MHY) + log(mrjmon) +
                   log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                   log(AIANTPPot) + log(NHPITPPot),
                 # tstart = tstart, timevar = tend,
                 # corstr=ar1, type="all", id = id,  
                 trunc=0.01, 
                 data = ASDKLTabab2AdfaRr_)



temp <- ipwpoint(exposure = mrjmon, family = "gaussian", 
                 numerator = ~ cigmon,
                 denominator = ~ cigmon + mrjmon,
                 trunc=0.01, 
                 data = ASDKLTabab2AdfaRr_)
#

temp <- ipwtm(exposure = mrjmon, family = "gaussian", 
                 numerator = ~ cigmon,
                 denominator = ~ cigmon + mrjmon,
                 tstart = tstart, timevar = tend,
                 corstr=ar1, type="all", id = id,
                 trunc=0.01, 
                 data = ASDKLTabab2AdfaRr_)
#


ASDKLTabab2AdfaRr_s <- ASDKLTabab2AdfaRr_[,c(1:6,12,14,71)]
ASDKLTabab2AdfaRr_s$id <- as.integer(ASDKLTabab2AdfaRr_s$id)
ASDKLTabab2AdfaRr_s$fQQuinnCICIExp_Int  <- as.integer(ASDKLTabab2AdfaRr_s$fQQuinnCICIExp)
ASDKLTabab2AdfaRr_s$fQQuinnCICIExp_Fac  <- as.factor (ASDKLTabab2AdfaRr_s$fQQuinnCICIExp)
glimpse(ASDKLTabab2AdfaRr_s)

class(ASDKLTabab2AdfaRr_s)
ASDKLTabab2AdfaRr_sdf <- as.data.frame(ASDKLTabab2AdfaRr_s)

# write_csv(ASDKLTabab2AdfaRr_,  "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2AdfaRr_.csv")
# write_csv(ASDKLTabab2AdfaRr_s, "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2AdfaRr_s.csv")

tempP <- ipwpoint(exposure = mrjmon, family = "gaussian", 
                 numerator = ~ cigmon,
                 denominator = ~ cigmon + mrjmon,
                 trunc=0.01, 
                 data = ASDKLTabab2AdfaRr_sdf)
#

tempT <- ipwtm(exposure = mrjmon, family = "gaussian", 
              numerator = ~ cigmon,
              denominator = ~ cigmon + ASDRt,
              tstart = tstart, timevar = tend,
              corstr=ar1, type="all", id = id,
              trunc=0.01, 
              data = ASDKLTabab2AdfaRr_sdf)
#


tempP <- ipwpoint(exposure = fQQuinnCICIExp_Fac, family = "binomial", link="probit", 
                 numerator = ~ cigmon,
                 denominator = ~ cigmon + mrjmon,
                 trunc=0.01, 
                 data = ASDKLTabab2AdfaRr_sdf)
#

tempT <- ipwtm(exposure = fQQuinnCICIExp_Int, family = "binomial", link="probit",
              numerator = ~ cigmon,
              denominator = ~ cigmon + ASDRt,
              tstart = tstart, timevar = tend,
              corstr=ar1, type="all", id = id,
              trunc=0.01, 
              data = ASDKLTabab2AdfaRr_sdf)
#


# https://stackoverflow.com/questions/54202834/how-to-set-r-formula-programmatically

f1 <- f.build("ASDKLTabab2AdfaRr_s$mrjmon", c("ASDKLTabab2AdfaRr_s$cigmon"))

f1 <- ASDKLTabab2AdfaRr_s$mrjmon ~ ASDKLTabab2AdfaRr_s$cigmon
w.out <- weightit(f1, data = ASDKLTabab2AdfaRr_s, estimand = "ATE")
w.out2 <- trim(w.out, .01, lower = TRUE)

summary(w.out)
summary(w.out)
bal.tab(w.out)
bal.tab(w.out2)

plot(w.out)
str(w.out, max.level=2)
ipwplot(w.out)


### Now Pasting the Weights to the Dataset

ASDKLTabab2Adf$sw <- temp$ipw.weights

##################################################
##################################################
#############  MSM's  for ipwpoint's

msm <- (svyglm(log(ASDRt) ~ mrjmon, design = svydesign (~1, weights = ~ sw, data= ASDKLTabab2Adf)))
summary(msm)

msm <- (svyglm(log(ASDRt) ~ mrjmon +White + Black + AIAN + MHY + mrjmon +
                 NHWhiteTPPot + NHBlackTPPot + HispanicTPPot + AsianTPPot +
                 AIANTPPot + NHPITPPot,
               design = svydesign (~1, weights = ~ sw, data= ASDKLTabab2Adf)))
summary(msm)

msm <- (svyglm(log(ASDRt) ~ mrjmon + anlyr + cocyr + abodalc + cigmon +
                 White + Black + AIAN + MHY + mrjmon +
                 NHWhiteTPPot + NHBlackTPPot + HispanicTPPot + AsianTPPot +
                 AIANTPPot + NHPITPPot,
               design = svydesign (~1, weights = ~ sw, data= ASDKLTabab2Adf)))
summary(msm)

msm <- (svyglm(log(ASDRt) ~ log(mrjmon) + log(anlyr) + log(cocyr) + abodalc + cigmon +
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
                 log(AIANTCan) + log(NHPITCan),
               design = svydesign (~1, weights = ~ sw, data= ASDKLTabab2Adf)))
summary(msm)

      msm <- (svyglm(log(ASDRt) ~ log(anlyr) + cigmon +
                                  log(Black) + log(AIAN) + log(MHY) + 
                                  log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan),
                              design = svydesign (~1, weights = ~ sw, data= ASDKLTabab2Adf)))
             summary(msm)

## This Time Conditioning on Lower 3 Quintiles v Upper 2 Quintiles  and Multiplying Both Weights           

tempExp <- ipwtm(exposure = fQQuinnCICIExp, family = "binomial", link="logit",
                 numerator = ~ White + log(Black) + log(AIAN) + log(MHY),
                   denominator = ~ White + log(Black) + log(AIAN) + log(MHY) + log(mrjmon) +
                   log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                   log(AIANTPPot) + log(NHPITPPot),
                   tstart = tstart, timevar = tend,
                   id = StateN, corstr=AR1, trunc=0.05, type="all",
                   data = ASDKLTabab2Adf)
summary(tempExp$ipw.weights)
ipwplot(tempExp$ipw.weights, data=ASDKLTabab2Adf)
ASDKLTabab2Adf$sw2 <- tempExp$ipw.weights

#### New MSM w weights as product
summary(svyglm(log(ASDRt) ~ log(mrjmon) + log(anlyr) + log(cocyr) + abodalc + cigmon +
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
                 log(AIANTCan) + log(NHPITCan),
               design = svydesign (~1, weights = ~ sw * sw2, data= ASDKLTabab2Adf)))
   summary(svyglm(log(ASDRt) ~  log(anlyr) +  abodalc + cigmon +
                                       White + log(Black) + 
                                       log(NHWhiteTCan),
                                     design = svydesign (~1, weights = ~ sw * sw2, data= ASDKLTabab2Adf)))
       summary(svyglm(log(ASDRt) ~  abodalc + cigmon +
                                        White + log(Black),
                                      design = svydesign (~1, weights = ~ sw * sw2, data= ASDKLTabab2Adf)))
       summary(svyglm(log(ASDRt) ~  abodalc + cigmon +
                  White + log(Black),
                design = svydesign (~1, weights = ~ sw * sw2, data= ASDKLTabab2Adf)))

   
###############################################################
###############################################################
###############################################################
##############  Now lme's
library(nlme)   

# Conditioned on Weights 
# Very Impressive Final Output Additive Model
summary(lme(log(ASDRt) ~ log(mrjmon) + log(anlyr) + log(cocyr) + abodalc + cigmon +
                    White + log(Black) + log(AIAN) + log(MHY) + 
                    log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
                    log(AIANTCan) + log(NHPITCan),
                  weights = ~ sw, random = ~ 1| State,  data= ASDKLTabab2Adf))
       summary(lme(log(ASDRt) ~ log(anlyr) + log(cocyr) + abodalc + cigmon +
                                   White +  log(MHY) + 
                                   log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + 
                                   log(AIANTCan) + log(NHPITCan),
                               weights = ~ sw, random = ~ 1| State,  data= ASDKLTabab2Adf))
       lme1 <- lme(log(ASDRt) ~ log(anlyr) + log(cocyr) + abodalc + cigmon +
                     White +  log(MHY) + 
                     log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + 
                     log(AIANTCan) + log(NHPITCan),
                   weights = ~ sw, random = ~ 1| State,  data= ASDKLTabab2Adf)


# Conditioned on Cannabis Quintile weights
summary(lme(log(ASDRt) ~ log(mrjmon) + log(anlyr) + log(cocyr) + abodalc + cigmon +
              White + log(Black) + log(AIAN) + log(MHY) + 
              log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
              log(AIANTCan) + log(NHPITCan),
            weights = ~ sw2, random = ~ 1| State,  data= ASDKLTabab2Adf))
     summary(lme(log(ASDRt) ~ log(mrjmon) + log(anlyr) + log(cocyr) + abodalc + cigmon +
                             White +log(AIAN) + log(MHY) + 
                             log(NHWhiteTCan) + log(HispanicTCan) + log(AsianTCan) +
                             log(AIANTCan) + log(NHPITCan),
                          weights = ~ sw2, random = ~ 1| State,  data= ASDKLTabab2Adf))
     lme2 <- lme(log(ASDRt) ~ log(mrjmon) + log(anlyr) + log(cocyr) + abodalc + cigmon +
                   White +log(AIAN) + log(MHY) + 
                   log(NHWhiteTCan) + log(HispanicTCan) + log(AsianTCan) +
                   log(AIANTCan) + log(NHPITCan),
                 weights = ~ sw2, random = ~ 1| State,  data= ASDKLTabab2Adf)

# (( Conditioned on Cannabis Quintile weights * sw Product ))
summary(lme(log(ASDRt) ~ log(mrjmon) + log(anlyr) + log(cocyr) + abodalc + cigmon +
              White + log(Black) + log(AIAN) + log(MHY) + 
              log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
              log(AIANTCan) + log(NHPITCan), 
            weights = ~ sw * sw2, random = ~ 1| State,  data= ASDKLTabab2Adf))
    summary(lme(log(ASDRt) ~  log(anlyr) + log(cocyr) + abodalc + cigmon +
                              log(Black) + log(AIAN) + log(MHY) + 
                             log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
                             log(AIANTCan),
                         weights = ~ sw * sw2, random = ~ 1| State,  data= ASDKLTabab2Adf))
    lme3 <- lme(log(ASDRt) ~  log(anlyr) + log(cocyr) + abodalc + cigmon +
                  log(Black) + log(AIAN) + log(MHY) + 
                  log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
                  log(AIANTCan),
                weights = ~ sw * sw2, random = ~ 1| State,  data= ASDKLTabab2Adf)
   

anova(lme1, lme2, lme3)   


# Now Same w/o Weights - Native lme
summary(lme(log(ASDRt) ~ log(mrjmon) + log(anlyr) + log(cocyr) + abodalc + cigmon +
              White + log(Black) + log(AIAN) + log(MHY) + 
              log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
              log(AIANTCan) + log(NHPITCan),
           random = ~ 1| State,  data= ASDKLTabab2Adf))
      summary(lme(log(ASDRt) ~  log(anlyr) +  cigmon +
                             log(NHWhiteTCan) ,
                        random = ~ 1| State,  data= ASDKLTabab2Adf))
      lme4 <- lme(log(ASDRt) ~  log(anlyr) +  cigmon +
            log(NHWhiteTCan) ,
          random = ~ 1| State,  data= ASDKLTabab2Adf)

anova(lme2, lme4)
            

############
############ VERY IMPRESSIVE FINAL OUTPUT ADDITIVE  MODEL
############ lme's
############ Now w lme w Revised Weights
summary(lme(log(ASDRt) ~ cigmon + abodalc + log(mrjmon) + log(anlyr) + log(cocyr) +
              White + log(Black) + log(AIAN) + log(MHY) + 
              log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
              log(AIANTPPot) + log(NHPITPPot),
            random = ~ 1| State,  weights = ~ sw, data= ASDKLTabab2Adf))
     summary(lme(log(ASDRt) ~ cigmon + abodalc +  log(anlyr) + log(cocyr) +
                             White +  log(MHY) + 
                             log(NHWhiteTPPot) + log(NHBlackTPPot) + log(NHPITPPot),
                         random = ~ 1| State,  weights = ~ sw, data= ASDKLTabab2Adf))
     lme5 <- lme(log(ASDRt) ~ cigmon + abodalc +  log(anlyr) + log(cocyr) +
                   White +  log(MHY) + 
                   log(NHWhiteTPPot) + log(NHBlackTPPot) + log(NHPITPPot),
                 random = ~ 1| State,  weights = ~ sw, data= ASDKLTabab2Adf)

     
############
############ VERY IMPRESSIVE FINAL OUTPUT ADDITIVE  MODEL - svyglm's
############  svyglm's
############

### Additive svyglm     
summary(svyglm(log(ASDRt) ~ cigmon + abodalc + log(mrjmon) + log(anlyr) + log(cocyr) +
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                 log(AIANTPPot) + log(NHPITPPot),
                    design = svydesign (~1, weights = ~ sw, data= ASDKLTabab2Adf)))
       summary(svyglm(log(ASDRt) ~ cigmon + abodalc + 
                                   White + log(Black) + log(AIAN) +  
                                   log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) +
                                   log(AIANTPPot) ,
                                    design = svydesign (~1, weights = ~ sw, data= ASDKLTabab2Adf)))
       svyglmAdd <- svyglm(log(ASDRt) ~ cigmon + abodalc + 
                             White + log(Black) + log(AIAN) +  
                             log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) +
                             log(AIANTPPot) ,
                           design = svydesign (~1, weights = ~ sw, data= ASDKLTabab2Adf))
       svyglmAdd$aic   # 1708.068

### Interactive svyglm     
summary(svyglm(log(ASDRt) ~ cigmon * log(mrjmon) * abodalc + log(anlyr) + log(cocyr) +
                        White + log(Black) + log(AIAN) + log(MHY) + 
                        log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                        log(AIANTPPot) + log(NHPITPPot),
                      design = svydesign (~1, weights = ~ sw, data= ASDKLTabab2Adf)))
       summary(svyglm(log(ASDRt) ~ cigmon * log(mrjmon) * abodalc +
                                          White + log(Black) +  
                                          log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) +
                                          log(AIANTPPot) - log(mrjmon):abodalc-abodalc,
                                        design = svydesign (~1, weights = ~ sw, data= ASDKLTabab2Adf)))
       svyglmIR <- svyglm(log(ASDRt) ~ cigmon * log(mrjmon) * abodalc +
                            White + log(Black) +  
                            log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) +
                            log(AIANTPPot) - log(mrjmon):abodalc-abodalc,
                          design = svydesign (~1, weights = ~ sw, data= ASDKLTabab2Adf))
       svyglmIR$aic  # 1650.112

# https://rdrr.io/rforge/survey/man/anova.svyglm.html
       
anova(object=svyglmAdd, object2 = svyglmIR, test = c("F"), 
             method = c("Wald"), tolerance = 1e-05, force=TRUE)

       
svyglmAddInit <- svyglm(log(ASDRt) ~ cigmon + abodalc + log(mrjmon) + log(anlyr) + log(cocyr) +
         White + log(Black) + log(AIAN) + log(MHY) + 
         log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
         log(AIANTPPot) + log(NHPITPPot),
       design = svydesign (~1, weights = ~ sw, data= ASDKLTabab2Adf))

svyglmIRInit <- svyglm(log(ASDRt) ~ cigmon * log(mrjmon) * abodalc + log(anlyr) + log(cocyr) +
         White + log(Black) + log(AIAN) + log(MHY) + 
         log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
         log(AIANTPPot) + log(NHPITPPot),
       design = svydesign (~1, weights = ~ sw, data= ASDKLTabab2Adf))

# Initial v Final Additive Models
anova(object=svyglmAddInit, object2 = svyglmIRInit, test = c("F", "Chisq"), 
      method = c("Wald"), tolerance = 1e-05, force=TRUE)          # F =  4.188203  on  4  and  268  df: p= 0.0026299 

       
##############################################################################################
##############################################################################################
##############################################################################################
############################################# FINAL IR'v MODEL    
########################### lme's
############ Now w cigmon * mrjmon * abodalc Interactions
summary(lme(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) + log(anlyr) + log(cocyr) +
                   White + log(Black) + log(AIAN) + log(MHY) + 
                   log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                   log(AIANTPPot) + log(NHPITPPot),
                 random = ~ 1| State,  weights = ~ sw, data= ASDKLTabab2Adf))
       summary(lme(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) + log(anlyr) + 
                                  White + log(Black) + log(MHY) + 
                                  log(NHWhiteTPPot) + log(NHBlackTPPot) + log(NHPITPPot),
                              random = ~ 1| State,  weights = ~ sw, data= ASDKLTabab2Adf))
       lme6 <- lme(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) + log(anlyr) + 
                     White + log(Black) + log(MHY) + 
                     log(NHWhiteTPPot) + log(NHBlackTPPot) + log(NHPITPPot),
                   random = ~ 1| State,  weights = ~ sw, data= ASDKLTabab2Adf)
       

anova(lme5, lme6)

##############################################################################################
##############################################################################################
##############################################################################################
############################################# FINAL IR'v MODEL  - Re-Do  
########################### lme's
############ Now w cigmon * mrjmon * abodalc Interactions
summary(lme(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) + log(anlyr) + log(cocyr) +
                   White + log(Black) + log(AIAN) + log(MHY) + 
                   log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                   log(AIANTPPot) + log(NHPITPPot),
                 random = ~ 1| State,  weights = ~ sw3, data= ASDKLTabab2AdfaRrdf))
       summary(lme(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) + log(anlyr) + log(cocyr) +
                    White + log(AIAN) + log(MHY) + 
                    log(NHWhiteTPPot) + log(NHBlackTPPot) + log(NHPITPPot)-abodalc:log(mrjmon)- log(mrjmon)-abodalc-cigmon,
                  random = ~ 1| State,  weights = ~ sw3, data= ASDKLTabab2AdfaRrdf))

       
       
1406.327-1347.322
pchisq(59.005, 5, lower.tail = F)     
     
     
############ Now lme Just on Susbtances 
     # temp <- ipwtm(exposure = mrjmon, family = "gaussian", link="log",
     #               numerator = ~ cigmon + abodalc + log(anlyr) + log(cocyr),
     #               # White + log(Black) + log(AIAN) + log(MHY),
     #               denominator = ~ cigmon + abodalc + log(mrjmon) + log(anlyr) + log(cocyr),

summary(lme(log(ASDRt) ~ cigmon + abodalc + log(mrjmon) + log(anlyr) + log(cocyr),
                         random = ~ 1| State,  weights = ~ swSubs, data= ASDKLTabab2Adf))
                   
##################################################
##################################################
#############  ipwpoint


temp <- ipwpoint(exposure=mrjmon, family="gaussian", link="log",
                 numerator= ~1, denominator = ~1,
                 data=ASDKLTabab2Adf)

temp <- ipwpoint(exposure=mrjmon, family="gaussian", link="log",
                 numerator= ~ White + Black, 
                 denominator = ~ White + Black + mrjmon,
                 data=ASDKLTabab2Adf)

temp <- ipwpoint(exposure=mrjmon, family="gaussian", link="log",
                 numerator= ~ MHY, 
                 denominator = ~ MHY + mrjmon,
                 data=ASDKLTabab2Adf)

temp <- ipwpoint(exposure=mrjmon, family="gaussian", link="log",
                 numerator = ~ White + Black + AIAN + MHY + AsPI,
                 denominator = ~ White + Black + AIAN + MHY + AsPI + mrjmon +
                 NHWhiteTPPot + NHBlackTPPot + HispanicTPPot + AsianTPPot +
                 AIANTPPot + NHPITPPot + mrjmon,
                 data=ASDKLTabab2Adf)

summary(temp$num.mod)
summary(temp$den.mod)
summary(temp$ipw.weights)

temptr <- ipwpoint(exposure=mrjmon, family="gaussian", link="log",
                 numerator = ~ White + Black + AIAN + MHY + AsPI,
                 denominator = ~ White + Black + AIAN + MHY + AsPI + mrjmon +
                   NHWhiteTPPot + NHBlackTPPot + HispanicTPPot + AsianTPPot +
                   AIANTPPot + NHPITPPot + mrjmon, trunc=0.04,
                 data=ASDKLTabab2Adf)
summary(temptr$ipw.weights)


ipwplot(temp$ipw.weights, data=ASDKLTabab2Adf)
ipwplot(temptr$ipw.weights, data=ASDKLTabab2Adf)



##############################################################################################
##############################################################################################
############################################# plm Models

### Multivariable Analysis        
# 0 lags - 3-Way IR - No IV's
summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+log(cocyr)+
              MHY + White + log(Black) + log(AIAN) + log(AsPI),
            data=ASDRaw,model="pooling",effect="twoways",
            random.method="swar"))

     summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc-cigmon:log(mrjmon):abodalc+
              MHY +log(Black)-log(mrjmon):abodalc,
            data=ASDRaw,model="pooling",effect="twoways",
            random.method="swar"))

names(ASDRaw)
ASDRaw$StateN           <- ASDRaw$State
ASDRaw$StateN           <- as.factor(ASDRaw$StateN)
levels(ASDRaw$StateN)
length(levels(ASDRaw$StateN))
levels(ASDRaw$StateN)   <- 1:36
ASDRaw$StateN           <- as.numeric(as.character(ASDRaw$StateN))
unique(ASDRaw$StateN)
class(ASDRaw$StateN)
class(ASDRaw$StateN)
table(ASDRaw$StateN)

range(ASDRaw$Year)
class(ASDRaw$Year)
table(ASDRaw$Year)
table(table((ASDRaw$ASDRt), ASDRaw$Year))

ASDRawC <- ASDRaw %>% 
  group_by(Year) %>%
  summarise(ASDRtCount = length(na.omit(ASDRt)))
ASDRawC
dim(ASDRaw); head(ASDRaw)

ASDRawna <- subset(ASDRaw, ASDRt !="NA" & mrjmon!="NA")
dim(ASDRawna); names(ASDRawna); head(ASDRawna, 20)

ASDRawna$tstart  <- as.numeric(ASDRawna$Year - 1989)
ASDRawna$tend    <- as.numeric(ASDRawna$tstart + 1)
range(ASDRawna$tstart)
range(ASDRawna$tend)
class(ASDRawna$tstart)
class(ASDRawna$tend)

summary(ASDRawna$mrjmon)

class(ASDRawna)

ASDRawnadf <- as.data.frame(ASDRawna)
names(ASDRawnadf)

# write_csv(ASDRawna, "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDRawna.csv")

########### Weights Revised!!!!
tempplm <- ipwtm(exposure = mrjmon, family = "gaussian", link="log",
                   numerator = ~ cigmon + bngalc + log(anlyr) + log(cocyr) +
                     White + log(Black) + log(AIAN) + log(MHY),
                   denominator = ~ cigmon + bngalc + log(anlyr) + log(cocyr) +
                     White + log(Black) + log(AIAN) + log(MHY) + log(mrjmon) +
                     log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                     log(AIANTPPot) + log(NHPITPPot),
                   tstart = tstart, timevar = tend,
                   id = StateN, corstr=AR1, trunc=0.01, type="all",
                   data = ASDRawnadf)
summary(tempplm$ipw.weights)
ipwplot(tempplm$ipw.weights, data=ASDKLTabab2Adf)
     
### Now Pasting the Weights to the Dataset
     
ASDRawnadf$sw <- tempplm$ipw.weights

#### Unweighted Regression
summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+log(cocyr)+
              log(MHY) + White + log(Black) + log(AIAN) + log(AsPI),
            data=ASDRawnadf,model="pooling",effect="twoways", weights=sw,
            random.method="swar"))
     summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc-cigmon:log(mrjmon):abodalc+
              log(MHY) +log(Black)-log(mrjmon):abodalc,
            data=ASDRaw,model="pooling",effect="twoways",
            random.method="swar"))
     plm1 <- plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc-cigmon:log(mrjmon):abodalc+
                   log(MHY) +log(Black)-log(mrjmon):abodalc,
                 data=ASDRaw,model="pooling",effect="twoways",
                 random.method="swar")
     logLik(plm1)

### Weighted Regression
summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+log(cocyr)+
              log(MHY) + White + log(Black) + log(AIAN) + log(AsPI),
            data=ASDRawnadf,model="pooling",effect="twoways", weights=sw,
            random.method="swar"))
     summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+
                             White + log(Black)-cigmon:log(mrjmon):abodalc-log(mrjmon):abodalc,
                         data=ASDRawnadf,model="pooling",effect="twoways", weights=sw,
                         random.method="swar"))
     plm2 <- plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+
                   White + log(Black)-cigmon:log(mrjmon):abodalc-log(mrjmon):abodalc,
                 data=ASDRawnadf,model="pooling",effect="twoways", weights=sw,
                 random.method="swar")

     anova(plm1, plm2)

library(lme4)

     BIC(plm1, plm2)
     
     
     
### Weighted Regression - Re-Visited
# Weights not Implemented for IV Models
# summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+log(cocyr)+
#               log(MHY) + White + log(Black) + log(AIAN) + log(AsPI) |
#               -log(mrjmon) + log(NHWhiteTPPot)+log(NHBlackTPPot)+log(HispanicTPPot)+
#               log(AsianTPPot)+log(AIANTPPot)+log(NHPITPPot),
#             data=ASDKLTabab2AdfaRrdf, model="pooling",effect="twoways", weights=sw3,
#             random.method="swar"))   

### Weighted plm Regression
summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+log(cocyr)+
              log(MHY) + White + log(Black) + log(AIAN) + log(AsPI) +
              log(NHWhiteTPPot)+log(NHBlackTPPot)+log(HispanicTPPot) +
              log(AsianTPPot)+log(AIANTPPot)+log(NHPITPPot),
            data=ASDKLTabab2AdfaRrdf, model="pooling",effect="twoways", weights=sw3,
            random.method="swar"))   
    summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+
               log(Black) + log(AIAN) + log(AsPI) +
               log(NHWhiteTPPot)+log(HispanicTPPot),
             data=ASDKLTabab2AdfaRrdf, model="pooling",effect="twoways", weights=sw3,
             random.method="swar")) 
    plm61 <- plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+
               log(Black) + log(AIAN) + log(AsPI) +
               log(NHWhiteTPPot)+log(HispanicTPPot),
             data=ASDKLTabab2AdfaRrdf, model="pooling",effect="twoways", weights=sw3,
             random.method="swar")

### Un-Weighted plm Regression
summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+log(cocyr)+
              log(MHY) + White + log(Black) + log(AIAN) + log(AsPI) +
              log(NHWhiteTPPot)+log(NHBlackTPPot)+log(HispanicTPPot) +
              log(AsianTPPot)+log(AIANTPPot)+log(NHPITPPot),
            data=ASDKLTabab2AdfaRrdf, model="pooling",effect="twoways", 
            random.method="swar"))   
summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+
               log(MHY) + log(Black)- log(NHBlackTPPot)-cigmon:log(mrjmon):abodalc-log(mrjmon):abodalc,
             data=ASDKLTabab2AdfaRrdf, model="pooling",effect="twoways", 
             random.method="swar"))  
    plm51 <- plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+
               log(MHY) + log(Black)- log(NHBlackTPPot)-cigmon:log(mrjmon):abodalc-log(mrjmon):abodalc,
             data=ASDKLTabab2AdfaRrdf, model="pooling",effect="twoways", 
             random.method="swar")

    BIC(plm51, plm61)
    anova(plm51, plm61)





summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+log(cocyr)+
              log(MHY) + White + log(Black) + log(AIAN) + log(AsPI),
            data=ASDKLTabab2AdfaRrdf, model="within",effect="twoways", weights=sw3,
            random.method="swar"))   

summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+log(cocyr)+
              log(MHY) + White + log(Black) + log(AIAN) + log(AsPI),
            data=ASDKLTabab2AdfaRrdf, model="random",effect="twoways", weights=sw3,
            random.method="swar"))  
     
     
     
     
     
     
     

# https://stats.stackexchange.com/questions/131401/how-to-get-anova-table-with-robust-standard-errors

library(car)
library(sandwich)
library(lmtest)
     
     waldtest(plm1, plm2, vcov=vcovHC)

## Un-Reduced Models
plmWt <- plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+log(cocyr)+
                   log(MHY) + White + log(Black) + log(AIAN) + log(AsPI),
                 data=ASDRawnadf,model="pooling",effect="twoways", weights=sw,
                 random.method="swar")

plmUwt <- plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+log(cocyr)+
              log(MHY) + White + log(Black) + log(AIAN) + log(AsPI),
            data=ASDRawnadf,model="pooling",effect="twoways",
            random.method="swar")

waldtest(plmUwt, plmWt, vcov=vcovHC)



###############################################################
###############################################################
################################ Now Panel Regression w IV's
### Un-Weighted Regression IR w IV's
summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+log(cocyr)+   
              White+log(Black)+log(AsPI)+log(AIAN)|
              . -White-log(Black) -log(AsPI) -log(AIAN)
            + log(NHWhiteTPPot) + log(NHBlackTPPot) + 
              log(AsianTPPot) + log(AIANTPPot) -
              log(mrjmon) + log(THCRt) + log(CBGRt),
            data=ASDRawnadf,model="pooling",effect="twoways", 
            random.method="swar"))

     summary(plm(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc-
                            cigmon-abodalc-log(mrjmon):abodalc-log(mrjmon)|
                             . -White-log(Black) -log(AsPI) -log(AIAN)
                         + log(NHWhiteTPPot) + log(NHBlackTPPot) + 
                             log(AsianTPPot) + log(AIANTPPot) -
                             log(mrjmon) + log(THCRt) + log(CBGRt),
                         data=ASDRawnadf,model="pooling",effect="twoways", 
                         random.method="swar"))

##############################################################################################
##############################################################################################
############################################# spreml Models

####################### Imported Models from ASD7.R
#### Drugs & Race      
# 0 Lags      
summary(spreml(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+log(cocyr)+   
                 White+log(Black)+log(AsPI)+log(AIAN)|
                 . -White-log(Black) -log(AsPI) -log(AIAN)
               + log(NHWhiteTPPot) + log(NHBlackTPPot) + 
                 log(AsianTPPot) + log(AIANTPPot) -
                 log(mrjmon) + log(THCRt) + log(CBGRt),
               data = ASDKLTab, w = ASDKLsf11.lww, w2 = ASDKLsf11.lww,
               lag=TRUE, errors = "sem2srre", method="BFGS", initval = "zeros")) 

      summary(spreml(log(ASDRt) ~ cigmon*log(mrjmon)+log(cocyr)-cigmon|
                 . -White-log(Black) -log(AsPI) -log(AIAN)
               + log(NHWhiteTPPot) + log(NHBlackTPPot) + 
                 log(AsianTPPot) + log(AIANTPPot) -
                 log(mrjmon) + log(THCRt) + log(CBGRt),
               data = ASDKLTab, w = ASDKLsf11.lww, w2 = ASDKLsf11.lww,
               lag=TRUE, errors = "sem2srre", method="BFGS", initval = "zeros")) 

#### New Worked Up Models
#### Drugs & Race      
# 0 Lags      
summary(spreml(log(ASDRt) ~ cigmon*log(mrjmon)*abodalc+log(anlyr)+log(cocyr)+   
                       White+log(Black)+log(AsPI)+log(AIAN)|
                       . -White-log(Black) -log(AsPI) -log(AIAN)
                     + log(NHWhiteTPPot) + log(NHBlackTPPot) + 
                       log(AsianTPPot) + log(AIANTPPot) -
                       log(mrjmon) + log(THCRt) + log(CBGRt),
                     data = ASDKLTabab2Adf, w = ASDKLsf11.lww, w2 = ASDKLsf11.lww,
                     lag=TRUE, errors = "sem2srre", method="BFGS", initval = "zeros")) 
      
      summary(spreml(log(ASDRt) ~ cigmon*log(mrjmon)+log(cocyr)-cigmon|
                       . -White-log(Black) -log(AsPI) -log(AIAN)
                     + log(NHWhiteTPPot) + log(NHBlackTPPot) + 
                       log(AsianTPPot) + log(AIANTPPot) -
                       log(mrjmon) + log(THCRt) + log(CBGRt),
                     data = ASDKLTabab2Adf, w = ASDKLsf11.lww * sw, w2 = ASDKLsf11.lww,
                     lag=TRUE, errors = "sem2srre", method="BFGS", initval = "zeros")) 


##############################################################################################
##############################################################################################
############################################# geom_ellipse    
      
stat_ellipse(
        mapping = NULL,
        data = NULL,
        geom = "path",
        position = "identity",
        # ...,
        type = "t",
        level = 0.95,
        segments = 51,
        na.rm = FALSE,
        show.legend = NA,
        inherit.aes = TRUE
)

dim(ASDRaw); names(ASDRaw); length(na.omit(ASDRaw$ASDRt)) # 338

ASDRaw$QQuinCI           <- cut_interval(ASDRaw$mrjmon, 5)
ASDRaw$QQuinnCI          <- ASDRaw$QQuinCI
levels(ASDRaw$QQuinnCI)  <- 1:5
ASDRaw$QQuinnCICI[ASDRaw$QQuinnCI=="1"]  <- "Lower"
ASDRaw$QQuinnCICI[ASDRaw$QQuinnCI=="2"]  <- "Lower"
ASDRaw$QQuinnCICI[ASDRaw$QQuinnCI=="3"]  <- "Lower"
ASDRaw$QQuinnCICI[ASDRaw$QQuinnCI=="4"]  <- "Upper"
ASDRaw$QQuinnCICI[ASDRaw$QQuinnCI=="5"]  <- "Upper"

dim(ASDRaw); names(ASDRaw); table(ASDRaw$QQuinnCI); table(ASDRaw$QQuinnCICI)
glimpse(ASDRaw)

ASDRawNa <- subset(ASDRaw, QQuinnCICI !="NA")
      
levels(factor(ASDRawNa$QQuinnCICI))
ASDRawNa$QQuinnCICI           <- as.factor(ASDRawNa$QQuinnCICI)
ASDRawNa$QQuinnCICI           <-  relevel(ASDRawNa$QQuinnCICI, ref='Upper' )
levels(factor(ASDRawNa$QQuinnCICI))

ggplot(ASDRawNa, aes(Year, (ASDRt), fill=QQuinnCICI,
                   colour=QQuinnCICI, group = QQuinnCICI)) +
  geom_jitter(size=4, alpha=0.4, width=0.3) +
  geom_smooth(method='lm', alpha=0.25) +
  # stat_ellipse(type="norm", linetype=2) +
  stat_ellipse(type="t") +
  theme_plotE() +
  ggtitle('ASD Rates by Dichotomized Cannabis Quintile') +
  labs(y='ASD Rate / 10,000 Births',
       fill='Two\nQuintile\nGroups', colour='Two\nQuintile\nGroups',
       subtitle='Data Jittered for Display')

      
      
# https://uc-r.github.io/kmeans_clustering

library(tidyverse)
library(cluster)
# install.packages("factoextra")
library(factoextra)

ASDRawNas <- subset(ASDRawNa[,c(1,2,3,11,57)], ASDRt !="NA")
dim(ASDRawNas); names(ASDRawNas)

ASDRawNass <- scale(ASDRawNas[3:4])
summary(ASDRawNass)

ASDRawNaSS <- scale(ASDRawNas[c(4,3)])
summary(ASDRawNaSS)

ASDRawNast <- ASDRawNas[,c(4,3)]

k2 <- kmeans(ASDRawNass, centers = 2, nstart = 25)    
k3 <- kmeans(ASDRawNass, centers = 3, nstart = 25)    
k4 <- kmeans(ASDRawNass, centers = 4, nstart = 25)    
k5 <- kmeans(ASDRawNass, centers = 5, nstart = 25)    
k6 <- kmeans(ASDRawNass, centers = 6, nstart = 25)    
k7 <- kmeans(ASDRawNass, centers = 7, nstart = 25)    

k2 <- kmeans(ASDRawNass, centers = 2, nstart = 25)    
k3t <- kmeans(ASDRawNast, centers = 3, nstart = 25)    
k4 <- kmeans(ASDRawNass, centers = 4, nstart = 25)    
k5 <- kmeans(ASDRawNass, centers = 5, nstart = 25)    
k6 <- kmeans(ASDRawNass, centers = 6, nstart = 25)    
k7 <- kmeans(ASDRawNass, centers = 7, nstart = 25)    

fviz_cluster(k2, data=ASDRawNass)      
fviz_cluster(k3, data=ASDRawNass)      
fviz_cluster(k4, data=ASDRawNass)      
fviz_cluster(k5, data=ASDRawNass)   

fviz_cluster(k2, data=ASDRawNass, ellipse.type = 'euclid')      
fviz_cluster(k3, data=ASDRawNass, ellipse.type = 'euclid')      
fviz_cluster(k4, data=ASDRawNass, ellipse.type = 'euclid')      
fviz_cluster(k5, data=ASDRawNass, ellipse.type = 'euclid')  

fviz_cluster(k2, data=ASDRawNass, ellipse.type = 't')      
fviz_cluster(k3, data=ASDRawNass, ellipse.type = 't')      
fviz_cluster(k4, data=ASDRawNass, ellipse.type = 't')      
fviz_cluster(k5, data=ASDRawNass, ellipse.type = 't')  

fviz_cluster(k2, data=ASDRawNass, ellipse.type = 'norm')      
fviz_cluster(k3, data=ASDRawNass, ellipse.type = 'norm')      
fviz_cluster(k4, data=ASDRawNass, ellipse.type = 'norm')      
fviz_cluster(k5, data=ASDRawNass, ellipse.type = 'norm')  


par(mfrow=c(1,3))
Cc1 <- fviz_cluster(k3, data=ASDRawNass, ellipse.type = 'euclid', main='Euclidean Ellipses')      
Cc2 <- fviz_cluster(k3, data=ASDRawNass, ellipse.type = 't', main=' "t" Ellipses')      
Cc3 <- fviz_cluster(k3, data=ASDRawNass, ellipse.type = 'norm', main='Normal Ellipses')      

ggarrange(Cc2, Cc3, Cc1, nrow=1, ncol=3)

par(mfrow=c(1,1))
class(ASDRawNass)


p1 <- fviz_cluster(k2, geom = "point",  data = ASDRawNass) + ggtitle("k = 2")
p2 <- fviz_cluster(k3, geom = "point",  data = ASDRawNass) + ggtitle("k = 3")
p3 <- fviz_cluster(k4, geom = "point",  data = ASDRawNass) + ggtitle("k = 4")
p4 <- fviz_cluster(k5, geom = "point",  data = ASDRawNass) + ggtitle("k = 5")

p1 <- fviz_cluster(k2, geom = "point",  data = ASDRawNaSS, ellipse.type = 'norm') + ggtitle("k = 2")
p2 <- fviz_cluster(k3, geom = "point",  data = ASDRawNass, ellipse.type = 'norm') + ggtitle("k = 3")
p3 <- fviz_cluster(k4, geom = "point",  data = ASDRawNass, ellipse.type = 'norm') + ggtitle("k = 4")
p4 <- fviz_cluster(k5, geom = "point",  data = ASDRawNass, ellipse.type = 'norm') + ggtitle("k = 5")
p5 <- fviz_cluster(k5, geom = "point",  data = ASDRawNass, ellipse.type = 'norm') + ggtitle("k = 6")
p6 <- fviz_cluster(k5, geom = "point",  data = ASDRawNass, ellipse.type = 'norm') + ggtitle("k = 7")

library(gridExtra)
grid.arrange(p1, p2, p3, p4, nrow = 2)
grid.arrange(p2, p3, p4, p6, nrow = 2)

class(p1)

p2 <- fviz_cluster(k3, geom = "point",  data = ASDRawNaSS, ellipse.type = 'norm',
                   show.clust.cent = FALSE) + 
  ggtitle("Cannabis - ASD Rate - 3 Clusters") + theme_plotE() +
  theme(legend.position = "none") +
  labs(x='Scaled Cannabis Use', y = 'Scaled ASD Rate')
p3 <- fviz_cluster(k4, geom = "point",  data = ASDRawNaSS, ellipse.type = 'norm',
                   show.clust.cent = FALSE) + 
  ggtitle("Cannabis - ASD Rate - 4 Clusters") + theme_plotE() +
  theme(legend.position = "none")  +
  labs(x='Scaled Cannabis Use', y = 'Scaled ASD Rate')
p4 <- fviz_cluster(k5, geom = "point",  data = ASDRawNaSS, ellipse.type = 'norm',
                   show.clust.cent = FALSE) + 
  ggtitle("Cannabis - ASD Rate - 5 Clusters") + theme_plotE() +
  theme(legend.position = "none")  +
  labs(x='Scaled Cannabis Use', y = 'Scaled ASD Rate')
p5 <- fviz_cluster(k6, geom = "point",  data = ASDRawNaSS, ellipse.type = 'norm',
                   show.clust.cent = FALSE) + 
  ggtitle("Cannabis - ASD Rate - 6 Clusters") + theme_plotE() +
  theme(legend.position = "none")  +
  labs(x='Scaled Cannabis Use', y = 'Scaled ASD Rate')

grid.arrange(p2, p3, p4, p5, nrow = 2)

GGr2 <- grid.arrange(p2, p3, p4, p5, nrow = 2)
class(GGr2)

# ggsave(GGr2, "Cluster_Graph_4.pdf", dpi=1200, width=10, height = 7, units="in",
#        path = "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/Figures/NewFigg")

pdf(GGr2, 
    "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/Figures/NewFigg/Cluster_Graph_4.pdf",
    width=10, height = 7, useDingbats = FALSE)
dev.off()








library(cluster)
# K-Means Clustering with 5 clusters
fit2 <- kmeans(ASDRawNass, 2)
fit3 <- kmeans(ASDRawNass, 3)
fit4 <- kmeans(ASDRawNass, 4)
fit5 <- kmeans(ASDRawNass, 5)
fit6 <- kmeans(ASDRawNass, 6)
fit7 <- kmeans(ASDRawNass, 7)

# Cluster Plot against 1st 2 principal components
# vary parameters for most readable graph
CPl2 <- clusplot(ASDRawNass, fit2$cluster, color=TRUE, shade=TRUE,
         labels=2, lines=0)
CPl3 <- clusplot(ASDRawNass, fit3$cluster, color=TRUE, shade=TRUE,
         labels=2, lines=0)
CPl4 <- clusplot(ASDRawNass, fit4$cluster, color=TRUE, shade=TRUE,
         labels=2, lines=0)
CPl5 <- clusplot(ASDRawNass, fit5$cluster, color=TRUE, shade=TRUE,
         labels=2, lines=0)
CPl6 <- clusplot(ASDRawNass, fit6$cluster, color=TRUE, shade=TRUE,
         labels=2, lines=0)
CPl7 <- clusplot(ASDRawNass, fit7$cluster, color=TRUE, shade=TRUE,
         labels=2, lines=0)

class(CPl2)

CPl2g <- grob(CPl2)
class(CPl2g)
CPl2g

# grid.arrange(CPl2g, nrow=1)
# ggarrange(CPl2, CPl3, CPl4, CPl5, nrow = 1)

par(mfrow=c(2,2))

clusplot(ASDRawNass, fit2$cluster, color=TRUE, shade=TRUE,
                 labels=2, lines=2, main='2 Clusters')
clusplot(ASDRawNass, fit3$cluster, color=TRUE, shade=TRUE,
                 labels=2, lines=0, main='3 Clusters')
clusplot(ASDRawNass, fit4$cluster, color=TRUE, shade=TRUE,
                 labels=2, lines=0, main='4 Clusters')
clusplot(ASDRawNass, fit5$cluster, color=TRUE, shade=TRUE,
                 labels=2, lines=0, main='5 Clusters')

par(mfrow=c(1,1))

# https://www.statmethods.net/advstats/cluster.html
# Centroid Plot against 1st 2 discriminant functions
library(fpc)
plotcluster(matrix((ASDRawNass),2,2), fit$cluster)


##############################################################################################
##############################################################################################
################# https://www.statmethods.net/advstats/cluster.html
# Model Based Clustering
# install.packages("mclust")
# install.packages("fpc")
library(mclust)
fit <- Mclust(ASDRawNass)
plot(fit) # plot results
summary(fit) # display the best model

# K-Means Clustering with 5 clusters
fit <- kmeans(mydata, 5)

# Cluster Plot against 1st 2 principal components

# vary parameters for most readable graph
library(cluster)
clusplot(mydata, fit$cluster, color=TRUE, shade=TRUE,
         labels=2, lines=0)

# Centroid Plot against 1st 2 discriminant functions
library(fpc)
plotcluster(mydata, fit$cluster)


######################### Cluster Analyses
# https://www.statmethods.net/advstats/cluster.html

install.packages(c("cluster", "mclust"))
library(cluster)
library(mclust)
install.packages("fpc")
library(fpc)

# Prepare Data
mydata <- na.omit(mydata) # listwise deletion of missing
mydata <- scale(mydata) # standardize variables
dim(mydata); names(mydata); head(mydata); class(mydata)

# Determine number of clusters
wss <- (nrow(mydata)-1)*sum(apply(mydata,2,var))
for (i in 2:15) wss[i] <- sum(kmeans(mydata,
                                     centers=i)$withinss)
plot(1:15, wss, type="b", xlab="Number of Clusters",
     ylab="Within groups sum of squares")


# K-Means Cluster Analysis
fit <- kmeans(mydata, 5) # 5 cluster solution
# get cluster means
aggregate(mydata,by=list(fit$cluster),FUN=mean)
# append cluster assignment
mydata <- data.frame(mydata, fit$cluster)

# Ward Hierarchical Clustering
d <- dist(mydata, method = "euclidean") # distance matrix
fit <- hclust(d, method="ward")
plot(fit) # display dendogram
groups <- cutree(fit, k=5) # cut tree into 5 clusters
# draw dendogram with red borders around the 5 clusters
rect.hclust(fit, k=5, border="red")



#### Now Model Based Clustering from mclust
# Model Based Clustering
library(mclust)
fit <- Mclust(mydata)
plot(fit) # plot results
summary(fit) # display the best model



# K-Means Clustering with 5 clusters
fit <- kmeans(mydata, 5)

# Cluster Plot against 1st 2 principal components

# vary parameters for most readable graph
library(cluster)
clusplot(mydata, fit$cluster, color=TRUE, shade=TRUE,
         labels=2, lines=0)

# Centroid Plot against 1st 2 discriminant functions
library(fpc)
plotcluster(mydata, fit$cluster)


##############################################################################################
##############################################################################################
############################################# drtmle    
##############################################################################################
##############################################################################################
############################################# drtmle

library(SuperLearner)
library(drtmle)

ASDKLTabab2Adf <- read_csv("D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2Adf.csv")
dim(ASDKLTabab2Adf); names(ASDKLTabab2Adf)

SL.npreg  <- function (Y, X, newX, family = gaussian(), obsWeights = rep(1,
                                                                         length(Y)), rangeThresh = 1e-07, ...)
{
  options(np.messages = FALSE)
  if (abs(diff(range(Y))) <= rangeThresh) {
    thisMod <- glm(Y ~ 1, data = X)
  }
  else {
    bw <- np::npregbw(stats::as.formula(paste("Y ~", paste(names(X),
                                                           collapse = "+"))), data = X, ftol = 0.01, tol = 0.01,
                      remin = FALSE)
    thisMod <- np::npreg(bw)
  }
  pred <- stats::predict(thisMod, newdata = newX)
  fit <- list(object = thisMod)
  class(fit) <- "SL.npreg"
  out <- list(pred = pred, fit = fit)
  return(out)
}


riskRatio <- list(f = function(eff){ log(eff) },
                  f_inv = function(eff){ exp(eff) },
                  h = function(est){ est[1]/est[2] },
                  fh_grad =  function(est){ c(1/est[1],-1/est[2]) })
# ci(npreg_fit, contrast = riskRatio)


z_test <- function(z, tailed){
  if(tailed == 1) return(cat('p-value - ', pnorm(-abs(z))))
  if(tailed == 2) return(cat('p-value - ', 2 * pnorm(-abs(z))))
  if(tailed != 1 | tailed !=2) return('can only be one or two tailed')
}


# names(ASDKLTabab2Adf)[19] <- "THC"
names(ASDKLTabab2Adf)
table(ASDKLTabab2Adf$fQQuinnCICIExp)

# ASDKLTabab2Adf$gn <- ASDKLTabab2Adf$mrjmon 
# ASDKLTabab2Adf$Qn <- log(ASDKLTabab2Adf$ASDRt)

# cigmon*log(mrjmon)*abodalc+log(anlyr)+log(cocyr)+   
#   White+log(Black)+log(AsPI)+log(AIAN)|
#   . -White-log(Black) -log(AsPI) -log(AIAN) +
#   log(NHWhiteTPPot) + log(NHBlackTPPot) + 
#   log(AsianTPPot) + log(AIANTPPot) -
#   log(mrjmon) + log(THCRt) + log(CBGRt)

# W <- ASDKLTabab2Adf[,c(4,7:10,12:16,38:48)]   # Covariates
W <- data.frame(
  W1 = ASDKLTabab2Adf$cigmon,
  W2 = ASDKLTabab2Adf$abodalc
  )
A <- ASDKLTabab2Adf$mrjmon
Y <- log(ASDKLTabab2Adf$ASDRt)

glm_fit_uni <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                      glm_g = "W1 + W2",
                      glm_Q = "W1 + W2 * A",
                      glm_gr = "Qn",
                      glm_Qr = "gn",
                      stratify = FALSE,
                      data = ASDKLTabab2Adf
                      )
summary(glm_fit_uni)
glm_fit_uni

A <- ASDKLTabab2Adf$fQQuinnCICIExp

glm_fit_uni_Biv <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                      glm_g = "W1 + W2",
                      glm_Q = "W1 + W2 * A",
                      glm_gr = "Qn",
                      glm_Qr = "gn",
                      stratify = FALSE,
                      data = ASDKLTabab2Adf
)
summary(glm_fit_uni_Biv)
glm_fit_uni_Biv
ci(glm_fit_uni_Biv, contrast = riskRatio) # 0.804 0.764 0.845  # 1 / 0.794  ##  1.259446
wald_test(glm_fit_uni_Biv, est = c("drtmle"), null = 0, contrast = c(-1,1))
z_test( 8.231, 2)


# W <- ASDKLTabab2Adf[,c(4,7:10,12:16,38:48)]   # Covariates
W <- data.frame(
  W1 = ASDKLTabab2Adf$mrjmon)
A <- ASDKLTabab2Adf$fQQuinnCICIExp
Y <- log(ASDKLTabab2Adf$ASDRt)

glm_fit_Uni_Biv <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                          glm_g = "W1",
                          glm_Q = "W1 * A",
                          glm_gr = "Qn",
                          glm_Qr = "gn",
                          stratify = FALSE,
                          data = ASDKLTabab2Adf
)
glm_fit_Uni_Biv
ci(glm_fit_Uni_Biv, contrast = riskRatio) # 0.819   0 Inf
wald_test(glm_fit_Uni_Biv, est = c("drtmle"), null = 0, contrast = c(-1,1))   # H0:E[Y(1)]-E[Y(0)]=0     0    1
# z_test( 8.231, 2)

Y <- ASDKLTabab2Adf$ASDRtReSc
range(ASDKLTabab2Adf$ASDRtReSc)
glm_fit_Uni_Biv_Bin <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                          glm_g = "W1",
                          glm_Q = "W1 * A",
                          glm_gr = "Qn",
                          glm_Qr = "gn",
                          stratify = FALSE,
                          data = ASDKLTabab2Adf
)
glm_fit_Uni_Biv_Bin
ci(glm_fit_Uni_Biv_Bin, contrast = riskRatio) # 0.752   0 Inf
wald_test(glm_fit_Uni_Biv_Bin, est = c("drtmle"), null = 0, contrast = c(-1,1))   # H0:E[Y(1)]-E[Y(0)]=0     0    1
# z_test( 8.231, 2)


glm_fit_Uni_Biv_Bin_Strat <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                              glm_g = "W1",
                              glm_Q = "W1",
                              glm_gr = "Qn",
                              glm_Qr = "gn",
                              stratify = TRUE,
                              data = ASDKLTabab2Adf
)
glm_fit_Uni_Biv_Bin_Strat   #  0.8989616 /  0.6758569   ## 1.330106
ci(glm_fit_Uni_Biv_Bin_Strat, contrast = riskRatio) # 0.752   0 Inf
wald_test(glm_fit_Uni_Biv_Bin_Strat, est = c("drtmle"), null = 0, contrast = c(-1,1))   # H0:E[Y(1)]-E[Y(0)]=0     0    1
# z_test( 8.231, 2)


#############################
############################
# Now Full drtmle model
W <- data.frame(
  W1  = ASDKLTabab2Adf$cigmon,
  W2  = ASDKLTabab2Adf$abodalc,
  W4  = log(ASDKLTabab2Adf$mrjmon),
  W5  = log(ASDKLTabab2Adf$anlyr),
  W6  = log(ASDKLTabab2Adf$cocyr),
  W7  = ASDKLTabab2Adf$White,
  W8  = log(ASDKLTabab2Adf$Black),
  W9  = log(ASDKLTabab2Adf$AsPI),
  W10  = log(ASDKLTabab2Adf$AIAN),
  W11 = log(ASDKLTabab2Adf$NHWhiteTPPot),
  W12 = log(ASDKLTabab2Adf$NHBlackTPPot),
  W13 = log(ASDKLTabab2Adf$AsianTPPot),
  W14 = log(ASDKLTabab2Adf$HispanicTPPot),
  W15 = log(ASDKLTabab2Adf$AIANTPPot),
  W16 = log(ASDKLTabab2Adf$MHY)
)

A <- ASDKLTabab2Adf$fQQuinnCICIExp
Y <- log(ASDKLTabab2Adf$ASDRt)

######## Non-Stratified
glm_fit_uni_NStrat <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                      glm_g = "W1+W2+W4+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                      glm_Q = "W1+W2+W4+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16 * A",
                      glm_gr = "Qn",
                      glm_Qr = "gn",
                      stratify = FALSE,
                      data = ASDKLTabab2Adf
)
summary(glm_fit_uni_NStrat)
glm_fit_uni_NStrat
ci(glm_fit_uni_NStrat)
ci(glm_fit_uni_NStrat, contrast = riskRatio)

str(glm_fit_uni_NStrat, max.level=0)
str(glm_fit_uni_NStrat, max.level=1)
str(glm_fit_uni_NStrat, max.level=2)


#######################################################################
#######################################################################
################################## glm Outut MV Model
######## Stratified
#### Additive Only Model

glm_fit_uni_Strat <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                            glm_g = "W1+W2+W4+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                            glm_Q = "W1+W2+W4+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                            glm_gr = "Qn",
                            glm_Qr = "gn",
                            stratify = TRUE,
                            data = ASDKLTabab2Adf
)
# summary(glm_fit_uni_Strat)
# glm_fit_uni_Strat
# ci(glm_fit_uni_Strat)
ci(glm_fit_uni_Strat)  #  0.855  / 0.678    # 1.261062
ci(glm_fit_uni_Strat, contrast = riskRatio) # 1 / 0.794  ##  1.259446
ci(glm_fit_uni_Strat, contrast = c(0, 1))   # E[Y(1)] 0.855 0.843 0.866         ## 1 / 0.855  ### 1.169591
ci(glm_fit_uni_Strat, contrast = c(-1,1))   # E[Y(1)]-E[Y(0)] 0.176 0.156 0.197

# ?wald.test
# wald.test(b = coef(fm), Sigma = vcov(fm), Terms = 3:4)
# wald_test(b = coef(glm_fit_uni_Strat), Sigma = vcov(glm_fit_uni_Strat), Terms = 3:4)

wald_test(glm_fit_uni_Strat, est = c("drtmle"), null = 0, contrast = c(-1,1))
z_test(17.163, 2)
# z_test(17.163, 1)


#######################################################################
#######################################################################
################################## glm Outut MV Model - Binomial
######## Stratified
#### Additive Only Model
A <- ASDKLTabab2Adf$fQQuinnCICIExp
Y <- ASDKLTabab2Adf$ASDRtReSc

glm_fit_uni_Strat <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                            glm_g = "W1+W2+W4+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                            glm_Q = "W1+W2+W4+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                            glm_gr = "Qn",
                            glm_Qr = "gn",
                            stratify = TRUE,
                            data = ASDKLTabab2Adf$gn
)
glm_fit_uni_Strat
ci(glm_fit_uni_Strat)  #  0.855  / 0.678    # 1.261062
ci(glm_fit_uni_Strat, contrast = riskRatio) # 1 / 0.794 1/0.771;  1/0.817  ##  1.259446  1.297017 1.22399
# ci(glm_fit_uni_Strat, contrast = c(0, 1))   # E[Y(1)] 0.855 0.843 0.866         ## 1 / 0.855  ### 1.169591
ci(glm_fit_uni_Strat, contrast = c(-1,1))   # E[Y(1)]-E[Y(0)] 0.176 0.156 0.197

wald_test(glm_fit_uni_Strat, est = c("drtmle"), null = 0, contrast = c(-1,1))
z_test(17.163, 2)


###################### Interactive
######## Stratified
glm_fit_uni_Strat <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                            glm_g = "W1*W4*W2+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                            glm_Q = "W1*W4*W2+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                            glm_gr = "Qn",
                            glm_Qr = "gn",
                            stratify = TRUE,
                            data = ASDKLTabab2Adf$gn
)
summary(glm_fit_uni_Strat)
glm_fit_uni_Strat
ci(glm_fit_uni_Strat)
ci(glm_fit_uni_Strat, contrast = riskRatio)


#######################################################################
#######################################################################
################################## glm Comparing Additive and Interactive Models - Binomial
################ Additive 
######## Stratified
#### Additive Only Model
A <- ASDKLTabab2Adf$fQQuinnCICIExp
Y <- ASDKLTabab2Adf$ASDRtReSc

glm_fit_uni_Strat_Add <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                            glm_g = "W1+W4+W2+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                            glm_Q = "W1+W4+W2+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                            glm_gr = "Qn",
                            glm_Qr = "gn",
                            stratify = TRUE,
                            data = ASDKLTabab2Adf$gn
)
glm_fit_uni_Strat_Add
ci(glm_fit_uni_Strat_Add)  #  0.855  / 0.678    # 1.261062
ci(glm_fit_uni_Strat_Add, contrast = riskRatio) # 1 / 0.794  ##  1.259446
ci(glm_fit_uni_Strat_Add, contrast = c(-1,1))   # E[Y(1)]-E[Y(0)] 0.176 0.156 0.197

wald_test(glm_fit_uni_Strat_Add, est = c("drtmle"), null = 0, contrast = c(-1,1))
z_test(17.163, 2)   # 5.024962e-66
 

################ INTERACTIVE 
######## Stratified
#### Interactive x 1 Only Model
A <- ASDKLTabab2Adf$fQQuinnCICIExp
Y <- ASDKLTabab2Adf$ASDRtReSc

glm_fit_uni_Strat_Int1 <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                                glm_g = "W1*W4+W2+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                                glm_Q = "W1*W4+W2+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                                glm_gr = "Qn",
                                glm_Qr = "gn",
                                stratify = TRUE,
                                data = ASDKLTabab2Adf$gn
)
glm_fit_uni_Strat_Int1
ci(glm_fit_uni_Strat_Int1)  #  0.824  / 0.680    # 1.211765
ci(glm_fit_uni_Strat_Int1, contrast = riskRatio) # 0.825 0.801 0.851  ##  1 / 0.794  ##  1.259446
ci(glm_fit_uni_Strat_Int1, contrast = c(-1,1))   # E[Y(1)]-E[Y(0)] 0.144 0.122 0.165

wald_test(glm_fit_uni_Strat_Int1, est = c("drtmle"), null = 0, contrast = c(-1,1))
z_test(13.156, 2)  # p-value -  1.5719e-39

################ INTERACTIVE 
######## Stratified
#### Interactive x 2 Only Model
A <- ASDKLTabab2Adf$fQQuinnCICIExp
Y <- ASDKLTabab2Adf$ASDRtReSc

glm_fit_uni_Strat_Int2 <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                                 glm_g = "W1*W4*W2+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                                 glm_Q = "W1*W4*W2+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                                 glm_gr = "Qn",
                                 glm_Qr = "gn",
                                 stratify = TRUE,
                                 data = ASDKLTabab2Adf$gn
)
glm_fit_uni_Strat_Int2
ci(glm_fit_uni_Strat_Int2)  #  0.785  /  0.6816    # 1.211765
ci(glm_fit_uni_Strat_Int2, contrast = riskRatio)   # 0.825 0.801 0.851  ##  1 / 0.794  ##  1.259446
ci(glm_fit_uni_Strat_Int2, contrast = c(-1,1))     # E[Y(1)]-E[Y(0)] 0.103 0.069 0.137

wald_test(glm_fit_uni_Strat_Int2, est = c("drtmle"), null = 0, contrast = c(-1,1)) #  5.954 
z_test(5.954, 2)  # p-value -  1.5719e-39


#### Interactive x 3 Only Model
A <- ASDKLTabab2Adf$fQQuinnCICIExp
Y <- ASDKLTabab2Adf$ASDRtReSc

glm_fit_uni_Strat_Int3 <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                                 glm_g = "W1*W4*W2*W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                                 glm_Q = "W1*W4*W2*W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                                 glm_gr = "Qn",
                                 glm_Qr = "gn",
                                 stratify = TRUE,
                                 data = ASDKLTabab2Adf$gn
)
glm_fit_uni_Strat_Int3
ci(glm_fit_uni_Strat_Int3)  #  0.7446513  /  0.6860041    # 1.211765
ci(glm_fit_uni_Strat_Int3, contrast = riskRatio)   # 0.921 0.872 0.973  ##  1 / 0.921  ##   1.085776
ci(glm_fit_uni_Strat_Int3, contrast = c(-1,1))     # E[Y(1)]-E[Y(0)]  0.059 0.018 0.099

wald_test(glm_fit_uni_Strat_Int3, est = c("drtmle"), null = 0, contrast = c(-1,1)) # 2.85 0.004
z_test(2.85, 2)  # p-value -  0.004371923



### 
### 
### Now Binomial Models
A <- ASDKLTabab2Adf$fQQuinnCICIExp

rescale01 <- function(x) {
  rng <- range(x, na.rm = TRUE)
  (x - rng[1]) / (rng[2] - rng[1])
}
rescale01(c(0, 5, 10))


ASDKLTabab2Adf$ASDRtReSc <- rescale01(log(ASDKLTabab2Adf$ASDRt))
range(ASDKLTabab2Adf$ASDRtReSc)

Y <- ASDKLTabab2Adf$ASDRtReSc

glm_fit_uni2 <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                      glm_g = "W1 + W2",
                      glm_Q = "W1 + W2",
                      glm_gr = "Qn",
                      glm_Qr = "gn",
                      stratify = TRUE,
                      data = ASDKLTabab2Adf$gn
)
summary(glm_fit_uni2)
glm_fit_uni2
ci(glm_fit_uni2)
ci(glm_fit_uni2, contrast = riskRatio)

############################
############################
#### Re-Doing Binomial Model
W <- data.frame(
  W1 = ASDKLTabab2Adf$mrjmon)
A <- ASDKLTabab2Adf$fQQuinnCICIExp
Y <- ASDKLTabab2Adf$ASDRtReSc

##### Stratified
glm_fit_uni_Biv_Strat <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                       glm_g = "W1",
                       glm_Q = "W1",
                       glm_gr = "Qn",
                       glm_Qr = "gn",
                       stratify = TRUE,
                       data = ASDKLTabab2Adf
)
ci(glm_fit_uni_Biv_Strat)
ci(glm_fit_uni_Biv_Strat, contrast = riskRatio)

###### Non-Stratified
glm_fit_uni_Biv_NoStrat <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                                glm_g = "W1",
                                glm_Q = "W1 * A",
                                glm_gr = "Qn",
                                glm_Qr = "gn",
                                stratify = FALSE,
                                data = ASDKLTabab2Adf$gn
)
ci(glm_fit_uni_Biv_NoStrat)
ci(glm_fit_uni_Biv_NoStrat, contrast = riskRatio)


######### SL Fits now

SL_fit <- drtmle(W = W, A = A, Y = Y, family = binomial(),
     SL_g  = c("SL.glm", "SL.mean"),
     SL_Q  = c("SL.glm", "SL.mean"),
     SL_gr = c("SL.glm", "SL.earth"),
     SL_Qr = c("SL.glm", "SL.earth"),
     stratify = FALSE)
SL_fit     
summary(SL_fit)

############################
############################
#### Re-Doing Binomial Model
#### SL Version of above glm
#### SL Stratified Fit

SL_fit_Strat <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                 SL_g  = c("SL.glm", "SL.mean"),
                 SL_Q  = c("SL.glm", "SL.mean"),
                 SL_gr = c("SL.glm", "SL.earth"),
                 SL_Qr = c("SL.glm", "SL.earth"),
                 stratify = TRUE)
SL_fit_Strat     
ci(SL_fit_Strat)
ci(SL_fit_Strat, contrast = riskRatio)
ci(SL_fit_Strat, contrast = c(-1,1))

wald_test(SL_fit_Strat, est = c("drtmle"), null = 0, contrast = NULL)
wald_test(SL_fit_Strat, est = c("drtmle"), null = 0, contrast = c(-1,1))  # 3.529 
z_test(3.529, 2)
z_test(52.762, 2)
z_test(36.762, 2)  # p-value -  7.477293e-296


########################################################
########################################################
#### Now the Full df for W - Listing All Covariates
#### SL Version of above glm

W <- data.frame(
  W1  = ASDKLTabab2Adf$cigmon,
  W2  = ASDKLTabab2Adf$abodalc,
  W4  = log(ASDKLTabab2Adf$mrjmon),
  W5  = log(ASDKLTabab2Adf$anlyr),
  W6  = log(ASDKLTabab2Adf$cocyr),
  W7  = ASDKLTabab2Adf$White,
  W8  = log(ASDKLTabab2Adf$Black),
  W9  = log(ASDKLTabab2Adf$AsPI),
  W10  = log(ASDKLTabab2Adf$AIAN),
  W11 = log(ASDKLTabab2Adf$NHWhiteTPPot),
  W12 = log(ASDKLTabab2Adf$NHBlackTPPot),
  W13 = log(ASDKLTabab2Adf$AsianTPPot),
  W14 = log(ASDKLTabab2Adf$HispanicTPPot),
  W15 = log(ASDKLTabab2Adf$AIANTPPot),
  W16 = log(ASDKLTabab2Adf$MHY)
)

A <- ASDKLTabab2Adf$fQQuinnCICIExp
Y <- ASDKLTabab2Adf$ASDRtReSc

######## Stratified
SL_fit_uni_MV_Strat <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                              SL_g  = c("SL.glm", "SL.mean"),
                              SL_Q  = c("SL.glm", "SL.mean"),
                              SL_gr = c("SL.glm", "SL.earth"),
                              SL_Qr = c("SL.glm", "SL.earth"),
                              stratify = TRUE)
SL_fit_uni_MV_Strat  
ci(SL_fit_uni_MV_Strat)   # 0.71 / 0.67   ##   1.059701
ci(SL_fit_uni_MV_Strat, contrast = riskRatio)                 
ci(SL_fit_uni_MV_Strat, contrast = c(-1,1))                 

wald_test(SL_fit_uni_MV_Strat, est = c("drtmle"), null = 0, contrast = NULL)
wald_test(SL_fit_uni_MV_Strat, est = c("drtmle"), null = 0, contrast = c(-1,1))  # 20.634
z_test(20.634, 2)

######## Non-Stratified
SL_fitG <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                 SL_g  = c("SL.glm", "SL.mean"),
                 SL_Q  = c("SL.glm", "SL.mean"),
                 SL_gr = c("SL.glm", "SL.earth"),
                 SL_Qr = c("SL.glm", "SL.earth"),
                 stratify = FALSE)
SL_fitG  
ci(SL_fitG)
ci(SL_fitG, contrast = riskRatio)


######## Stratified - Gaussian
SL_fitGS <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                  SL_g  = c("SL.glm", "SL.mean"),
                  SL_Q  = c("SL.glm", "SL.mean"),
                  SL_gr = c("SL.glm", "SL.earth"),
                  SL_Qr = c("SL.glm", "SL.earth"),
                  stratify = TRUE)
SL_fitGS  
ci(SL_fitGS)  # 0.849 / 0.710       # 1.195775
ci(SL_fitGS, contrast = riskRatio)  # user contrast 0.837 0.811 0.863
ci(SL_fitGS, contrast = c(-1,1))    # E[Y(1)]-E[Y(0)] 0.139 0.116 0.161

Y <- ASDKLTabab2Adf$ASDRt
Y <- log(ASDKLTabab2Adf$ASDRt)

exp(ci(SL_fitGS))
exp(ci(SL_fitGS, contrast = riskRatio))
exp(ci(SL_fitGS, contrast = c(0,1)))

######## Stratified - Gaussian - Raw Rates
#### w Raw Rates
Y <- ASDKLTabab2Adf$ASDRt

# n_SL = 5
SL_fitGS <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                   SL_g  = c("SL.glm", "SL.mean"),
                   SL_Q  = c("SL.glm", "SL.mean"),
                   SL_gr = c("SL.glm", "SL.earth"),
                   SL_Qr = c("SL.glm", "SL.earth"),
                   stratify = TRUE, n_SL = 5)
SL_fitGS  
ci(SL_fitGS)  #  134.65396 /  67.21654    #  1.985711
ci(SL_fitGS, contrast = riskRatio)  # user contrast 0.499 0.449 0.555    # 1/0.499;  1/0.449;  1/0.555;  ## 2.004008  (1.801802, 2.227171) 
ci(SL_fitGS, contrast = c(-1,1))    # E[Y(1)]-E[Y(0)] 67.437 58.996 75.879

# n_SL = 10
SL_fitGS <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                   SL_g  = c("SL.glm", "SL.mean"),
                   SL_Q  = c("SL.glm", "SL.mean"),
                   SL_gr = c("SL.glm", "SL.earth"),
                   SL_Qr = c("SL.glm", "SL.earth"),
                   stratify = TRUE, n_SL = 10)
SL_fitGS  
ci(SL_fitGS)  #  133.43735 /  67.19878    #  1.985711
ci(SL_fitGS, contrast = riskRatio)  # user contrast  0.504 0.452 0.561    # 1/0.504;  1/0.452;  1/0.561;  ## 1.984127  (1.782531, 2.212389) 
ci(SL_fitGS, contrast = c(-1,1))    # E[Y(1)]-E[Y(0)] 66.239 (57.596, 74.881)

wald_test(SL_fitGS, est = c("drtmle"), null = 0, contrast = NULL)
wald_test(SL_fitGS, est = c("drtmle"), null = 0, contrast = c(-1,1))
z_test(14.729, 2)


###########################################################################
###########################################################################
################################## Repeating glm drtmle w SL
########### 

W <- data.frame(
  W1  = ASDKLTabab2Adf$cigmon,
  W2  = ASDKLTabab2Adf$abodalc,
  W4  = log(ASDKLTabab2Adf$mrjmon),
  W5  = log(ASDKLTabab2Adf$anlyr),
  W6  = log(ASDKLTabab2Adf$cocyr),
  W7  = ASDKLTabab2Adf$White,
  W8  = log(ASDKLTabab2Adf$Black),
  W9  = log(ASDKLTabab2Adf$AsPI),
  W10  = log(ASDKLTabab2Adf$AIAN),
  W11 = log(ASDKLTabab2Adf$NHWhiteTPPot),
  W12 = log(ASDKLTabab2Adf$NHBlackTPPot),
  W13 = log(ASDKLTabab2Adf$AsianTPPot),
  W14 = log(ASDKLTabab2Adf$HispanicTPPot),
  W15 = log(ASDKLTabab2Adf$AIANTPPot),
  W16 = log(ASDKLTabab2Adf$MHY)
)

A <- ASDKLTabab2Adf$fQQuinnCICIExp
Y <- ASDKLTabab2Adf$ASDRtReSc

# n_SL = 5
SL_fitBSn <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                           SL_g  = c("SL.glm", "SL.mean"),
                           SL_Q  = c("SL.glm", "SL.mean"),
                           SL_gr = c("SL.glm", "SL.earth"),
                           SL_Qr = c("SL.glm", "SL.earth"),
                           stratify = TRUE, n_SL = 5)
SL_fitBSn 
ci(SL_fitBSn)  #  134.65396 /  67.21654    #  1.985711
ci(SL_fitBSn, contrast = riskRatio)  # user contrast 0.728 0.704 0.754    # 1/0.499;  1/0.449;  1/0.555;  ## 2.004008  (1.801802, 2.227171) 
ci(SL_fitBSn, contrast = c(-1,1))    # E[Y(1)]-E[Y(0)] 0.265 0.239 0.291

wald_test(SL_fitBSn, est = c("drtmle"), null = 0, contrast = NULL)
wald_test(SL_fitBSn, est = c("drtmle"), null = 0, contrast = c(-1,1))  # 20.078
z_test(20.078, 2)

z_test(17.163, 2)

Inv_Fn(c(0.989, 0.959, 1.021)) # 1.0111223 1.0427529 0.9794319
Inv_Fn(c(0.794, 0.771, 0.817)) # 1.259446 1.297017 1.223990
Inv_Fn(c(0.825, 0.801, 0.851)) # 1.212121 1.248439 1.175088
0.966 / 0.690;  0.984 / 0.730


SL_fitBSn <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                    SL_g  = W1 + c("SL.glm", "SL.mean"),
                    SL_Q  = c("SL.glm", "SL.mean"),
                    SL_gr = c("SL.glm", "SL.earth"),
                    SL_Qr = c("SL.glm", "SL.earth"),
                    stratify = TRUE)


###########################################################################
###########################################################################
################################## Repeating glm drtmle w SL
################################## MIXED SL FITS!!!
################################## Using Mixed fit SL's     
###########################################################################
###########################################################################
####################
###### Gaussian
A <- ASDKLTabab2Adf$fQQuinnCICIExp
Y <- log(ASDKLTabab2Adf$ASDRt)

Mixed_fitBSn_Add_Simple <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                           # SL_g  = list(DeltaA = "SL.glm", A = "SL.npreg",
                           #              DeltaY = c("SL.glm", "SL.mean", "SL.earth")),
                           glm_g = "W1 + W2",
                           glm_Q = "W1 + W2",
                           glm_gr = "Qn",
                           glm_Qr = "gn",
                           stratify = FALSE)
Mixed_fitBSn_Add_Simple
ci(Mixed_fitBSn_Add_Simple)
ci(Mixed_fitBSn_Add_Simple, contrast = c(-1,1))    # E[Y(1)]-E[Y(0)] 0.964 0.704 1.224
wald_test(Mixed_fitBSn_Add_Simple, est = c("drtmle"), null = 0, contrast = c(-1,1))  # 7.269    0
z_test(7.269, 2)  # 3.621584e-13

####################
###### Binomial
A <- ASDKLTabab2Adf$fQQuinnCICIExp
Y <- ASDKLTabab2Adf$ASDRtReSc

#### Additive
Mixed_fitBSn_Add <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                    SL_g  = list(DeltaA = "SL.glm", A = "SL.npreg",
                       DeltaY = c("SL.glm", "SL.mean", "SL.earth")),
                    glm_Q = "W1+W4+W2+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                    glm_gr = "Qn",
                    glm_Qr = "gn",
                    stratify = TRUE)

Mixed_fitBSn_Add 
ci(Mixed_fitBSn_Add)  #  0.8545335 /  0.6781479    #   1.260099  ## exp( 1.260099)  #  3.525771
ci(Mixed_fitBSn_Add, contrast = riskRatio)  # user contrast  0.794 0.771 0.817    # 1/ 0.794;  1/0.449;  1/0.555;  ## 1.259446  
ci(Mixed_fitBSn_Add, contrast = c(-1,1))    # E[Y(1)]-E[Y(0)] 0.265 0.239 0.291

wald_test(Mixed_fitBSn_Add, est = c("drtmle"), null = 0, contrast = NULL)
wald_test(Mixed_fitBSn_Add, est = c("drtmle"), null = 0, contrast = c(-1,1))  # 17.163 
z_test(17.163 , 2)  # 1.149296e-89


# Interactive x 1
Mixed_fitBSn_IR1 <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                           SL_g  = list(DeltaA = "SL.glm", A = "SL.npreg",
                                        DeltaY = c("SL.glm", "SL.mean", "SL.earth")),
                           glm_Q = "W1*W4+W2+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                           glm_gr = "Qn",
                           glm_Qr = "gn",
                           stratify = TRUE)

Mixed_fitBSn_IR1 
ci(Mixed_fitBSn_IR1)  #  0.8545335 /  0.6781479    #   1.260099  ## exp( 1.260099)  #  3.525771
ci(Mixed_fitBSn_IR1, contrast = riskRatio)  # user contrast  0.794 0.771 0.817    # 1/ 0.794;  1/0.449;  1/0.555;  ## 1.259446  
ci(Mixed_fitBSn_IR1, contrast = c(-1,1))    # E[Y(1)]-E[Y(0)] 0.265 0.239 0.291

wald_test(Mixed_fitBSn_IR1, est = c("drtmle"), null = 0, contrast = NULL)
wald_test(Mixed_fitBSn_IR1, est = c("drtmle"), null = 0, contrast = c(-1,1))  #  13.156 
z_test(13.156 , 2)  # 1.149296e-89


# Interactive x 2
Mixed_fitBSn_IR2 <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                           SL_g  = list(DeltaA = "SL.glm", A = "SL.npreg",
                                        DeltaY = c("SL.glm", "SL.mean", "SL.earth")),
                           glm_Q = "W1*W4*W2+W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                           glm_gr = "Qn",
                           glm_Qr = "gn",
                           stratify = TRUE)

Mixed_fitBSn_IR2 
ci(Mixed_fitBSn_IR2)  #  0.8545335 /  0.6781479    #   1.260099  ## exp( 1.260099)  #  3.525771
ci(Mixed_fitBSn_IR2, contrast = riskRatio)  # user contrast  0.794 0.771 0.817    # 1/ 0.794;  1/0.449;  1/0.555;  ## 1.259446  
ci(Mixed_fitBSn_IR2, contrast = c(-1,1))    # E[Y(1)]-E[Y(0)] 0.265 0.239 0.291

wald_test(Mixed_fitBSn_IR2, est = c("drtmle"), null = 0, contrast = NULL)
wald_test(Mixed_fitBSn_IR2, est = c("drtmle"), null = 0, contrast = c(-1,1))  # 5.954 
z_test(5.954 , 2)  # 1.149296e-89


# Interactive x 3
Mixed_fitBSn_IR3 <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                           SL_g  = list(DeltaA = "SL.glm", A = "SL.npreg",
                                        DeltaY = c("SL.glm", "SL.mean", "SL.earth")),
                           glm_Q = "W1*W4*W2*W5+W6+W7+W8+W9+W10+W11+W12+W13+W14+W15+W16",
                           glm_gr = "Qn",
                           glm_Qr = "gn",
                           stratify = TRUE)

Mixed_fitBSn_IR3 
ci(Mixed_fitBSn_IR3)  #  0.8545335 /  0.6781479    #   1.260099  ## exp( 1.260099)  #  3.525771
ci(Mixed_fitBSn_IR3, contrast = riskRatio)  # user contrast  0.794 0.771 0.817    # 1/ 0.794;  1/0.449;  1/0.555;  ## 1.259446  
ci(Mixed_fitBSn_IR3, contrast = c(-1,1))    # E[Y(1)]-E[Y(0)] 0.265 0.239 0.291

wald_test(Mixed_fitBSn_IR3, est = c("drtmle"), null = 0, contrast = NULL)
wald_test(Mixed_fitBSn_IR3, est = c("drtmle"), null = 0, contrast = c(-1,1))  # 17.163 
z_test(2.85 , 2)  # 1.149296e-89


ASDRange_Inv(c(0.176, 0.156, 0.197))      # 65.1096 57.7676 72.8187
ASDRange_Inv(c(0.144, 0.122, 0.165))      # 53.3624 45.2862 61.0715
ASDRange_Inv(c(0.103, 0.069, 0.137))      # 38.3113 25.8299 50.7927
ASDRange_Inv(c(0.059, 0.018, 0.099))      # 22.1589  7.1078 36.8429



hist(ASDKLTabab2Adf$ASDRt)
hist(log(ASDKLTabab2Adf$ASDRt))
hist(ASDKLTabab2Adf$ASDRtReSc)

ASDKLTabab2Adf$ASDRtLReSc <- rescale01(log(ASDKLTabab2Adf$ASDRt))

hist(ASDKLTabab2Adf$ASDRtLReSc)

shapiro.test(ASDKLTabab2Adf$ASDRt)
shapiro.test(log(ASDKLTabab2Adf$ASDRt))
shapiro.test((ASDKLTabab2Adf$ASDRtReSc))
shapiro.test((ASDKLTabab2Adf$ASDRtLReSc))


# Quintile est's
ASDRange_Inv(c(0.298, 0.557, 0.480, 0.646, 0.727))
# Quintile LCI's
ASDRange_Inv(c(0.262, 0.519, 0.424, 0.629, 0.693))
# Quintile UCI's
ASDRange_Inv(c(0.334, 0.596, 0.536, 0.663, 0.761))


##################################################################################
######################## Now Looking at IR's in Cannabis Use - by Race
##################################################################################
######################## Now Looking at IR's in Cannabis Use - By Race

# Interactive x 3
Mixed_fitBSn_IR31 <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                           SL_g  = list(DeltaA = "SL.glm", A = "SL.npreg",
                                        DeltaY = c("SL.glm", "SL.mean", "SL.earth")),
                           glm_Q = "W1+W4+W2+W5+W6+W7+W8+W9+W10+W11*W12*W13*W15+W14+W16",
                           glm_gr = "Qn",
                           glm_Qr = "gn",
                           stratify = TRUE)

Mixed_fitBSn_IR31 
ci(Mixed_fitBSn_IR31)  #  0.8545335 /  0.6781479    #   1.260099  ## exp( 1.260099)  #  3.525771
ci(Mixed_fitBSn_IR31, contrast = riskRatio)  # user contrast  0.794 0.771 0.817    # 1/ 0.794;  1/0.449;  1/0.555;  ## 1.259446  
ci(Mixed_fitBSn_IR31, contrast = c(-1,1))    # E[Y(1)]-E[Y(0)] 0.265 0.239 0.291

wald_test(Mixed_fitBSn_IR31, est = c("drtmle"), null = 0, contrast = NULL)
wald_test(Mixed_fitBSn_IR31, est = c("drtmle"), null = 0, contrast = c(-1,1))  # 4.472 
z_test(4.472 , 2)  #  7.749143e-06

79/68 # 1.161765
ASDRange_Inv(c(0.11, 0.062, 0.158)) # 40.8810 23.2602 58.5018
evalues.RR(0.11, 0.062, 0.158)


############################################################################################################################################
######################## Now Looking at IR's in Cannabis Use - by Race  & by Substance
############################################################################################################################################
######################## Now Looking at IR's in Cannabis Use - By Race & by Substance

# Interactive x 3
Mixed_fitBSn_IR33 <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                           SL_g  = list(DeltaA = "SL.glm", A = "SL.npreg",
                                        DeltaY = c("SL.glm", "SL.mean", "SL.earth")),
                           glm_Q = "W1*W4*W2+W5+W6+W7+W8+W9+W10+W11*W13*W15+W12+W14+W16",
                           glm_gr = "Qn",
                           glm_Qr = "gn",
                           stratify = TRUE)

Mixed_fitBSn_IR33 
ci(Mixed_fitBSn_IR33)  #  0.7851098 /  0.6843049    #   1.260099  ## exp( 1.260099)  #  3.525771
ci(Mixed_fitBSn_IR33, contrast = riskRatio)  # user contrast 0.872 0.83 0.915    # 1/ 0.872;  1/0.83;  1/0.915;  ## 1.259446  
ci(Mixed_fitBSn_IR33, contrast = c(-1,1))    # E[Y(1)]-E[Y(0)] 0.101 0.064 0.138

wald_test(Mixed_fitBSn_IR33, est = c("drtmle"), null = 0, contrast = NULL)
wald_test(Mixed_fitBSn_IR33, est = c("drtmle"), null = 0, contrast = c(-1,1))  # 4.472 
z_test(5.301 , 2)  #  7.749143e-06

0.7851098/0.6843049   #  1.14731
ASDRange_Inv(c(0.101, 0.064, 0.138)) # 37.5771 23.9944 51.1598
evalues.RR(0.101, 0.064, 0.138)  # 19.28867    NA 13.9742


############################################################################################################################################
######################## Now Looking at IR's in Cannabis Use - by Race  & by Substance - All 6 IR's
############################################################################################################################################
######################## Now Looking at IR's in Cannabis Use - By Race & by Substance - All 6 IR's
# Interactive x 5
Mixed_fitBSn_IR36 <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                            SL_g  = list(DeltaA = "SL.glm", A = "SL.npreg",
                                         DeltaY = c("SL.glm", "SL.mean", "SL.earth")),
                            glm_Q = "W1*W4*W2*W11*W13*W15+W12+W14+W16+W5+W6+W7+W8+W9+W10",
                            glm_gr = "Qn",
                            glm_Qr = "gn",
                            stratify = TRUE)

Mixed_fitBSn_IR36 
ci(Mixed_fitBSn_IR36)  #  0.9330025 /  0.7039932   #  1.3253  ## ASDRange_Inv(1.3253)  ### 487.0176
ci(Mixed_fitBSn_IR36, contrast = riskRatio)  # user contrast 0.755 0.731 0.779    # 1/  0.755;  1/0.731;  1/0.779;  ## 1.324503; 1.367989; 1.283697
ci(Mixed_fitBSn_IR36, contrast = c(-1,1))    # E[Y(1)]-E[Y(0)] 0.229 0.205 0.253  #  ASDRange_Inv(c(0.229, 0.205, 0.253)) # 84.5659 75.7555 93.3763

wald_test(Mixed_fitBSn_IR36, est = c("drtmle"), null = 0, contrast = NULL)
wald_test(Mixed_fitBSn_IR36, est = c("drtmle"), null = 0, contrast = c(-1,1))  # 18.524 
z_test(18.524 , 2)  #  7.749143e-06

0.7851098/0.6843049   #  1.14731
ASDRange_Inv(c(0.101, 0.064, 0.138)) # 37.5771 23.9944 51.1598
evalues.RR(0.101, 0.064, 0.138)  # 19.28867    NA 13.9742



###########################################################################
###########################################################################
################################## Looking at this as a Function of fASD
########### Not a Useful Comparison

class(ASDKLTabab2Adf$fASD); table(ASDKLTabab2Adf$fASD)

ASDKLTabab2Adf$fASDfCann                                       <- 0
ASDKLTabab2Adf$fASDfCann[ASDKLTabab2Adf$fASD=="High"]          <- 1
table(ASDKLTabab2Adf$fASDfCann);                               # 248 0    40   1
class(ASDKLTabab2Adf$fASDfCann)                                # numeric

A <- ASDKLTabab2Adf$fASDfCann

# n_SL = 10
SL_fitGS <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                   SL_g  = c("SL.glm", "SL.mean"),
                   SL_Q  = c("SL.glm", "SL.mean"),
                   SL_gr = c("SL.glm", "SL.earth"),
                   SL_Qr = c("SL.glm", "SL.earth"),
                   stratify = TRUE, n_SL = 10)
SL_fitGS  
ci(SL_fitGS)  #  1 94.662 79.803 109.520  ##  0 90.795 76.407 105.184
ci(SL_fitGS, contrast = riskRatio)  # user contrast  1.043 0.861 1.262     
ci(SL_fitGS, contrast = c(-1,1))    # E[Y(0)]-E[Y(1)] -3.866 -21.59 13.858

wald_test(SL_fitGS, est = c("drtmle"), null = 0, contrast = NULL)
wald_test(SL_fitGS, est = c("drtmle"), null = 0, contrast = c(-1,1))  # H0:E[Y(0)]-E[Y(1)]=0 -0.428 0.669
z_test(0.428, 2)   # 0.6686511


#######################################################################
#######################################################################
################################## SL Outut MV Model
######## Stratified - Gaussian w/o set_Seed = n_SL = 5

Y <- log(ASDKLTabab2Adf$ASDRt)

SL_fitGSn <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                   SL_g  = c("SL.glm", "SL.mean"),
                   SL_Q  = c("SL.glm", "SL.mean"),
                   SL_gr = c("SL.glm", "SL.earth"),
                   SL_Qr = c("SL.glm", "SL.earth"),
                   stratify = TRUE, n_SL = 5)
SL_fitGSn  
ci(SL_fitGSn)
ci(SL_fitGSn, contrast=riskRatio)
ci(SL_fitGSn, contrast=c(-1,0, 0,0,1))


##### Regression Coefficients to Odds Ratios
fit <- glm(Accepted~Background, data=dat, family="binomial")
exp(cbind(ODDS=coef(fit), confint(fit)))

# ODDS     2.5 %   97.5 %
#   (Intercept)      0.7441860 0.5367042 1.026588
# Backgroundorange 0.8682692 0.5223358 1.437108
# Backgroundred    1.6745192 1.1271430 2.497853


SL.npreg  <- function (Y, X, newX, family = gaussian(), obsWeights = rep(1,
    length(Y)), rangeThresh = 1e-07, ...)
{
    options(np.messages = FALSE)
    if (abs(diff(range(Y))) <= rangeThresh) {
        thisMod <- glm(Y ~ 1, data = X)
    }
    else {
        bw <- np::npregbw(stats::as.formula(paste("Y ~", paste(names(X),
            collapse = "+"))), data = X, ftol = 0.01, tol = 0.01,
            remin = FALSE)
        thisMod <- np::npreg(bw)
    }
    pred <- stats::predict(thisMod, newdata = newX)
    fit <- list(object = thisMod)
    class(fit) <- "SL.npreg"
    out <- list(pred = pred, fit = fit)
    return(out)
}

## <bytecode: 0x7f995c0af1d8>
## <environment: namespace:drtmle>

riskRatio <- list(f = function(eff){ log(eff) },
                  f_inv = function(eff){ exp(eff) },
                  h = function(est){ est[1]/est[2] },
                  fh_grad =  function(est){ c(1/est[1],-1/est[2]) })
ci(npreg_fit, contrast = riskRatio)


ci(glm_fit_uni2, contrast = riskRatio)



#######################################################################
#######################################################################
################################## SL Outut MV Model
################################## SL Outut MV Model MV Treatment FX - QQuinn
######## Stratified - Gaussian w/o set_Seed = n_SL = 5

dim(ASDKLTabab2Adf); names(ASDKLTabab2Adf)

class(ASDKLTabab2Adf$QQuinCI);      unique(ASDKLTabab2Adf$QQuinCI)
class(ASDKLTabab2Adf$fQQuinnCI);    unique(ASDKLTabab2Adf$fQQuinnCI)

ASDKLTabab2Adf$fQQuinnCIExp <- ASDKLTabab2Adf$fQQuinnCI - 1
class(ASDKLTabab2Adf$fQQuinnCIExp); unique(ASDKLTabab2Adf$fQQuinnCIExp); table(ASDKLTabab2Adf$fQQuinnCIExp)

W <- data.frame(
  W1  = ASDKLTabab2Adf$cigmon,
  W2  = ASDKLTabab2Adf$abodalc,
  W4  = log(ASDKLTabab2Adf$mrjmon),
  W5  = log(ASDKLTabab2Adf$anlyr),
  W6  = log(ASDKLTabab2Adf$cocyr),
  W7  = ASDKLTabab2Adf$White,
  W8  = log(ASDKLTabab2Adf$Black),
  W9  = log(ASDKLTabab2Adf$AsPI),
  W10  = log(ASDKLTabab2Adf$AIAN),
  W11 = log(ASDKLTabab2Adf$NHWhiteTPPot),
  W12 = log(ASDKLTabab2Adf$NHBlackTPPot),
  W13 = log(ASDKLTabab2Adf$AsianTPPot),
  W14 = log(ASDKLTabab2Adf$HispanicTPPot),
  W15 = log(ASDKLTabab2Adf$AIANTPPot),
  W16 = log(ASDKLTabab2Adf$MHY)
)

### Gaussian
A <- ASDKLTabab2Adf$fQQuinnCIExp
Y <- log(ASDKLTabab2Adf$ASDRt)

SL_fitGSn_multiA <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                    SL_g  = c("SL.glm", "SL.mean"),
                    SL_Q  = c("SL.glm", "SL.mean"),
                    SL_gr = c("SL.glm", "SL.earth"),
                    SL_Qr = c("SL.glm", "SL.earth"),
                    stratify = TRUE, n_SL = 5, a_0 = c(0,1,2,3,4))
SL_fitGSn_multiA  
ci(SL_fitGSn_multiA)
ci(SL_fitGSn_multiA, contrast=riskRatio)
ci(SL_fitGSn_multiA, contrast=c(-1, 1, 0))

exp(3.270); exp(3.759904); exp(3.681791); exp(3.937926); exp(4.178470)
exp(3.742553); exp(4.215); exp(3.581); exp(3.859); exp(3.504); exp(3.859)
exp(3.826); exp(4.050); exp(3.678); exp( 4.679)


### Gaussian w Raw Data
A <- ASDKLTabab2Adf$fQQuinnCIExp
Y <- ASDKLTabab2Adf$ASDRt

SL_fitGSn_multiA <- drtmle(W = W, A = A, Y = Y, family = gaussian(),
                           SL_g  = c("SL.glm", "SL.mean"),
                           SL_Q  = c("SL.glm", "SL.mean"),
                           SL_gr = c("SL.glm", "SL.earth"),
                           SL_Qr = c("SL.glm", "SL.earth"),
                           stratify = TRUE, n_SL = 5, a_0 = c(0,1,2,3,4))
SL_fitGSn_multiA  
ci(SL_fitGSn_multiA)
ci(SL_fitGSn_multiA, contrast=riskRatio)
ci(SL_fitGSn_multiA, contrast=c(-1, 1, 0,0,0))



### Binomial
A <- ASDKLTabab2Adf$fQQuinnCIExp
Y <- ASDKLTabab2Adf$ASDRtReSc

SL_fitGSn_multiBin <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                    SL_g  = c("SL.glm", "SL.mean"),
                    SL_Q  = c("SL.glm", "SL.mean"),
                    SL_gr = c("SL.glm", "SL.earth"),
                    SL_Qr = c("SL.glm", "SL.earth"),
                    stratify = TRUE, n_SL = 5, a_0 = c(0,1,2,3,4))
SL_fitGSn_multiBin  
ci(SL_fitGSn_multiBin)
# ci(SL_fitGSn_multiBin, contrast=riskRatio)

ASDRange_Inv(c(0.270, 0.228, 0.312))
ASDRange_Inv(c(0.270, 0.228, 0.312))
ASDRange_Inv(c(0.270, 0.228, 0.312))
ASDRange_Inv(c(0.270, 0.228, 0.312))
ASDRange_Inv(c(0.270, 0.228, 0.312))


### Binomial n_SL=1
SL_fitGSn_multiBin1 <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                             SL_g  = c("SL.glm", "SL.mean"),
                             SL_Q  = c("SL.glm", "SL.mean"),
                             SL_gr = c("SL.glm", "SL.earth"),
                             SL_Qr = c("SL.glm", "SL.earth"),
                             stratify = TRUE, a_0 = c(0,1,2,3,4))
SL_fitGSn_multiBin1  
ci(SL_fitGSn_multiBin1)



SL_fitGSn_multiBin <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                             SL_g  = c("SL.glm", "SL.mean", "SL.npreg"),
                             SL_Q  = c("SL.glm", "SL.mean", "SL.npreg"),
                             SL_gr = c("SL.glm", "SL.earth"),
                             SL_Qr = c("SL.glm", "SL.earth"),
                             stratify = TRUE, n_SL = 5, a_0 = c(0,1,2,3,4))
SL_fitGSn_multiBin  
ci(SL_fitGSn_multiBin)


SL_fitGSn_multiBin <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                             SL_g  = c("SL.npreg"),
                             SL_Q  = c("SL.npreg"),
                             SL_gr = c("SL.npreg"),
                             SL_Qr = c("SL.npreg"),
                             stratify = TRUE, a_0 = c(0,1,2,3,4))
SL_fitGSn_multiBin  
ci(SL_fitGSn_multiBin)



################################# Re-Doing Multi-level Comparisons
install.packages(c("future", "future.batchtools", "parallel"))
install.packages(c("snow"))
library(future)
library(snow)
library(future.batchtools)
library(parallel)
library(SuperLearner)

cl <- makeCluster(4, type="SOCK")
plan(cluster, workers = cl)
clusterEvalQ(cl, library("SuperLearner"))
pcv_sl_fit <- drtmle(W=W, A=A, Y=Y, family = binomial(),
                     SL_g  = c("SL.glm", "SL.glm.interaction", "SL.earth"),
                     SL_Q  = c("SL.glm", "SL.glm.interaction", "SL.earth"),
                     SL_gr = c("SL.glm", "SL.earth", "SL.mean"),
                     SL_Qr = c("SL.glm", "SL.earth", "SL.mean"),
                     stratify=TRUE, a_0 = c(0,1,2,3,4),
                     cvFolds=2, parallel=TRUE, n_SL=10)
pcv_sl_fit
ci(pcv_sl_fit)

?future::batchtools::cvFolds


glm_fit_multiA <- drtmle(W=W, A=A, Y=Y, stratify = TRUE,
                         glm_g  = "W1+W4+W2+W5+W6+W7+W8+W9+W10+W11+W13+W15+W12+W14+W16",
                         glm_Q  = "W1+W4+W2+W5+W6+W7+W8+W9+W10+W11+W13+W15+W12+W14+W16",
                         glm_gr = "Qn",
                         glm_Qr = "gn",
                         family = binomial(), a_0 = c(0,1,2,3,4), parallel=TRUE)
glm_fit_multiA
ci(glm_fit_multiA)

# > ci(glm_fit_multiA)
# $drtmle
# est           cil          ciu
# 0 0.604 -24521707.113 24521708.320
# 1 0.669         0.642        0.695
# 2 0.654         0.626        0.682
# 3 0.710         0.695        0.725
# 4 0.828         0.809        0.847




glm_fit_multiAA <- drtmle(W=W, A=A, Y=Y, stratify = TRUE,
                         glm_g  = "W1*W4*W2*W11*W13*W15+W12+W14+W16+W5+W6+W7+W8+W9+W10",
                         glm_Q  = "W1*W4*W2*W11*W13*W15+W12+W14+W16+W5+W6+W7+W8+W9+W10",
                         glm_gr = "Qn",
                         glm_Qr = "gn",
                         family = binomial(), a_0 = c(0,1,2,3,4), parallel=TRUE)
glm_fit_multiAA
ci(glm_fit_multiAA)


# Interactive x 3
Mixed_fitBSn_IR31 <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                            SL_g  = list(DeltaA = "SL.glm", A = "SL.npreg",
                                         DeltaY = c("SL.glm", "SL.mean", "SL.earth")),
                            glm_Q = "W1+W4+W2+W5+W6+W7+W8+W9+W10+W11*W12*W13*W15+W14+W16",
                            glm_gr = "Qn",
                            glm_Qr = "gn",
                            stratify = TRUE)

### No. 2
pcv_sl_fit_2 <- drtmle(W=W, A=A, Y=Y, family = binomial(),
                     SL_g  = list(DeltaA = "SL.glm", A = "SL.npreg",
                                  DeltaY = c("SL.glm", "SL.mean", "SL.earth")),
                     glm_Q  = "W1*W4*W2*W11*W13*W15+W12+W14+W16+W5+W6+W7+W8+W9+W10",
                     SL_gr = c("SL.glm", "SL.earth", "SL.mean"),
                     SL_Qr = c("SL.glm", "SL.earth", "SL.mean"),
                     stratify=TRUE, a_0 = c(0,1,2,3,4),
                     cvFolds=2, parallel=TRUE, n_SL=10)
pcv_sl_fit_2
ci(pcv_sl_fit_2)


### No. 3
pcv_sl_fit_3 <- drtmle(W=W, A=A, Y=Y, family = binomial(),
                       SL_g  = list(DeltaA = "SL.glm", A = "SL.npreg",
                                    DeltaY = c("SL.glm", "SL.mean", "SL.earth")),
                       glm_Q  = "W1*W4*W2*W11*W13*W15+W12+W14+W16+W5+W6+W7+W8+W9+W10",
                       glm_gr = "Qn",
                       glm_Qr = "gn",
                       stratify=TRUE, a_0 = c(0,1,2,3,4),
                       cvFolds=2, parallel=TRUE, n_SL=10)
pcv_sl_fit_3
ci(pcv_sl_fit_3)




SL_fitGSn_multiCBin <- drtmle(W = W, A = A, Y = Y, family = binomial(),
                             SL_g  = c("SL.npreg"),
                             SL_Q  = c("SL.npreg"),
                             SL_gr = c("SL.npreg"),
                             SL_Qr = c("SL.npreg"),
                             stratify = TRUE, a_0 = c(0,1,2,3,4))
SL_fitGSn_multiCBin  
ci(SL_fitGSn_multiCBin)



npreg_iptw_multiA <- adaptive_iptw(W = W, A = A, Y = Y, stratify = FALSE,
                                   SL_g = "SL.npreg", SL_Qr = "SL.npreg",
                                   family = binomial(), a_0 = c(0, 1, 2, 3, 4), n_SL = 5)
npreg_iptw_multiA



## Level 1 v 0
riskRatio_1v0 <- list(f = function(eff){ log(eff) },
                      f_inv = function(eff){ exp(eff) },
                      h = function(est){ est[2]/est[1] },
                      fh_grad =  function(est){ c(1/est[2], -1/est[1], 0) })
ci(glm_fit_multiA, contrast = riskRatio_1v0)

## Level 2 v 0
riskRatio_2v0 <- list(f = function(eff){ log(eff) },
                      f_inv = function(eff){ exp(eff) },
                      h = function(est){ est[3]/est[1] },
                      fh_grad =  function(est){ c(0, -1/est[1], 1/est[3]) })
ci(glm_fit_multiA, contrast = riskRatio_2v0)

## Level 3 v 0
riskRatio_4v0 <- list(f = function(eff){ log(eff) },
                      f_inv = function(eff){ exp(eff) },
                      h = function(est){ est[4]/est[1] },
                      fh_grad =  function(est){ c(0, -1/est[1], 1/est[4]) })
ci(glm_fit_multiA, contrast = riskRatio_3v0)

## Level 4 v 0
riskRatio_4v0 <- list(f = function(eff){ log(eff) },
                      f_inv = function(eff){ exp(eff) },
                      h = function(est){ est[5]/est[1] },
                      fh_grad =  function(est){ c(0, -1/est[1], 1/est[5]) })
ci(glm_fit_multiA, contrast = riskRatio_4v0)


## Level 5 v 1
riskRatio_5v1 <- list(f = function(eff){ log(eff) },
                      f_inv = function(eff){ exp(eff) },
                      h = function(est){ est[5]/est[1] },
                      fh_grad =  function(est){ c(0, -1/est[1], 1/est[5],0,0)})
ci(SL_fitGSn_multiBin, contrast = riskRatio_5v1)


## Level 5 v 2
riskRatio_5v2 <- list(f = function(eff){ log(eff) },
                      f_inv = function(eff){ exp(eff) },
                      h = function(est){ est[5]/est[2] },
                      fh_grad =  function(est){ c(0, -1/est[2], 1/est[5],0,0)})
ci(SL_fitGSn_multiBin, contrast = riskRatio_5v2)

## Level 4 v 2
riskRatio_4v2 <- list(f = function(eff){ log(eff) },
                      f_inv = function(eff){ exp(eff) },
                      h = function(est){ est[4]/est[2] },
                      fh_grad =  function(est){ c(0, -1/est[2], 1/est[4],0,0)})
ci(SL_fitGSn_multiBin, contrast = riskRatio_4v2)

## Level 4 v 5
riskRatio_4v5 <- list(f = function(eff){ log(eff) },
                      f_inv = function(eff){ exp(eff) },
                      h = function(est){ est[5]/est[4] },
                      fh_grad =  function(est){ c(0, -1/est[5], 1/est[4],0,0)})
ci(SL_fitGSn_multiBin, contrast = riskRatio_4v5)

## Level 3 v 4
riskRatio_3v4 <- list(f = function(eff){ log(eff) },
                      f_inv = function(eff){ exp(eff) },
                      h = function(est){ est[3]/est[4] },
                      fh_grad =  function(est){ c(0, -1/est[3], 1/est[4],0,0)})
ci(SL_fitGSn_multiBin, contrast = riskRatio_3v4)

## Level 3 v 5
riskRatio_3v5 <- list(f = function(eff){ log(eff) },
                      f_inv = function(eff){ exp(eff) },
                      h = function(est){ est[3]/est[4] },
                      fh_grad =  function(est){ c(0, -1/est[3], 1/est[5],0,0)})
ci(SL_fitGSn_multiBin, contrast = riskRatio_3v5)








####################################################################################################
####################################################################################################
####################################################################################################
####################################################################################################

install.packages('aod')
library(aod)

?wald.test

data(orob2)
fm <- quasibin(cbind(y, n - y) ~ seed * root, data = orob2)
summary(fm)
fm
str(fm, max.level = 2)
# Wald test for the effect of root
wald.test(b = coef(fm), Sigma = vcov(fm), Terms = 3:4)


####################################################################################################
####################################################################################################
################# z_test

z_test1 <- function(x, mu, s, n, tailed){
  z <- (x-mu) / (s/sqrt(n))
  if(tailed == 1) return(cat('Z-Score - ', z, '\np-value - ', pnorm(-abs(z))))
  if(tailed == 2) return(cat('Z-Score - ', z, '\np-value - ', 2 * pnorm(-abs(z))))
  if(tailed != 1 | tailed !=2) return('can only be one or two tailed')
}
z_test1(6,5,2,20,1)

z_test <- function(z, tailed){
  if(tailed == 1) return(cat('p-value - ', pnorm(-abs(z))))
  if(tailed == 2) return(cat('p-value - ', 2 * pnorm(-abs(z))))
  if(tailed != 1 | tailed !=2) return('can only be one or two tailed')
}

z_test(1.96, 2)


############################################################################################################
############################################################################################################

install.packages("EValue")
library(EValue)

exp(1.481)  # 4.397341

evalues.RR(1.481, 1.481, 1.481)                    # 2.325015 2.325015 2.325015 

exp(2.085); exp(1.871); exp(2.323)

evalues.RR(2.085, 1.871, 2.323)                    # 3.589069 3.147574  

evalues.RR(4.397341, 4.397341, 4.397341)           #  8.262476 8.262476

evalues.RR(8.044, 6.495, 10.206)                   # 15.57141 12.46911     NA

evalues.OR(8.044, 6.495, 10.206, rare=TRUE)        # 15.57141 12.46911     NA

evalues.RR(1.265, 1.179, 1.358)                    #  1.843986 1.638392    NA


## Quintile Comparisons
evalues.RR(2.085, 1.871, 2.323)                    #  3.589069 3.147574    4.076091

# evalues.RR(2.323, 2.323, 2.323)                    #  1.843986 1.638392    NA

evalues.RR(1.265, 1.179, 1.358)                    #  1.843986 1.638392    2.055255

# evalues.RR(1.358, 1.358, 1.358)                    #  1.843986 1.638392    NA


## SL Raw Data Gaussian
evalues.RR(2.00408, 1.801802, 2.227171)            #  3.42262 3.003754   3.880386

# evalues.RR(2.227171, 2.227171, 2.227171)           #  3.880386 3.880386    3.880386

evalues.RR(1.265, 1.179, 1.358)                    #  1.843986 1.638392    2.055255

# evalues.RR(1.358, 1.358, 1.358)                    #  1.843986 1.638392    NA


############################################################################################################
############################################################################################################
#### Checking drtmle ratios

0.862/0.6782
0.8403 / 0.6785
0.795/0.682
0.805/0.68
0.747/0.692

134.654/67.217
1/0.894
1/0.842
1/0.95

1/0.794
1/0.771
1/0.817

1/0.837
1/0.812
1/0.863

exp(4.178)
exp(3.938)

0.975/0.710

76/68 # 1.117647

Inv_Fn <- function(x) (1/x)

Inv_Fn(c(0.81, 0.036, 0.125))
ASDRange_Inv(c(0.081, 0.036, 0.125))  # 30.2351 13.7156 46.3875

855/678 # 1.261062

785/682  # 1.151026;  0.753 / 0.663;  0.818 / 0.701

Inv_Fn(c(0.868, 0.83, 0.908)) # 1.152074 1.204819 1.101322
Inv_Fn(c(0.921, 0.872, 0.973)) # 1.152074 1.204819 1.101322

745/686; 706/667; 784/705

Inv_Fn(c(0.861, 0.809, 0.917)) # .161440 1.236094 1.090513

79/68; 747/660; 833/700
      
Inv_Fn(c(0.755, 0.731, 0.779)) # .161440 1.236094 1.090513

933/704; 922/684; 944/724    
      


# http://freerangestats.info/blog/2017/04/09/propensity-v-regression

############################################################################################################
############################################################################################################
#### ipwtm Operations

require(survival)
temp <- ipwtm(
  exposure = haartind,
  family = "survival",
  numerator = ~ sex + age,
  denominator = ~ sex + age + cd4.sqrt,
  id = patient,
  tstart = tstart,
  timevar = fuptime,
  trunc = 0.01,
  type = "first",
  data = haartdat)

head(haartdat); glimpse(haartdat); summary(haartdat)

ipwplot(temp$ipw.weights)
ipwplot(temp$weights.trunc)


#### Examples
#Simulate data with continuous confounder and outcome, binomial exposure.
#Marginal causal effect of exposure on outcome: 10.
n <- 1000
simdat <- data.frame(l = rnorm(n, 10, 5))
a.lin <- simdat$l - 10
pa <- exp(a.lin)/(1 + exp(a.lin))
simdat$a <- rbinom(n, 1, prob = pa)
simdat$y <- 10*simdat$a + 0.5*simdat$l + rnorm(n, -10, 5)
simdat[1:5,]
#Estimate ipw weights.
temp <- ipwpoint(
exposure = a,
family = "binomial",
link = "logit",
numerator = ~ 1,
denominator = ~ l,
data = simdat)
dim(simdat); names(simdat); head(simdat); summary(simdat)
glimpse(simdat)
summary(temp$ipw.weights)
#Plot inverse probability weights
graphics.off()
ipwplot(weights = temp$ipw.weights, logscale = FALSE,
main = "Stabilized weights", xlim = c(0, 8))
#Examine numerator and denominator models.
summary(temp$num.mod)
summary(temp$den.mod)
#Paste inverse probability weights
simdat$sw <- temp$ipw.weights


#Marginal structural model for the causal effect of a on y
#corrected for confounding by l using inverse probability weighting
#with robust standard error from the survey package.
require("survey")
msm <- (svyglm(y ~ a, design = svydesign(~ 1, weights = ~ sw, data = simdat)))
coef(msm)
confint(msm)



############################################################################################################
############################################################################################################
#### ipwtm Operationally
############################################################################################################
############################################################################################################
#### ipwtm Operationally

temp <- ipwtm(exposure = mrjmon, family = "gaussian", link="log",
              numerator = ~ cigmon + abodalc + (anlyr) + (cocyr) +
                White + (Black) + (AIAN) + (MHY),
              denominator = ~ cigmon + abodalc + log(anlyr) + log(cocyr) +
                White + (Black) + log(AIAN) + log(MHY) +  log(mrjmon) +
                (NHWhiteTPPot) + (NHBlackTPPot) + (HispanicTPPot) + (AsianTPPot) +
                (AIANTPPot) + (NHPITPPot),
              tstart = tstart, timevar = tend,
              id = StateN, corstr=ar1, trunc=0.02, type="all",
              data = ASDKLTabab2AdfaRrdf)

summary(temp$ipw.weights)
summary(temp$weights.trunc)
ipwplot(temp$ipw.weights)
ipwplot(temp$weights.trunc)
ipwplot(temp$weights.trunc, add=TRUE)
plot(temp$ipw.weights, size=2, pch=2)
plot(temp$weights.trunc, add=TRUE, col='red', type="l", lty=2)
plot(temp$ipw.weights)

ASDKLTabab2AdfaRrdf$TrW02 <- temp$weights.trunc
ASDKLTabab2AdfaRrdf$sw3   <- temp$ipw.weights
sum(temp$weights.trunc)   #  158.7344
sum(temp$ipw.weights)     #  7410.108


# write_csv(ASDKLTabab2AdfaRrdf, "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2AdfaRrdf.csv")

################# Additve Models
# Truncated Weights
summary(svyglm(log(ASDRt) ~ cigmon + abodalc + log(mrjmon) + log(anlyr) + log(cocyr) + 
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
                 log(AIANTCan) + log(NHPITCan), family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ TrW02, data= ASDKLTabab2AdfaRrdf)))
      summary(svyglm(log(ASDRt) ~  abodalc + log(anlyr) + 
                  White + log(Black) + log(AIAN) +
                  log(NHBlackTCan) +  log(AsianTCan), family = stats::gaussian,
                design = svydesign (~StateN, weights = ~ TrW02, data= ASDKLTabab2AdfaRrdf)))


############## Native Weights
# Simple Models
((  summary(svyglm(log(ASDRt) ~ log(mrjmon),   #  P = 0.45
               family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))  ))

((  summary(svyglm(log(ASDRt) ~ (mrjmon),     # P = 0.186
               family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))  ))
      
#### Main Additive Models     
summary(svyglm(log(ASDRt) ~ cigmon + abodalc + log(mrjmon) + log(anlyr) + log(cocyr) + 
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
                 log(AIANTCan) + log(NHPITCan), family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))
      summary(svyglm(log(ASDRt) ~  abodalc +  log(anlyr) + 
                  White + log(Black) + log(AIAN) + 
                  log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
                  log(NHPITCan), family = stats::gaussian,
                design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))

################# Interactive models
# Native Weights
summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) + log(anlyr) + log(cocyr) + 
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
                 log(AIANTCan) + log(NHPITCan), family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))
        summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) + log(anlyr) +  
                  White + log(Black) + log(AIAN), family = stats::gaussian,
                design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))

# Trunc Weights
summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) + log(anlyr) + log(cocyr) + 
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
                 log(AIANTCan) + log(NHPITCan), family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ TrW02, data= ASDKLTabab2AdfaRrdf)))
       summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) +
                  White + log(Black) + log(AIAN) +
                   log(NHBlackTCan) , family = stats::gaussian,
                design = svydesign (~StateN, weights = ~ TrW02, data= ASDKLTabab2AdfaRrdf)))

# Native Weights
# 4-Way IR
summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) * log(anlyr) + log(cocyr) + 
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
                 log(AIANTCan) + log(NHPITCan), family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))

# Trunc Weights
# 4-Way IR
summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) * log(anlyr) + log(cocyr) + 
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
                 log(AIANTCan) + log(NHPITCan), family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ TrW02, data= ASDKLTabab2AdfaRrdf)))
     summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) * log(anlyr) + 
                  log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
                  log(AIANTCan) + log(NHPITCan), family = stats::gaussian,
                design = svydesign (~StateN, weights = ~ TrW02, data= ASDKLTabab2AdfaRrdf)))
     
# Native Weights
# Race IR's
summary(svyglm(log(ASDRt) ~ cigmon + abodalc + log(mrjmon) + log(anlyr) + log(cocyr) + 
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTCan) + log(NHBlackTCan) + log(HispanicTCan) + log(AsianTCan) +
                 log(AIANTCan) + log(NHPITCan), family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))

      
##################################################################################################
##################################################################################################
################### Now Going w Ethnicities_TPPot

#### Main Additive Models     
summary(svyglm(log(ASDRt) ~ cigmon + abodalc + log(mrjmon) + log(anlyr) + log(cocyr) + 
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                 log(AIANTPPot) + log(NHPITPPot), family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))
     summary(svyglm(log(ASDRt) ~  abodalc +  log(anlyr) + 
                  White + log(Black) + log(AIAN) + 
                  log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                   log(NHPITPPot), family = stats::gaussian,
                design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))


# Native Weights
# 4-Way IR
summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) * log(anlyr) + log(cocyr) + 
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                 log(AIANTPPot) + log(NHPITPPot), family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))
    summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) * log(anlyr) + 
                  White + log(Black) +  
                  log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + 
                   log(NHPITPPot), family = stats::gaussian,
                design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))

# Trunc Weights
# 4-Way IR
summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) * log(anlyr) + log(cocyr) + 
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) + log(AsianTPPot) +
                 log(AIANTPPot) + log(NHPITPPot), family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ TrW02, data= ASDKLTabab2AdfaRrdf)))
      summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) * log(anlyr) + 
                 log(NHWhiteTPPot) + log(NHBlackTPPot) + log(HispanicTPPot) +
                  log(AIANTPPot) + log(NHPITPPot), family = stats::gaussian,
                design = svydesign (~StateN, weights = ~ TrW02, data= ASDKLTabab2AdfaRrdf)))
      
      
################### Ethnicity IR's  
# Native Weights
# 4-Way IR
summary(svyglm(log(ASDRt) ~ cigmon + abodalc + log(mrjmon) + log(anlyr) + log(cocyr) + 
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTPPot) * log(NHBlackTPPot) * log(AsianTPPot) * log(AIANTPPot) +
                 log(HispanicTPPot) + log(NHPITPPot), family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))     
     summary(svyglm(log(ASDRt) ~ cigmon + abodalc + log(cocyr) + 
                  White + log(Black) + 
                  log(NHWhiteTPPot) * log(NHBlackTPPot) * log(AsianTPPot) * log(AIANTPPot) +
                  log(HispanicTPPot) -log(NHWhiteTPPot):log(AIANTPPot)-log(NHWhiteTPPot):log(NHBlackTPPot):log(AsianTPPot):log(AIANTPPot)  , family = stats::gaussian,
                design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))      

      
## Trunc Weights
# 4-Way IR
summary(svyglm(log(ASDRt) ~ cigmon + abodalc + log(mrjmon) + log(anlyr) + log(cocyr) + 
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHWhiteTPPot) * log(NHBlackTPPot) * log(AsianTPPot) * log(AIANTPPot) +
                 log(HispanicTPPot) + log(NHPITPPot), family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ TrW02, data= ASDKLTabab2AdfaRrdf)))      
      summary(svyglm(log(ASDRt) ~ cigmon + abodalc +  log(cocyr) + 
                  White + log(Black) +  
                  log(NHWhiteTPPot) * log(NHBlackTPPot) * log(AsianTPPot) * log(AIANTPPot) +
                  log(HispanicTPPot) + log(NHPITPPot)-log(NHBlackTPPot):log(AsianTPPot)-log(NHWhiteTPPot):log(NHBlackTPPot):log(AsianTPPot):log(AIANTPPot)-log(AsianTPPot):log(AIANTPPot), family = stats::gaussian,
                design = svydesign (~StateN, weights = ~ TrW02, data= ASDKLTabab2AdfaRrdf)))
      
      
      
      
 ################### Ethnicity IR's  &  Drug IR's
# Native Weights
# Full IR * IR
summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) + log(anlyr) +
                 log(NHWhiteTPPot) * log(AsianTPPot) * log(AIANTPPot) + log(cocyr) + 
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHBlackTPPot) + log(HispanicTPPot) + log(NHPITPPot), 
               family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf)))          
     summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) + log(anlyr) +
                  log(NHWhiteTPPot) * log(AsianTPPot) * log(AIANTPPot) +
                  White + log(Black) + log(AIAN) +  
                  log(HispanicTPPot)-log(NHWhiteTPPot):log(AsianTPPot)-log(NHWhiteTPPot)-log(HispanicTPPot)-log(NHWhiteTPPot):log(AsianTPPot):log(AIANTPPot)-log(AsianTPPot):log(AIANTPPot)-log(AsianTPPot)-log(AIANTPPot)-log(NHWhiteTPPot):log(AIANTPPot), 
                family = stats::gaussian,
                design = svydesign (~StateN, weights = ~ sw3, data= ASDKLTabab2AdfaRrdf))) 


# Trunc Weights
# Full IR * IR
summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) + log(anlyr) +
                 log(NHWhiteTPPot) * log(AsianTPPot) * log(AIANTPPot) + log(cocyr) + 
                 White + log(Black) + log(AIAN) + log(MHY) + 
                 log(NHBlackTPPot) + log(HispanicTPPot) + log(NHPITPPot), 
               family = stats::gaussian,
               design = svydesign (~StateN, weights = ~ TrW02, data= ASDKLTabab2AdfaRrdf)))    
        summary(svyglm(log(ASDRt) ~ cigmon * abodalc * log(mrjmon) + log(anlyr) +
                  log(NHWhiteTPPot) * log(AsianTPPot) * log(AIANTPPot) + 
                  White + log(Black) + log(AIAN) + 
                   log(NHPITPPot)-log(NHWhiteTPPot):log(AIANTPPot)-log(NHWhiteTPPot):log(AsianTPPot)-log(NHPITPPot)-log(NHWhiteTPPot):log(AsianTPPot):log(AIANTPPot)-log(NHWhiteTPPot)-log(AIANTPPot)-log(AsianTPPot):log(AIANTPPot)-log(AsianTPPot), 
                family = stats::gaussian,
                design = svydesign (~StateN, weights = ~ TrW02, data= ASDKLTabab2AdfaRrdf)))    



######################################################################################################################################################
######################################################################################################################################################        
######################################################################################################################################################
######################################################################################################################################################
############## eValues

# SL:
evalues.RR(1.32, 1.28, 1.36)            #  1.969923 1.878665  SL*glm regression  3 + 3 Interactions  MSM
evalues.RR(1.37, 1.34, 1.40)            #  2.081969 2.014981  SL glm regression
        
# svyglm
evalues.OLS(78.88, 64.38, 93.38)        #  3.736662 1.0000000
evalues.OLS(1467.06, 997.23, 1936.89)   #  3.398230 1.0000000       
evalues.OLS(913.3, 597.54, 12229.06)    #   1.344677 1.000000           
evalues.OLS(5.42, 2.42, 8.42)           #   2.992452 1.364978  This one is Good!!    NHWhiteCaucAmCann     

        
# plm
evalues.OLS(1418, 1080.57, 1755.43)     #   3.590398 1.0000000  
evalues.OLS(0.68, 0.27, 1.09)           #   2.925354 1.526905  Hispanic Cannabis Use 
# plm Un-Weight
evalues.OLS(22.01, 10.17, 33.85)        #   3.014706 1.307548  Cig:Cannabis
evalues.OLS(4.291, 7.21, 1.37)          #   34.07594 1.000000000 
        

# spreml
evalues.OLS(19.44, 9.11, 29.77)         #   3.024253 1.281776  Cannabis : Alcohol

  
# lme iptw
evalues.OLS(6.8, 5.86, 7.74)            #   3.874702 1.0000000      
evalues.OLS(2.22, 0.83, 3.61)           #   2.895631 1.596509   NHWhiteCaucAmCann     

# legal
evalues.OLS(80.16, 25.11, 135.22)       #   2.822514 1.767438   All legal status         
evalues.OLS(0.301, 0.0123, 0.0479)      #   608.3172 384.9609   Legal v Illegal       

        
# Time - Rise        
evalues.OLS(2.52, 1.56, 3.48)           #   3.275510 1.000000      
# Cannabis Relationship
evalues.OLS(24.93, 4.06, 45.8)          #   2.666710 2.151637  ASD ~ Cannabis Relationship       
# Year:fASD IR
evalues.OLS(10.72, 8.39, 13.05)         #   3.644017 1.0000000     


############################################################################################################
############################################################################################################
#### ipwtm Operationally - Re-Re-Do
############################################################################################################
############################################################################################################
#### ipwtm Operationally - Re-Re-Do

dim(ASDKLTabab2AdfaRrdf); names(ASDKLTabab2AdfaRrdf)
ASDKLTabab2AdfaRrdf[1:12, 1:8]

temp <- ipwtm(exposure = mrjmon, family = "gaussian", link="log",
              numerator = ~ cigmon + abodalc + (anlyr) + (cocyr) +
                White + (Black) + (AIAN) + (MHY),
              denominator = ~ cigmon + abodalc + log(anlyr) + log(cocyr) +
                White + (Black) + log(AIAN) + log(MHY) +  log(mrjmon) +
                (NHWhiteTPPot) + (NHBlackTPPot) + (HispanicTPPot) + (AsianTPPot) +
                (AIANTPPot) + (NHPITPPot),
              tstart = tstart, timevar = tend,
              id = StateN, corstr=ar1, trunc=0.02, type="all",
              data = ASDKLTabab2AdfaRrdf)

par(mfrow=c(2,1))

summary(temp$ipw.weights)
summary(temp$weights.trunc)
ipwplot(temp$ipw.weights)
ipwplot(temp$weights.trunc)
ipwplot(temp$weights.trunc, add=TRUE)
plot(temp$ipw.weights, size=2, pch=2)
plot(temp$weights.trunc, add=TRUE, col='red', type="l", lty=2)
plot(temp$ipw.weights)

ASDKLTabab2AdfaRrdf$TrW02 <- temp$weights.trunc
ASDKLTabab2AdfaRrdf$sw3   <- temp$ipw.weights
sum(temp$weights.trunc)   #  158.7344
sum(temp$ipw.weights)     #  7410.108


# write_csv(ASDKLTabab2AdfaRrdf, "D:/1ASReece/Research/2020 Res/ASD/R Codes/Data/csv/ASDKLTabab2AdfaRrdf.csv")









